;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module ai
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _fighter_attack
	.globl _entity_move
	.globl _cpct_memset
	.globl _num_ai_components
	.globl _ai_components
	.globl _init_ai
	.globl _basic_ai_create
	.globl _basic_ai_take_turn
	.globl _move_to
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_ai_components::
	.ds 384
_num_ai_components::
	.ds 1
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/components/ai.c:35: void init_ai() {
;	---------------------------------
; Function init_ai
; ---------------------------------
_init_ai::
;src/components/ai.c:36: cpct_memset (ai_components, 0x0, sizeof (ai_components));
	ld	hl, #0x0180
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	hl, #_ai_components
	push	hl
	call	_cpct_memset
;src/components/ai.c:37: num_ai_components = 0;
	ld	hl,#_num_ai_components + 0
	ld	(hl), #0x00
	ret
;src/components/ai.c:41: struct TAI *basic_ai_create ()
;	---------------------------------
; Function basic_ai_create
; ---------------------------------
_basic_ai_create::
;src/components/ai.c:43: struct TAI *ai = NULL;
	ld	bc, #0x0000
;src/components/ai.c:45: if (num_ai_components < MAX_AI_COMPONENTS)
	ld	iy, #_num_ai_components
	ld	a, 0 (iy)
	sub	a, #0x60
	jr	NC,00102$
;src/components/ai.c:52: ai = &ai_components[num_ai_components++];
	ld	bc, #_ai_components+0
	ld	e, 0 (iy)
	inc	0 (iy)
	ld	l, e
	ld	h, #0x00
	add	hl, hl
	add	hl, hl
	add	hl,bc
;src/components/ai.c:55: ai->take_turn = basic_ai_take_turn;
	ld	c,l
	ld	b,h
	inc	hl
	inc	hl
	ld	(hl), #<(_basic_ai_take_turn)
	inc	hl
	ld	(hl), #>(_basic_ai_take_turn)
00102$:
;src/components/ai.c:64: return ai;
	ld	l, c
	ld	h, b
	ret
;src/components/ai.c:91: void basic_ai_take_turn (struct TAI *ai)
;	---------------------------------
; Function basic_ai_take_turn
; ---------------------------------
_basic_ai_take_turn::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-8
	add	hl, sp
	ld	sp, hl
;src/components/ai.c:94: struct TEntity *ai_entity = ai->owner;
	ld	l,4 (ix)
	ld	h,5 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;src/components/ai.c:95: u16 distance = distance_sqr(player->x, player->y, ai_entity->x, ai_entity->y);
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-7 (ix), a
	ld	l, c
	ld	h, b
	inc	hl
	ld	e, (hl)
	ld	hl, (_player)
	ld	-4 (ix), l
	ld	-3 (ix), h
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-5 (ix), a
	ld	-8 (ix), a
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	inc	hl
	ld	a, (hl)
	ld	-6 (ix), a
	ld	l, a
	ld	a, e
	rla
	sbc	a, a
	ld	d, a
	ld	a, l
	rla
	sbc	a, a
	ld	h, a
	ld	a, e
	sub	a, l
	ld	e, a
	ld	a, d
	sbc	a, h
	ld	d, a
	push	bc
	push	de
	push	de
	call	__mulint
	pop	af
	pop	af
	ld	-1 (ix), h
	ld	-2 (ix), l
	pop	bc
	ld	l, -7 (ix)
	ld	a, -7 (ix)
	rla
	sbc	a, a
	ld	h, a
	ld	e, -8 (ix)
	ld	a, -8 (ix)
	rla
	sbc	a, a
	ld	d, a
	cp	a, a
	sbc	hl, de
	push	bc
	push	hl
	push	hl
	call	__mulint
	pop	af
	pop	af
	pop	bc
	ld	e,-2 (ix)
	ld	d,-1 (ix)
	add	hl, de
;src/components/ai.c:98: if (distance < MOB_ATKR2) {
	ld	a, l
	sub	a, #0x32
	ld	a, h
	sbc	a, #0x00
	jr	NC,00109$
;src/components/ai.c:100: if (distance >= 2)
	ld	a, l
	sub	a, #0x02
	ld	a, h
	sbc	a, #0x00
	jr	C,00104$
;src/components/ai.c:101: move_to (ai_entity, player->x, player->y);
	ld	h, -5 (ix)
	ld	l, -6 (ix)
	push	hl
	push	bc
	call	_move_to
	pop	af
	pop	af
	jr	00109$
00104$:
;src/components/ai.c:104: else if (player->fighter->hp > 0) {
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, e
	inc	hl
	inc	hl
	inc	hl
	ld	e, (hl)
	xor	a, a
	sub	a, e
	jp	PO, 00123$
	xor	a, #0x80
00123$:
	jp	P, 00109$
;src/components/ai.c:105: fighter_attack (ai_entity->fighter, player);
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	hl, (_player)
	push	hl
	push	bc
	call	_fighter_attack
	pop	af
	pop	af
00109$:
	ld	sp, ix
	pop	ix
	ret
;src/components/ai.c:111: bool move_to (struct TEntity *e, i8 x, i8 y)
;	---------------------------------
; Function move_to
; ---------------------------------
_move_to::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;src/components/ai.c:114: dx = dy = 0;
	ld	b, #0x00
	ld	-1 (ix), #0x00
;src/components/ai.c:116: if (e->x != x) {
	ld	e,4 (ix)
	ld	d,5 (ix)
	ld	l, e
	ld	h, d
	inc	hl
	ld	c, (hl)
	ld	a, 6 (ix)
	sub	a, c
	jr	Z,00102$
;src/components/ai.c:118: dx = sign (x - e->x);
	ld	a, 6 (ix)
	sub	a, c
;src/aux_math.h:26: return value < 0 ? -1 : 1;
	bit	7,a
	jr	Z,00109$
	ld	c, #0xff
	jr	00110$
00109$:
	ld	c, #0x01
00110$:
;src/components/ai.c:118: dx = sign (x - e->x);
	ld	-1 (ix), c
00102$:
;src/components/ai.c:120: if (e->y != y) {
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	ld	c, (hl)
	ld	a, 7 (ix)
	sub	a, c
	jr	Z,00104$
;src/components/ai.c:121: dy = sign (y - e->y);
	ld	a, 7 (ix)
	sub	a, c
;src/aux_math.h:26: return value < 0 ? -1 : 1;
	bit	7,a
	jr	Z,00111$
	ld	c, #0xff
	jr	00112$
00111$:
	ld	c, #0x01
00112$:
;src/components/ai.c:121: dy = sign (y - e->y);
	ld	b, c
00104$:
;src/components/ai.c:123: entity_move (e, dx, dy);
	push	bc
	push	bc
	inc	sp
	ld	a, -1 (ix)
	push	af
	inc	sp
	push	de
	call	_entity_move
	pop	af
	pop	af
	pop	bc
;src/components/ai.c:124: return (dx == 0 && dy == 0);
	ld	a, -1 (ix)
	or	a,a
	jr	NZ,00113$
	or	a,b
	jr	Z,00114$
00113$:
	ld	l, #0x00
	jr	00115$
00114$:
	ld	l, #0x01
00115$:
	inc	sp
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
