;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module fighter
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _rand_range
	.globl _log_msg_ext
	.globl _name
	.globl _check_level
	.globl _sprintf
	.globl _cpct_getRandom_mxor_u8
	.globl _cpct_memset
	.globl _fighters
	.globl _num_fighters
	.globl _bon_atkdef
	.globl _hit_probability
	.globl _mob_info
	.globl _init_fighters
	.globl _fighter_create
	.globl _fighter_attack
	.globl _fighter_take_damage
	.globl _kill_mob
	.globl _kill_player
	.globl _is_a_hit
	.globl _get_damage
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_num_fighters::
	.ds 1
_fighters::
	.ds 1344
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/components/fighter.c:61: void init_fighters()
;	---------------------------------
; Function init_fighters
; ---------------------------------
_init_fighters::
;src/components/fighter.c:63: cpct_memset (fighters, 0, sizeof (fighters));
	ld	hl, #0x0540
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	hl, #_fighters
	push	hl
	call	_cpct_memset
;src/components/fighter.c:64: num_fighters = 0;
	ld	hl,#_num_fighters + 0
	ld	(hl), #0x00
	ret
_mob_info:
	.db #0x08	;  8
	.dw #0x0019
	.db #0x0b	; 11
	.db #0x0c	; 12
	.db #0x0b	; 11
	.db #0x0b	; 11
	.db #0x02	; 2
	.db #0x06	; 6
	.db #0x07	;  7
	.dw #0x001e
	.db #0x09	; 9
	.db #0x0a	; 10
	.db #0x0d	; 13
	.db #0x0b	; 11
	.db #0x02	; 2
	.db #0x04	; 4
	.db #0x0a	;  10
	.dw #0x0019
	.db #0x0a	; 10
	.db #0x0a	; 10
	.db #0x0d	; 13
	.db #0x0c	; 12
	.db #0x02	; 2
	.db #0x04	; 4
	.db #0x14	;  20
	.dw #0x001e
	.db #0x0c	; 12
	.db #0x0a	; 10
	.db #0x0b	; 11
	.db #0x0b	; 11
	.db #0x02	; 2
	.db #0x06	; 6
	.db #0x19	;  25
	.dw #0x0032
	.db #0x0e	; 14
	.db #0x0c	; 12
	.db #0x09	; 9
	.db #0x09	; 9
	.db #0x04	; 4
	.db #0x08	; 8
_hit_probability:
	.db #0x80	; 128
	.db #0x83	; 131
	.db #0x86	; 134
	.db #0x8a	; 138
	.db #0x8d	; 141
	.db #0x91	; 145
	.db #0x94	; 148
	.db #0x98	; 152
	.db #0x9b	; 155
	.db #0x9f	; 159
	.db #0xa2	; 162
	.db #0xa6	; 166
	.db #0xa9	; 169
	.db #0xad	; 173
	.db #0xb0	; 176
	.db #0xb4	; 180
	.db #0xb7	; 183
	.db #0xbb	; 187
	.db #0xbe	; 190
	.db #0xc2	; 194
	.db #0xc5	; 197
	.db #0xc9	; 201
	.db #0xcc	; 204
	.db #0xd0	; 208
	.db #0xd3	; 211
	.db #0xd6	; 214
	.db #0xda	; 218
	.db #0xdd	; 221
	.db #0xe1	; 225
	.db #0xe4	; 228
	.db #0xe8	; 232
_bon_atkdef:
	.db #0xf9	; -7
	.db #0xfa	; -6
	.db #0xfa	; -6
	.db #0xfb	; -5
	.db #0xfc	; -4
	.db #0xfd	; -3
	.db #0xfd	; -3
	.db #0xfe	; -2
	.db #0xff	; -1
	.db #0x00	;  0
	.db #0x00	;  0
	.db #0x00	;  0
	.db #0x01	;  1
	.db #0x02	;  2
	.db #0x03	;  3
	.db #0x03	;  3
	.db #0x04	;  4
	.db #0x05	;  5
	.db #0x06	;  6
	.db #0x06	;  6
	.db #0x07	;  7
	.db #0x08	;  8
	.db #0x09	;  9
	.db #0x09	;  9
	.db #0x0a	;  10
	.db #0x0b	;  11
	.db #0x0c	;  12
	.db #0x0c	;  12
	.db #0x0d	;  13
	.db #0x0e	;  14
	.db #0x0f	;  15
;src/components/fighter.c:69: struct TFighter *fighter_create (
;	---------------------------------
; Function fighter_create
; ---------------------------------
_fighter_create::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/components/fighter.c:79: struct TFighter *fighter = NULL;
	ld	bc, #0x0000
;src/components/fighter.c:81: if (num_fighters < MAX_FIGHTER_COMPONENTS)
	ld	iy, #_num_fighters
	ld	a, 0 (iy)
	sub	a, #0x60
	jr	NC,00102$
;src/components/fighter.c:84: fighter = &fighters[num_fighters++];
	ld	bc, #_fighters+0
	ld	e, 0 (iy)
	inc	0 (iy)
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl,bc
	ld	c, l
	ld	b, h
;src/components/fighter.c:87: fighter->max_hp = fighter->hp = hp;
	ld	e, c
	ld	d, b
	inc	de
	inc	de
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	a, 4 (ix)
	ld	(hl), a
	ld	a, 4 (ix)
	ld	(de), a
;src/components/fighter.c:88: fighter->xp     = xp;
	ld	hl, #0x0008
	add	hl, bc
	ld	a, 5 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 6 (ix)
	ld	(hl), a
;src/components/fighter.c:89: fighter->strn   = strn;
	ld	hl, #0x0004
	add	hl, bc
	ld	a, 7 (ix)
	ld	(hl), a
;src/components/fighter.c:90: fighter->def    = def;
	ld	hl, #0x0005
	add	hl, bc
	ld	a, 8 (ix)
	ld	(hl), a
;src/components/fighter.c:91: fighter->ref    = ref;
	ld	hl, #0x0006
	add	hl, bc
	ld	a, 9 (ix)
	ld	(hl), a
;src/components/fighter.c:92: fighter->dex    = dex;
	ld	hl, #0x0007
	add	hl, bc
	ld	a, 10 (ix)
	ld	(hl), a
;src/components/fighter.c:95: fighter->dmg.min  = min_dmg;
	ld	hl, #0x000a
	add	hl, bc
	ld	a, 11 (ix)
	ld	(hl), a
;src/components/fighter.c:96: fighter->dmg.max  = max_dmg;
	ld	hl, #0x000b
	add	hl, bc
	ld	a, 12 (ix)
	ld	(hl), a
;src/components/fighter.c:99: fighter->death_fn = death_fn;
	ld	hl, #0x000c
	add	hl, bc
	ld	a, 13 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 14 (ix)
	ld	(hl), a
00102$:
;src/components/fighter.c:103: return fighter;
	ld	l, c
	ld	h, b
	pop	ix
	ret
;src/components/fighter.c:116: void fighter_attack (struct TFighter *fighter,
;	---------------------------------
; Function fighter_attack
; ---------------------------------
_fighter_attack::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/components/fighter.c:122: name(fighter->owner), name(target));
	ld	l,6 (ix)
	ld	h,7 (ix)
	push	hl
	call	_name
	pop	af
	ld	-1 (ix), h
	ld	-2 (ix), l
	ld	c,4 (ix)
	ld	b,5 (ix)
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	push	de
	call	_name
	pop	af
	ex	de,hl
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	push	de
	ld	hl, #___str_0
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
	pop	bc
;src/components/fighter.c:125: if (is_a_hit (fighter, target->fighter)) {
	ld	e,6 (ix)
	ld	d,7 (ix)
	ld	hl, #0x0007
	add	hl,de
	ex	(sp), hl
	pop	hl
	push	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	push	de
	push	bc
	call	_is_a_hit
	pop	af
	pop	af
	ld	e, l
	pop	bc
	bit	0, e
	jr	Z,00102$
;src/components/fighter.c:126: dmg = get_damage(fighter, target->fighter);
	pop	hl
	push	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	push	de
	push	bc
	call	_get_damage
	pop	af
	pop	af
	pop	bc
	ld	a, l
;src/components/fighter.c:127: fighter_take_damage (target->fighter, fighter->owner, dmg);
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	pop	hl
	push	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	af
	inc	sp
	push	de
	push	bc
	call	_fighter_take_damage
	pop	af
	pop	af
	inc	sp
	jr	00104$
00102$:
;src/components/fighter.c:130: log_msg_ext ("\477\11\10but fails misserably");
	ld	hl, #___str_1
	push	hl
	call	_log_msg_ext
	pop	af
00104$:
	ld	sp, ix
	pop	ix
	ret
___str_0:
	.ascii "?"
	.db 0x08
	.db 0x0b
	.ascii "%s?"
	.db 0x09
	.db 0x08
	.ascii " attacks ?"
	.db 0x08
	.db 0x09
	.ascii "%s"
	.db 0x00
___str_1:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "but fails misserably"
	.db 0x00
;src/components/fighter.c:137: void fighter_take_damage (struct TFighter *fighter,
;	---------------------------------
; Function fighter_take_damage
; ---------------------------------
_fighter_take_damage::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;src/components/fighter.c:144: fighter->hp -= dmg;
	ld	a, 4 (ix)
	ld	-6 (ix), a
	ld	a, 5 (ix)
	ld	-5 (ix), a
	pop	de
	push	de
	inc	de
	inc	de
	inc	de
	ld	a, (de)
	sub	a, 8 (ix)
	ld	c,a
	ld	(de), a
;src/components/fighter.c:147: name(fighter->owner), fighter->hp, fighter->max_hp);
	pop	hl
	push	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-4 (ix), a
	rla
	sbc	a, a
	ld	-3 (ix), a
	ld	-2 (ix), c
	ld	a, c
	rla
	sbc	a, a
	ld	-1 (ix), a
	pop	hl
	push	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	de
	push	bc
	call	_name
	pop	af
	ld	c, l
	ld	b, h
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	push	hl
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	push	bc
	ld	hl, #___str_2
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #10
	add	hl, sp
	ld	sp, hl
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
	pop	de
;src/components/fighter.c:147: name(fighter->owner), fighter->hp, fighter->max_hp);
	pop	hl
	push	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;src/components/fighter.c:151: if (fighter->owner == player)
	ld	iy, #_player
	ld	a, 0 (iy)
	sub	a, c
	jr	NZ,00132$
	ld	a, 1 (iy)
	sub	a, b
	jr	NZ,00132$
	ld	a,#0x01
	jr	00133$
00132$:
	xor	a,a
00133$:
	ld	c,a
	or	a, a
	jr	Z,00102$
;src/components/fighter.c:152: stats_changed = true;
	ld	hl,#_stats_changed + 0
	ld	(hl), #0x01
00102$:
;src/components/fighter.c:155: if (fighter->hp <= 0) {
	ld	a, (de)
	ld	b, a
	xor	a, a
	sub	a, b
	jp	PO, 00134$
	xor	a, #0x80
00134$:
	jp	M, 00110$
;src/components/fighter.c:158: if (fighter->owner != player && attacker == player) {
	ld	a, c
	or	a, a
	jr	NZ,00104$
	ld	a, 6 (ix)
	ld	iy, #_player
	sub	a, 0 (iy)
	jr	NZ,00104$
	ld	a, 7 (ix)
	sub	a, 1 (iy)
	jr	NZ,00104$
;src/components/fighter.c:159: player->fighter->xp += fighter->xp;
	ld	hl, (_player)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	hl, #0x0008
	add	hl,bc
	ld	c,l
	ld	b,h
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	pop	hl
	push	hl
	push	bc
	ld	bc, #0x0008
	add	hl, bc
	pop	bc
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	add	hl,de
	ex	de,hl
	ld	a, e
	ld	(bc), a
	inc	bc
	ld	a, d
	ld	(bc), a
;src/components/fighter.c:160: check_level();
	call	_check_level
;src/components/fighter.c:161: stats_changed = true;
	ld	hl,#_stats_changed + 0
	ld	(hl), #0x01
00104$:
;src/components/fighter.c:165: if (fighter->death_fn) {
	pop	hl
	push	hl
	ld	de, #0x000c
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	a, b
	or	a,c
	jr	Z,00110$
;src/components/fighter.c:166: fighter->death_fn (fighter->owner);
	pop	hl
	push	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	de
	ld	l, c
	ld	h, b
	call	___sdcc_call_hl
	pop	af
00110$:
	ld	sp, ix
	pop	ix
	ret
___str_2:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "%s HP: ?"
	.db 0x08
	.db 0x09
	.ascii "%d?"
	.db 0x09
	.db 0x08
	.ascii "/%d"
	.db 0x00
;src/components/fighter.c:174: void kill_mob (struct TEntity *mob) {
;	---------------------------------
; Function kill_mob
; ---------------------------------
_kill_mob::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/components/fighter.c:176: sprintf (msg, "\477\11\10%s \477\11\12is dead!", name(mob));
	ld	l,4 (ix)
	ld	h,5 (ix)
	push	hl
	call	_name
	ex	(sp),hl
	ld	hl, #___str_3
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/components/fighter.c:177: log_msg_ext (msg);
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
;src/components/fighter.c:179: mob->fighter  = NULL;
	ld	c,4 (ix)
	ld	b,5 (ix)
	ld	hl, #0x0007
	add	hl, bc
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;src/components/fighter.c:180: mob->ai       = NULL;
	ld	hl, #0x0009
	add	hl, bc
	xor	a, a
	ld	(hl), a
	inc	hl
	ld	(hl), a
;src/components/fighter.c:181: set_dead (mob);
;src/entity.h:124: e->flags |= E_DEAD;
	ld	hl, #0x0005
	add	hl, bc
	set	1, (hl)
	ld	a, (hl)
;src/components/fighter.c:181: set_dead (mob);
	pop	ix
	ret
___str_3:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "%s ?"
	.db 0x09
	.db 0x0a
	.ascii "is dead!"
	.db 0x00
;src/components/fighter.c:184: void kill_player(struct TEntity *e)
;	---------------------------------
; Function kill_player
; ---------------------------------
_kill_player::
;src/components/fighter.c:187: game_running = false;
	ld	hl,#_game_running + 0
	ld	(hl), #0x00
	ret
;src/components/fighter.c:194: bool is_a_hit(struct TFighter *attacker, struct TFighter *target)
;	---------------------------------
; Function is_a_hit
; ---------------------------------
_is_a_hit::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/components/fighter.c:196: u8 hit_idx = attacker->dex - target->ref;
	ld	l,4 (ix)
	ld	h,5 (ix)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	ld	l,6 (ix)
	ld	h,7 (ix)
	ld	de, #0x0006
	add	hl, de
	ld	b, (hl)
	ld	a, c
	sub	a, b
	ld	c, a
;src/components/fighter.c:198: u8 rnd_value = cpct_rand ();
	push	bc
	call	_cpct_getRandom_mxor_u8
	pop	bc
	ld	b, l
;src/components/fighter.c:201: hit_idx = hit_idx < 128 ? hit_idx : 0;
	ld	a, c
	sub	a, #0x80
	jr	C,00104$
	ld	c, #0x00
00104$:
;src/components/fighter.c:202: hit_chance = hit_probability[hit_idx];
	ld	de, #_hit_probability+0
	ld	l,c
	ld	h,#0x00
	add	hl, de
	ld	c, (hl)
;src/components/fighter.c:209: return (rnd_value < hit_chance);
	ld	a, b
	sub	a, c
	ld	a, #0x00
	rla
	ld	l, a
	pop	ix
	ret
;src/components/fighter.c:218: u8 get_damage(struct TFighter *attacker, struct TFighter *target)
;	---------------------------------
; Function get_damage
; ---------------------------------
_get_damage::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;src/components/fighter.c:220: i8 bon_atk = bon_atkdef[attacker->strn];
	ld	bc, #_bon_atkdef+0
	ld	e,4 (ix)
	ld	d,5 (ix)
	push	de
	pop	iy
	ld	l, 4 (iy)
	ld	h,#0x00
	add	hl, bc
	ld	a, (hl)
	ld	-6 (ix), a
;src/components/fighter.c:221: i8 bon_def = bon_atkdef[target->def];
	ld	l,6 (ix)
	ld	h,7 (ix)
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	l, (hl)
	ld	h,#0x00
	add	hl, bc
	ld	c, (hl)
;src/components/fighter.c:222: u8 weapon_damage = rand_range (attacker->dmg.min, attacker->dmg.max);
	push	de
	pop	iy
	ex	de,hl
	ld	de, #0x000b
	add	hl, de
	ld	d, (hl)
	ld	b, 10 (iy)
	push	bc
	ld	e, b
	push	de
	call	_rand_range
	pop	af
	pop	bc
;src/components/fighter.c:223: u8 dmg = weapon_damage + bon_atk - bon_def;
	ld	a, l
	add	a, -6 (ix)
	sub	a, c
;src/components/fighter.c:224: dmg = (dmg < 128) ? dmg : 0;
	cp	a, #0x80
	jr	C,00104$
	ld	a, #0x00
00104$:
;src/components/fighter.c:227: weapon_damage, bon_atk, bon_def, dmg);
	ld	-5 (ix), a
	ld	-2 (ix), a
	ld	-1 (ix), #0x00
	ld	a, c
	rla
	sbc	a, a
	ld	b, a
	ld	e, -6 (ix)
	ld	a, -6 (ix)
	rla
	sbc	a, a
	ld	d, a
	ld	-4 (ix), l
	ld	-3 (ix), #0x00
;src/components/fighter.c:226: sprintf (msg, "\477\11\10%d + %d - %d = \477\13\10%d",
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	push	bc
	push	de
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	push	hl
	ld	hl, #___str_4
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #12
	add	hl, sp
	ld	sp, hl
;src/components/fighter.c:228: log_msg_ext (msg);
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
;src/components/fighter.c:230: return dmg;
	ld	l, -5 (ix)
	ld	sp, ix
	pop	ix
	ret
___str_4:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "%d + %d - %d = ?"
	.db 0x0b
	.db 0x08
	.ascii "%d"
	.db 0x00
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
