;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module items
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _log_msg_ext
	.globl _remove_from_container
	.globl _append_to_container
	.globl _name
	.globl _add_to_list
	.globl _remove_from_list
	.globl _remove_from_world
	.globl _add_to_world
	.globl _sprintf
	.globl _cpct_memset
	.globl _items
	.globl _num_items
	.globl _item_info
	.globl _init_items
	.globl _item_create
	.globl _pick_up
	.globl _drop
	.globl _take_gold
	.globl _use
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_num_items::
	.ds 1
_items::
	.ds 864
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/components/items.c:51: void init_items()
;	---------------------------------
; Function init_items
; ---------------------------------
_init_items::
;src/components/items.c:53: cpct_memset (items, 0, sizeof (items));
	ld	hl, #0x0360
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	hl, #_items
	push	hl
	call	_cpct_memset
;src/components/items.c:54: num_items = 0;
	ld	hl,#_num_items + 0
	ld	(hl), #0x00
	ret
_item_info:
	.dw #0x0008
	.dw _cast_heal
	.dw #0x0006
	.dw _cast_poison
	.dw #0x0000
	.dw _cast_bonus
	.dw #0x0001
	.dw _cast_bonus
	.dw #0x0002
	.dw _cast_bonus
	.dw #0x0003
	.dw _cast_bonus
	.dw #0x0000
	.dw _remove_hungry
	.dw #0x000f
	.dw #0x0000
	.dw #0x0000
	.dw _use_orutrix
;src/components/items.c:58: struct TItem *item_create(bool is_gold)
;	---------------------------------
; Function item_create
; ---------------------------------
_item_create::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/components/items.c:60: struct TItem *item=NULL;
	ld	bc, #0x0000
;src/components/items.c:61: if (num_items < MAX_ITEMS) {
	ld	iy, #_num_items
	ld	a, 0 (iy)
	sub	a, #0x60
	jr	NC,00104$
;src/components/items.c:62: item = &items[num_items++];
	ld	bc, #_items+0
	ld	e, 0 (iy)
	inc	0 (iy)
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl,bc
	ld	c, l
	ld	b, h
;src/components/items.c:63: item->is_gold = is_gold;
	ld	hl, #0x0006
	add	hl, bc
	ld	a, 4 (ix)
	ld	(hl), a
;src/components/items.c:64: if (is_gold) {
	bit	0, 4 (ix)
	jr	Z,00104$
;src/components/items.c:65: item->value = 25;
	ld	hl, #0x0007
	add	hl, bc
	ld	(hl), #0x19
	inc	hl
	ld	(hl), #0x00
00104$:
;src/components/items.c:68: return item;
	ld	l, c
	ld	h, b
	pop	ix
	ret
;src/components/items.c:72: void pick_up (struct TItem *item, struct TEntity *entity)
;	---------------------------------
; Function pick_up
; ---------------------------------
_pick_up::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/components/items.c:76: if (item->is_gold) {
	ld	c,4 (ix)
	ld	b,5 (ix)
	push	bc
	pop	iy
	ld	e, 6 (iy)
	bit	0, e
	jr	Z,00107$
;src/components/items.c:77: take_gold(item);
	push	bc
	call	_take_gold
	pop	af
	jp	00109$
00107$:
;src/components/items.c:80: if (entity->container) {
	ld	e,6 (ix)
	ld	d,7 (ix)
	ld	hl, #0x000b
	add	hl,de
	ex	(sp), hl
	pop	hl
	push	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, d
	or	a,e
	jp	Z, 00109$
;src/components/items.c:81: if (entity->container->num_items+1 > MAX_INVENTORY_ITEMS)
	push	de
	pop	iy
	ld	e, 34 (iy)
	ld	d, #0x00
	inc	de
	ld	a, #0x10
	cp	a, e
	ld	a, #0x00
	sbc	a, d
	jp	PO, 00123$
	xor	a, #0x80
00123$:
	jp	P, 00102$
;src/components/items.c:82: log_msg_ext ("\477\11\10Inventory full!");
	ld	hl, #___str_0
	push	hl
	call	_log_msg_ext
	pop	af
	jr	00109$
00102$:
;src/components/items.c:86: name(item->owner));
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	push	de
	call	_name
	ex	(sp),hl
	ld	hl, #___str_1
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
	pop	bc
;src/components/items.c:88: append_to_container (entity->container, item->owner);
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	pop	hl
	push	hl
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	bc
	push	de
	push	hl
	call	_append_to_container
	pop	af
	pop	af
	pop	bc
;src/components/items.c:89: remove_from_world (item->owner);
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	push	de
	call	_remove_from_world
	pop	af
	pop	bc
;src/components/items.c:90: remove_from_list (entities_in_level, item->owner);
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	push	de
	ld	hl, #_entities_in_level
	push	hl
	call	_remove_from_list
	pop	af
	pop	af
	pop	bc
;src/components/items.c:91: item->container = entity->container;
	inc	bc
	inc	bc
	ld	e, b
	pop	hl
	push	hl
	ld	b, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, e
	ld	(hl), b
	inc	hl
	ld	(hl), d
00109$:
	ld	sp, ix
	pop	ix
	ret
___str_0:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "Inventory full!"
	.db 0x00
___str_1:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "Picking up ?"
	.db 0x08
	.db 0x09
	.ascii "%s"
	.db 0x00
;src/components/items.c:99: void drop (struct TItem *item, i8 x, i8 y)
;	---------------------------------
; Function drop
; ---------------------------------
_drop::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/components/items.c:103: add_to_world (item->owner, x,y);
	ld	c,4 (ix)
	ld	b,5 (ix)
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	ld	h, 7 (ix)
	ld	l, 6 (ix)
	push	hl
	push	de
	call	_add_to_world
	pop	af
	pop	af
	pop	bc
;src/components/items.c:104: add_to_list (entities_in_level, item->owner);
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	push	de
	ld	hl, #_entities_in_level
	push	hl
	call	_add_to_list
	pop	af
	pop	af
	pop	bc
;src/components/items.c:105: remove_from_container (item->container, item->owner);
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	bc
	push	de
	push	hl
	call	_remove_from_container
	pop	af
	pop	af
;src/components/items.c:108: name(item->owner));
	pop	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	call	_name
;src/components/items.c:107: sprintf (msg, "\477\11\10Item \477\10\11%s\477\11\10 dropped",
	ex	(sp),hl
	ld	hl, #___str_2
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/components/items.c:109: log_msg_ext (msg);
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
	pop	ix
	ret
___str_2:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "Item ?"
	.db 0x08
	.db 0x09
	.ascii "%s?"
	.db 0x09
	.db 0x08
	.ascii " dropped"
	.db 0x00
;src/components/items.c:113: void take_gold(struct TItem *item_gold) {
;	---------------------------------
; Function take_gold
; ---------------------------------
_take_gold::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/components/items.c:117: player->item->value += item_gold->value;
	ld	hl, (_player)
	ld	de, #0x000d
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	hl, #0x0007
	add	hl,bc
	ex	(sp), hl
	pop	hl
	push	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	c,4 (ix)
	ld	b,5 (ix)
	ld	iy, #0x0007
	add	iy, bc
	ld	l, 0 (iy)
	ld	h, 1 (iy)
	add	hl,de
	ex	de,hl
	pop	hl
	push	hl
	ld	(hl), e
	inc	hl
	ld	(hl), d
;src/components/items.c:119: item_gold->value);
	ld	e, 0 (iy)
	ld	d, 1 (iy)
;src/components/items.c:118: sprintf (msg, "\477\11\10You got \477\10\11%d\477\11\10 gold",
	push	bc
	push	de
	ld	hl, #___str_3
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
;src/components/items.c:121: remove_from_world (item_gold->owner);
	pop	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	call	_remove_from_world
	pop	af
;src/components/items.c:122: stats_changed = true;
	ld	hl,#_stats_changed + 0
	ld	(hl), #0x01
	ld	sp, ix
	pop	ix
	ret
___str_3:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "You got ?"
	.db 0x08
	.db 0x09
	.ascii "%d?"
	.db 0x09
	.db 0x08
	.ascii " gold"
	.db 0x00
;src/components/items.c:127: void use(struct TItem *item) {
;	---------------------------------
; Function use
; ---------------------------------
_use::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/components/items.c:129: if (item->use_fn) {
	ld	c,4 (ix)
	ld	b,5 (ix)
	push	bc
	pop	iy
	ld	a, 4 (iy)
	ld	-2 (ix), a
	ld	a, 5 (iy)
	ld	-1 (ix), a
	or	a,-2 (ix)
	jr	Z,00103$
;src/components/items.c:130: item->use_fn(item->container->owner, item->value);
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	pop	iy
	inc	iy
	inc	iy
	ld	l, 0 (iy)
	ld	h, 1 (iy)
	ld	d, (hl)
	inc	hl
	ld	h, (hl)
	push	bc
	push	iy
	ld	a, e
	push	af
	inc	sp
	ld	l, d
	push	hl
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	call	___sdcc_call_hl
	pop	af
	inc	sp
	pop	iy
;src/components/items.c:131: remove_from_container (item->container, item->owner);
	pop	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	c, 0 (iy)
	ld	b, 1 (iy)
	push	de
	push	bc
	call	_remove_from_container
	pop	af
	pop	af
00103$:
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
