;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module rect
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _rect_create
	.globl _rect_get_center
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/components/rect.c:36: void rect_create (struct TRect *r, u8 x, u8 y, u8 w, u8 h)
;	---------------------------------
; Function rect_create
; ---------------------------------
_rect_create::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/components/rect.c:38: r->width  = w;
	ld	c,4 (ix)
	ld	b,5 (ix)
	ld	hl, #0x0004
	add	hl, bc
	ld	a, 8 (ix)
	ld	(hl), a
;src/components/rect.c:39: r->height = h;
	ld	hl, #0x0005
	add	hl, bc
	ld	a, 9 (ix)
	ld	(hl), a
;src/components/rect.c:40: r->left   = x;
	ld	a, 6 (ix)
	ld	(bc), a
;src/components/rect.c:41: r->top    = y;
	ld	e, c
	ld	d, b
	inc	de
	ld	a, 7 (ix)
	ld	(de), a
;src/components/rect.c:42: r->right  = x + w - 1;
	ld	e, c
	ld	d, b
	inc	de
	inc	de
	ld	a, 6 (ix)
	add	a, 8 (ix)
	add	a, #0xff
	ld	(de), a
;src/components/rect.c:43: r->bottom = y + h - 1;
	inc	bc
	inc	bc
	inc	bc
	ld	h, b
	ld	a, 7 (ix)
	add	a, 9 (ix)
	ld	b, a
	dec	b
	ld	l, c
	ld	(hl), b
	pop	ix
	ret
;src/components/rect.c:46: void rect_get_center (struct TRect *r, u8 *x, u8 *y)
;	---------------------------------
; Function rect_get_center
; ---------------------------------
_rect_get_center::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/components/rect.c:48: *x = (r->left + r->right)/2;
	ld	a, 6 (ix)
	ld	-2 (ix), a
	ld	a, 7 (ix)
	ld	-1 (ix), a
	ld	e,4 (ix)
	ld	d,5 (ix)
	ld	a, (de)
	ld	c, a
	ld	b, #0x00
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	ld	l, (hl)
	ld	h, #0x00
	add	hl, bc
	ld	c, l
	ld	b, h
	bit	7, h
	jr	Z,00103$
	inc	hl
	ld	c,l
	ld	b,h
00103$:
	sra	b
	rr	c
	pop	hl
	push	hl
	ld	(hl), c
;src/components/rect.c:49: *y = (r->top + r->bottom)/2;
	ld	c,8 (ix)
	ld	b,9 (ix)
	ld	l, e
	ld	h, d
	inc	hl
	ld	l, (hl)
	ld	-2 (ix), l
	ld	-1 (ix), #0x00
	ex	de,hl
	inc	hl
	inc	hl
	inc	hl
	ld	e, (hl)
	ld	d, #0x00
	pop	hl
	push	hl
	add	hl, de
	ld	e, l
	ld	d, h
	bit	7, h
	jr	Z,00104$
	ex	de,hl
	inc	de
00104$:
	sra	d
	rr	e
	ld	a, e
	ld	(bc), a
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
