;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module game_map
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _gen_mob
	.globl _gen_orutrix
	.globl _gen_stairs
	.globl _gen_item
	.globl _rand_range
	.globl _rect_get_center
	.globl _rect_create
	.globl _is_there_an_entity
	.globl _cpct_memset
	.globl _last_entity_in_level
	.globl _entities_in_level
	.globl _game_map
	.globl _plast_room
	.globl _rooms
	.globl _grid
	.globl _map_create
	.globl _get_random_position
	.globl __init_tiles
	.globl __place_rooms_in_grid
	.globl __grid_to_map
	.globl __carve_room
	.globl __dig_tunnel_x
	.globl __dig_tunnel_y
	.globl __place_stairs
	.globl __place_entities
	.globl __place_orutrix
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_grid::
	.ds 18
_rooms::
	.ds 36
_plast_room::
	.ds 2
_game_map::
	.ds 1010
_entities_in_level::
	.ds 256
_last_entity_in_level::
	.ds 2
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/game_map.c:66: void map_create (u8 width, u8 height)
;	---------------------------------
; Function map_create
; ---------------------------------
_map_create::
;src/game_map.c:72: _init_tiles(width, height);
	ld	hl, #3+0
	add	hl, sp
	ld	a, (hl)
	push	af
	inc	sp
	ld	hl, #3+0
	add	hl, sp
	ld	a, (hl)
	push	af
	inc	sp
	call	__init_tiles
	pop	af
;src/game_map.c:73: _place_rooms_in_grid();
	call	__place_rooms_in_grid
;src/game_map.c:74: _grid_to_map();
	call	__grid_to_map
;src/game_map.c:75: _place_stairs();
	call	__place_stairs
;src/game_map.c:78: if (orutrix_dlvl == dungeon_lvl) {
	ld	a,(#_orutrix_dlvl + 0)
	ld	iy, #_dungeon_lvl
	sub	a, 0 (iy)
	ret	NZ
;src/game_map.c:79: _place_orutrix();
	jp  __place_orutrix
;src/game_map.c:84: void get_random_position (struct TRect *r, i8 *x, i8 *y)
;	---------------------------------
; Function get_random_position
; ---------------------------------
_get_random_position::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-10
	add	hl, sp
	ld	sp, hl
;src/game_map.c:86: do {
	ld	c,4 (ix)
	ld	b,5 (ix)
	inc	sp
	inc	sp
	push	bc
	ld	-8 (ix), c
	ld	-7 (ix), b
	ld	-2 (ix), c
	ld	-1 (ix), b
00102$:
;src/game_map.c:87: *x = rand_range (r->left+1, r->right-1);
	ld	a, 6 (ix)
	ld	-4 (ix), a
	ld	a, 7 (ix)
	ld	-3 (ix), a
	pop	hl
	push	hl
	inc	hl
	inc	hl
	ld	d, (hl)
	dec	d
	ld	a, (bc)
	inc	a
	push	bc
	ld	e, a
	push	de
	call	_rand_range
	pop	af
	ld	e, l
	pop	bc
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	(hl), e
;src/game_map.c:88: *y = rand_range (r->top+1, r->bottom-1);
	ld	a, 8 (ix)
	ld	-6 (ix), a
	ld	a, 9 (ix)
	ld	-5 (ix), a
	ld	l,-8 (ix)
	ld	h,-7 (ix)
	inc	hl
	inc	hl
	inc	hl
	ld	d, (hl)
	dec	d
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	inc	hl
	ld	a, (hl)
	inc	a
	push	bc
	ld	e, a
	push	de
	call	_rand_range
	pop	af
	ld	e, l
	pop	bc
	ld	l,-6 (ix)
	ld	h,-5 (ix)
	ld	(hl), e
;src/game_map.c:89: } while (tile_blocks_movement (*x,*y) || is_there_an_entity(*x,*y));
	ld	l,-6 (ix)
	ld	h,-5 (ix)
	ld	a, (hl)
	ld	-6 (ix), a
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	d, (hl)
	ld	e, d
;src/game_map.h:112: return game_map.tiles[y][x].t_flags & BLOCKED;
	push	de
	ld	e,a
	rlc	a
	sbc	a, a
	ld	d, a
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	pop	de
	ld	a, #<((_game_map + 0x0002))
	add	a, l
	ld	l, a
	ld	a, #>((_game_map + 0x0002))
	adc	a, h
	ld	h, a
	sla	e
	ld	a, e
	add	a, l
	ld	l, a
	ld	a, #0x00
	adc	a, h
	ld	h, a
	inc	hl
	ld	a, (hl)
	rrca
	jp	C,00102$
;src/game_map.c:89: } while (tile_blocks_movement (*x,*y) || is_there_an_entity(*x,*y));
	push	bc
	ld	a, -6 (ix)
	push	af
	inc	sp
	push	de
	inc	sp
	call	_is_there_an_entity
	pop	af
	pop	bc
	bit	0, l
	jp	NZ, 00102$
	ld	sp, ix
	pop	ix
	ret
;src/game_map.c:114: void _init_tiles (u8 width, u8 height)
;	---------------------------------
; Function _init_tiles
; ---------------------------------
__init_tiles::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/game_map.c:116: game_map.width  = width;
	ld	hl, #_game_map
	ld	a, 4 (ix)
	ld	(hl), a
;src/game_map.c:117: game_map.height = height;
	ld	hl, #(_game_map + 0x0001)
	ld	a, 5 (ix)
	ld	(hl), a
;src/game_map.c:121: for (u8 y=0;y<height;y++) {
	ld	c, #0x00
00107$:
	ld	a, c
	sub	a, 5 (ix)
	jr	NC,00109$
;src/game_map.c:122: for (u8 x=0;x<width;x++) {
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ex	de,hl
	ld	hl, #(_game_map + 0x0002)
	add	hl,de
	ex	de,hl
	ld	b, #0x00
00104$:
	ld	a, b
	sub	a, 4 (ix)
	jr	NC,00108$
;src/game_map.c:123: game_map.tiles[y][x].spr     = '\0';
	ld	a, b
	add	a, a
	ld	l, a
	ld	h,#0x00
	add	hl, de
	ld	(hl), #0x00
;src/game_map.c:124: game_map.tiles[y][x].t_flags = BLOCKED;
	inc	hl
	ld	(hl), #0x01
;src/game_map.c:122: for (u8 x=0;x<width;x++) {
	inc	b
	jr	00104$
00108$:
;src/game_map.c:121: for (u8 y=0;y<height;y++) {
	inc	c
	jr	00107$
00109$:
	pop	ix
	ret
;src/game_map.c:144: void _place_rooms_in_grid()
;	---------------------------------
; Function _place_rooms_in_grid
; ---------------------------------
__place_rooms_in_grid::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
	dec	sp
;src/game_map.c:154: cpct_memset (rooms, 0, MAX_ROOMS * sizeof (struct TRoom));
	ld	hl, #0x0024
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	hl, #_rooms
	push	hl
	call	_cpct_memset
;src/game_map.c:157: num_rooms = rand_range (MIN_ROOMS, MAX_ROOMS);
	ld	hl, #0x0604
	push	hl
	call	_rand_range
	pop	af
;src/game_map.c:158: plast_room = &rooms[num_rooms];
	ld	c,l
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	ld	de, #_rooms
	add	hl, de
	ld	(_plast_room), hl
;src/game_map.c:171: for (i=0; i != GRID_SIZE; ++i) {
	ld	c, #0x00
00106$:
;src/game_map.c:172: x = (i%GRID_WIDTH) * GRID_CELL_WIDTH;
	push	bc
	ld	b, #0x03
	push	bc
	call	__moduchar
	pop	af
	pop	bc
	ld	e,l
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	push	bc
	ld	de, #0x0003
	push	de
	push	hl
	call	__divsint
	pop	af
	pop	af
	pop	bc
	ld	-1 (ix), l
;src/game_map.c:173: y = (i/GRID_WIDTH) * GRID_CELL_HEIGHT;
	push	bc
	ld	b, #0x03
	push	bc
	call	__divuchar
	pop	af
	pop	bc
	ld	e,l
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	ld	e, l
	ld	b, h
	bit	7, h
	jr	Z,00113$
	inc	hl
	ld	e, l
	ld	b, h
00113$:
	ld	d, b
	sra	d
	rr	e
	ld	b, e
;src/game_map.c:174: grid[i].x = x;
	ld	e,c
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	ex	de,hl
	ld	hl, #_grid
	add	hl,de
	ex	de,hl
	ld	a, -1 (ix)
	ld	(de), a
;src/game_map.c:175: grid[i].y = y;
	ld	l, e
	ld	h, d
	inc	hl
	ld	(hl), b
;src/game_map.c:176: grid[i].room_id = ROOM_NONE;
	inc	de
	inc	de
	ld	a, #0xff
	ld	(de), a
;src/game_map.c:171: for (i=0; i != GRID_SIZE; ++i) {
	inc	c
	ld	a, c
	sub	a, #0x06
	jr	NZ,00106$
;src/game_map.c:180: for (i=0, proom=rooms; proom != plast_room; ++i, ++proom) {
	ld	-3 (ix), #<(_rooms)
	ld	-2 (ix), #>(_rooms)
	ld	-5 (ix), #0x00
00109$:
	ld	iy, #_plast_room
	ld	a, 0 (iy)
	sub	a, -3 (ix)
	jr	NZ,00142$
	ld	a, 1 (iy)
	sub	a, -2 (ix)
	jr	Z,00111$
00142$:
;src/game_map.c:182: do {
00102$:
;src/game_map.c:183: spot = rand_range (0, GRID_SIZE);
	ld	hl, #0x0600
	push	hl
	call	_rand_range
	pop	af
;src/game_map.c:184: } while (grid[spot].room_id != ROOM_NONE);
	ld	c,l
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	ld	bc,#_grid
	add	hl,bc
	ex	de,hl
	ld	c, e
	ld	b, d
	inc	bc
	inc	bc
	ld	a, (bc)
	inc	a
	jr	NZ,00102$
;src/game_map.c:187: x = grid[spot].x;
	ld	a, (de)
	ld	-4 (ix), a
;src/game_map.c:188: y = grid[spot].y;
	ld	l, e
	ld	h, d
	inc	hl
	ld	e, (hl)
;src/game_map.c:189: w = rand_range (MIN_ROOM_SIZE, MAX_ROOM_SIZE);
	push	bc
	push	de
	ld	hl, #0x0805
	push	hl
	call	_rand_range
	pop	af
	pop	de
	pop	bc
	ld	d, l
;src/game_map.c:190: h = rand_range (MIN_ROOM_SIZE, MAX_ROOM_SIZE);
	push	bc
	push	de
	ld	hl, #0x0805
	push	hl
	call	_rand_range
	pop	af
	pop	de
	pop	bc
	ld	h, l
;src/game_map.c:191: rect_create (&(proom->rect), x,y, w, h);
	push	bc
	ld	l, d
	push	hl
	ld	d, e
	ld	e, -4 (ix)
	push	de
	ld	l,-3 (ix)
	ld	h,-2 (ix)
	push	hl
	call	_rect_create
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	bc
;src/game_map.c:192: grid[spot].room_id  = i;
	ld	a, -5 (ix)
	ld	(bc), a
;src/game_map.c:180: for (i=0, proom=rooms; proom != plast_room; ++i, ++proom) {
	inc	-5 (ix)
	ld	a, -3 (ix)
	add	a, #0x06
	ld	-3 (ix), a
	ld	a, -2 (ix)
	adc	a, #0x00
	ld	-2 (ix), a
	jp	00109$
00111$:
	ld	sp, ix
	pop	ix
	ret
;src/game_map.c:202: void  _grid_to_map ()
;	---------------------------------
; Function _grid_to_map
; ---------------------------------
__grid_to_map::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;src/game_map.c:206: i = new_x = new_y = prev_x = prev_y = 0;
	ld	c, #0x00
	ld	-6 (ix), #0x00
	ld	-5 (ix), #0x00
	ld	-4 (ix), #0x00
;src/game_map.c:208: cpct_memset (entities_in_level, 0, sizeof (entities_in_level));
	push	bc
	ld	hl, #0x0100
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	hl, #_entities_in_level
	push	hl
	call	_cpct_memset
	pop	bc
;src/game_map.c:209: last_entity_in_level = entities_in_level;
	ld	hl, #_entities_in_level
	ld	(_last_entity_in_level), hl
;src/game_map.c:212: for (i=0, proom=rooms; proom != plast_room; ++proom, ++i) {
	ld	de, #_rooms
	ld	-3 (ix), #0x00
00107$:
	ld	iy, #_plast_room
	ld	a, 0 (iy)
	sub	a, e
	jr	NZ,00136$
	ld	a, 1 (iy)
	sub	a, d
	jp	Z,00104$
00136$:
;src/game_map.c:214: rect_get_center (&(proom->rect), &new_x, &new_y);
	ld	hl, #0x0001
	add	hl, sp
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	iy,#0x0002
	add	iy,sp
	push	bc
	push	de
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	push	iy
	push	de
	call	_rect_get_center
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	de
	pop	bc
;src/game_map.c:217: if (i != 0) {
	ld	a, -3 (ix)
	or	a, a
	jr	Z,00102$
;src/game_map.c:218: _dig_tunnel_x (prev_x, prev_y, new_x);
	push	bc
	push	de
	ld	b, -4 (ix)
	push	bc
	ld	a, -6 (ix)
	push	af
	inc	sp
	call	__dig_tunnel_x
	pop	af
	inc	sp
	pop	de
	pop	bc
;src/game_map.c:219: _dig_tunnel_y (new_x,  prev_y, new_y);
	push	de
	ld	b, -5 (ix)
	push	bc
	ld	a, -4 (ix)
	push	af
	inc	sp
	call	__dig_tunnel_y
	pop	af
	inc	sp
	pop	de
	jr	00103$
00102$:
;src/game_map.c:223: player->x = new_x;
	ld	hl, (_player)
	inc	hl
	ld	a, -4 (ix)
	ld	(hl), a
;src/game_map.c:224: player->y = new_y;
	ld	hl, (_player)
	inc	hl
	inc	hl
	ld	a, -5 (ix)
	ld	(hl), a
;src/game_map.c:227: *last_entity_in_level++ = player;
	ld	hl, (_last_entity_in_level)
	ld	iy, #_player
	ld	a, 0 (iy)
	ld	(hl), a
	inc	hl
	ld	a, 1 (iy)
	ld	(hl), a
	ld	hl, #_last_entity_in_level
	ld	a, (hl)
	add	a, #0x02
	ld	(hl), a
	inc	hl
	ld	a, (hl)
	adc	a, #0x00
	ld	(hl), a
00103$:
;src/game_map.c:230: prev_x = new_x;
	ld	a, -4 (ix)
	ld	-6 (ix), a
;src/game_map.c:231: prev_y = new_y;
	ld	c, -5 (ix)
;src/game_map.c:212: for (i=0, proom=rooms; proom != plast_room; ++proom, ++i) {
	ld	hl, #0x0006
	add	hl,de
	ex	de,hl
	inc	-3 (ix)
	jp	00107$
00104$:
;src/game_map.c:238: for (i=0, proom=rooms; proom != plast_room; ++proom, ++i) {
	ld	bc, #_rooms
00110$:
	ld	iy, #_plast_room
	ld	a, 0 (iy)
	sub	a, c
	jr	NZ,00137$
	ld	a, 1 (iy)
	sub	a, b
	jr	Z,00112$
00137$:
;src/game_map.c:239: _carve_room (proom);
	push	bc
	push	bc
	call	__carve_room
	pop	af
	pop	bc
;src/game_map.c:240: _place_entities(proom);
	push	bc
	push	bc
	call	__place_entities
	pop	af
	pop	bc
;src/game_map.c:238: for (i=0, proom=rooms; proom != plast_room; ++proom, ++i) {
	ld	hl, #0x0006
	add	hl,bc
	ld	c, l
	ld	b, h
	jr	00110$
00112$:
	ld	sp, ix
	pop	ix
	ret
;src/game_map.c:250: void  _carve_room (struct TRoom *r)
;	---------------------------------
; Function _carve_room
; ---------------------------------
__carve_room::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-20
	add	hl, sp
	ld	sp, hl
;src/game_map.c:255: for (y = r->rect.top+1; y <= r->rect.bottom-1; ++y) {
	ld	a, 4 (ix)
	ld	-7 (ix), a
	ld	a, 5 (ix)
	ld	-6 (ix), a
	ld	a, -7 (ix)
	add	a, #0x01
	ld	-2 (ix), a
	ld	a, -6 (ix)
	adc	a, #0x00
	ld	-1 (ix), a
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	a, (hl)
	inc	a
	ld	-5 (ix), a
	ld	c,-7 (ix)
	ld	b,-6 (ix)
	inc	bc
	inc	bc
	ld	a, -7 (ix)
	add	a, #0x03
	ld	-4 (ix), a
	ld	a, -6 (ix)
	adc	a, #0x00
	ld	-3 (ix), a
00119$:
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	e, (hl)
	ld	d, #0x00
	dec	de
	ld	l, -5 (ix)
	ld	h, #0x00
	ld	a, e
	sub	a, l
	ld	a, d
	sbc	a, h
	jp	PO, 00185$
	xor	a, #0x80
00185$:
	jp	M, 00102$
;src/game_map.c:256: for (x = r->rect.left+1; x <= r->rect.right-1; ++x) {
	ld	l,-7 (ix)
	ld	h,-6 (ix)
	ld	a, (hl)
	inc	a
	ld	-16 (ix), a
	ld	e,-5 (ix)
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ex	de,hl
	ld	hl, #(_game_map + 0x0002)
	add	hl,de
	ex	de,hl
00116$:
	ld	a, (bc)
	ld	l, a
	ld	h, #0x00
	dec	hl
	ld	a, -16 (ix)
	ld	-18 (ix), a
	ld	-17 (ix), #0x00
	ld	a, l
	sub	a, -18 (ix)
	ld	a, h
	sbc	a, -17 (ix)
	jp	PO, 00186$
	xor	a, #0x80
00186$:
	jp	M, 00120$
;src/game_map.c:257: game_map.tiles[y][x].spr = SPR_FLOOR;
	ld	a, -16 (ix)
	add	a, a
	ld	l, a
	ld	h,#0x00
	add	hl, de
	ld	(hl), #0x90
;src/game_map.c:258: game_map.tiles[y][x].t_flags &= ~BLOCKED;
	inc	hl
	ld	a, (hl)
	and	a, #0xfe
	ld	(hl), a
;src/game_map.c:256: for (x = r->rect.left+1; x <= r->rect.right-1; ++x) {
	inc	-16 (ix)
	jr	00116$
00120$:
;src/game_map.c:255: for (y = r->rect.top+1; y <= r->rect.bottom-1; ++y) {
	inc	-5 (ix)
	jr	00119$
00102$:
;src/game_map.c:262: for (y=r->rect.top+1; y < r->rect.bottom; ++y) {
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	a, (hl)
	inc	a
	ld	-20 (ix), a
	ld	-18 (ix), c
	ld	-17 (ix), b
00122$:
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	e, (hl)
;src/game_map.c:256: for (x = r->rect.left+1; x <= r->rect.right-1; ++x) {
	ld	l,-7 (ix)
	ld	h,-6 (ix)
	ld	a, (hl)
	ld	-16 (ix), a
;src/game_map.c:262: for (y=r->rect.top+1; y < r->rect.bottom; ++y) {
	ld	a, -20 (ix)
	sub	a, e
	jp	NC, 00109$
;src/game_map.c:263: if (tile_blocks_movement (r->rect.left, y))
	ld	a, -16 (ix)
	ld	-19 (ix), a
	ld	e, -20 (ix)
;src/game_map.h:112: return game_map.tiles[y][x].t_flags & BLOCKED;
	ld	a, e
	rlc	a
	sbc	a, a
	ld	d, a
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	de, #(_game_map + 0x0002)
	add	hl, de
	ld	a, -19 (ix)
	add	a, a
	ld	e, a
	ld	d,#0x00
	add	hl, de
	inc	hl
	ld	a, (hl)
	rrca
	jr	NC,00104$
;src/game_map.c:263: if (tile_blocks_movement (r->rect.left, y))
;src/game_map.c:264: spr = SPR_VWALL;
	ld	e, #0x95
	jr	00105$
00104$:
;src/game_map.c:266: spr = ' ';
	ld	e, #0x20
00105$:
;src/game_map.c:267: game_map.tiles[y][r->rect.left].spr =spr;
	push	de
	ld	e,-20 (ix)
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	pop	de
	ld	a, #<((_game_map + 0x0002))
	add	a, l
	ld	-9 (ix), a
	ld	a, #>((_game_map + 0x0002))
	adc	a, h
	ld	-8 (ix), a
	ld	a, -16 (ix)
	add	a, a
	add	a, -9 (ix)
	ld	l, a
	ld	a, #0x00
	adc	a, -8 (ix)
	ld	h, a
	ld	(hl), e
;src/game_map.c:269: if (tile_blocks_movement (r->rect.right, y))
	ld	l,-18 (ix)
	ld	h,-17 (ix)
	ld	e, (hl)
	ld	d, e
	ld	l, -20 (ix)
;src/game_map.h:112: return game_map.tiles[y][x].t_flags & BLOCKED;
	push	de
	ld	e, l
	ld	a, e
	rlc	a
	sbc	a, a
	ld	d, a
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	pop	de
	ld	a, #<((_game_map + 0x0002))
	add	a, l
	ld	l, a
	ld	a, #>((_game_map + 0x0002))
	adc	a, h
	ld	h, a
	sla	d
	ld	a, d
	add	a, l
	ld	l, a
	ld	a, #0x00
	adc	a, h
	ld	h, a
	inc	hl
	ld	a, (hl)
	rrca
	jr	NC,00107$
;src/game_map.c:269: if (tile_blocks_movement (r->rect.right, y))
;src/game_map.c:270: spr = SPR_VWALL;
	ld	d, #0x95
	jr	00108$
00107$:
;src/game_map.c:272: spr = ' ';
	ld	d, #0x20
00108$:
;src/game_map.c:273: game_map.tiles[y][r->rect.right].spr =spr;
	sla	e
	ld	a, e
	add	a, -9 (ix)
	ld	l, a
	ld	a, #0x00
	adc	a, -8 (ix)
	ld	h, a
	ld	(hl), d
;src/game_map.c:262: for (y=r->rect.top+1; y < r->rect.bottom; ++y) {
	inc	-20 (ix)
	jp	00122$
00109$:
;src/game_map.c:276: for (x=r->rect.left+1; x < r->rect.right; ++x) {
	ld	a, -16 (ix)
	inc	a
	ld	-9 (ix), a
	ld	-18 (ix), c
	ld	-17 (ix), b
00125$:
	ld	l,-18 (ix)
	ld	h,-17 (ix)
	ld	c, (hl)
;src/game_map.c:255: for (y = r->rect.top+1; y <= r->rect.bottom-1; ++y) {
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	a, (hl)
;src/game_map.c:278: game_map.tiles[r->rect.top][x].spr = spr;
	ld	-16 (ix), a
	ld	e, a
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	-11 (ix), l
	ld	-10 (ix), h
;src/game_map.c:276: for (x=r->rect.left+1; x < r->rect.right; ++x) {
	ld	a, -9 (ix)
	sub	a, c
	jp	NC, 00110$
;src/game_map.c:277: spr = (tile_blocks_movement (x, r->rect.top)) ? SPR_HWALL : ' ';
	ld	a, -16 (ix)
;src/game_map.h:112: return game_map.tiles[y][x].t_flags & BLOCKED;
	ld	-19 (ix), a
	ld	c,a
	rlc	a
	sbc	a, a
	ld	b, a
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	-13 (ix), l
	ld	-12 (ix), h
	ld	a, #<((_game_map + 0x0002))
	add	a, -13 (ix)
	ld	-13 (ix), a
	ld	a, #>((_game_map + 0x0002))
	adc	a, -12 (ix)
	ld	-12 (ix), a
	ld	a, -9 (ix)
	add	a, a
	ld	-16 (ix), a
	ld	a, -13 (ix)
	add	a, -16 (ix)
	ld	-13 (ix), a
	ld	a, -12 (ix)
	adc	a, #0x00
	ld	-12 (ix), a
	ld	l,-13 (ix)
	ld	h,-12 (ix)
	inc	hl
	ld	a, (hl)
	rrca
	jr	NC,00129$
;src/game_map.c:277: spr = (tile_blocks_movement (x, r->rect.top)) ? SPR_HWALL : ' ';
	ld	bc, #0x009a
	jr	00130$
00129$:
	ld	bc, #0x0020
00130$:
;src/game_map.c:278: game_map.tiles[r->rect.top][x].spr = spr;
	ld	a, #<((_game_map + 0x0002))
	add	a, -11 (ix)
	ld	e, a
	ld	a, #>((_game_map + 0x0002))
	adc	a, -10 (ix)
	ld	d, a
	ld	l,-16 (ix)
	ld	h,#0x00
	add	hl, de
	ld	(hl), c
;src/game_map.c:255: for (y = r->rect.top+1; y <= r->rect.bottom-1; ++y) {
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	a, (hl)
;src/game_map.c:279: spr = (tile_blocks_movement (x, r->rect.bottom)) ? SPR_HWALL : ' ';
	ld	-13 (ix), a
;src/game_map.h:112: return game_map.tiles[y][x].t_flags & BLOCKED;
	ld	c,a
	rlc	a
	sbc	a, a
	ld	b, a
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	de, #(_game_map + 0x0002)
	add	hl, de
	ld	e,-16 (ix)
	ld	d,#0x00
	add	hl, de
	inc	hl
	ld	a, (hl)
	rrca
	jr	NC,00131$
;src/game_map.c:279: spr = (tile_blocks_movement (x, r->rect.bottom)) ? SPR_HWALL : ' ';
	ld	-15 (ix), #0x9a
	ld	-14 (ix), #0x00
	jr	00132$
00131$:
	ld	-15 (ix), #0x20
	ld	-14 (ix), #0x00
00132$:
	ld	c, -15 (ix)
;src/game_map.c:280: game_map.tiles[r->rect.bottom][x].spr = spr;
	ld	e,-13 (ix)
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	de, #(_game_map + 0x0002)
	add	hl, de
	ld	e,-16 (ix)
	ld	d,#0x00
	add	hl, de
	ld	(hl), c
;src/game_map.c:276: for (x=r->rect.left+1; x < r->rect.right; ++x) {
	inc	-9 (ix)
	jp	00125$
00110$:
;src/game_map.c:286: game_map.tiles[r->rect.top][r->rect.left].spr = SPR_TLWALL;
	ld	a, #<((_game_map + 0x0002))
	add	a, -11 (ix)
	ld	c, a
	ld	a, #>((_game_map + 0x0002))
	adc	a, -10 (ix)
	ld	b, a
	ld	l,-7 (ix)
	ld	h,-6 (ix)
	ld	e, (hl)
	sla	e
	ld	l,e
	ld	h,#0x00
	add	hl, bc
	ld	(hl), #0x96
;src/game_map.c:288: game_map.tiles[r->rect.bottom][r->rect.left].spr = SPR_BLWALL;
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	c, (hl)
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	bc,#(_game_map + 0x0002)
	add	hl,bc
	ld	c, l
	ld	b, h
	ld	l,-7 (ix)
	ld	h,-6 (ix)
	ld	e, (hl)
	sla	e
	ld	l,e
	ld	h,#0x00
	add	hl, bc
	ld	(hl), #0x93
;src/game_map.c:289: game_map.tiles[r->rect.top][r->rect.right].spr = SPR_TRWALL;
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	c, (hl)
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	bc,#(_game_map + 0x0002)
	add	hl,bc
	ld	c, l
	ld	b, h
	ld	l,-18 (ix)
	ld	h,-17 (ix)
	ld	e, (hl)
	sla	e
	ld	l,e
	ld	h,#0x00
	add	hl, bc
	ld	(hl), #0x9c
;src/game_map.c:290: game_map.tiles[r->rect.bottom][r->rect.right].spr = SPR_BRWALL;
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	c, (hl)
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	bc,#(_game_map + 0x0002)
	add	hl,bc
	ld	c, l
	ld	b, h
	ld	l,-18 (ix)
	ld	h,-17 (ix)
	ld	e, (hl)
	sla	e
	ld	l,e
	ld	h,#0x00
	add	hl, bc
	ld	(hl), #0x99
	ld	sp, ix
	pop	ix
	ret
;src/game_map.c:302: void  _dig_tunnel_x (u8 src_x, u8 src_y, u8 dst_x)
;	---------------------------------
; Function _dig_tunnel_x
; ---------------------------------
__dig_tunnel_x::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/game_map.c:308: start_x = min (src_x, dst_x);
	ld	b, 6 (ix)
	ld	e, 4 (ix)
;src/aux_math.h:34: return a < b ? a : b;
	ld	a, e
	sub	a, b
	jr	NC,00108$
	ld	c, e
	jr	00109$
00108$:
	ld	c, b
00109$:
;src/game_map.c:308: start_x = min (src_x, dst_x);
;src/aux_math.h:38: return a > b ? a : b;
	ld	a, b
	sub	a, e
	jr	C,00111$
	ld	e, b
00111$:
	ld	b, e
;src/game_map.c:311: tile = &(game_map.tiles[src_y][start_x]);
	ld	e,5 (ix)
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	de, #(_game_map + 0x0002)
	add	hl, de
	ld	a, c
	add	a, a
	ld	e, a
	ld	d,#0x00
	add	hl, de
	ex	de,hl
;src/game_map.c:312: tile_end = tile + end_x - start_x;
	ld	l, b
	ld	h, #0x00
	add	hl, hl
	add	hl, de
	ld	b, #0x00
	sla	c
	rl	b
	cp	a, a
	sbc	hl, bc
	ld	c, l
	ld	b, h
;src/game_map.c:313: while (tile <= tile_end) {
00101$:
	ld	a, c
	sub	a, e
	ld	a, b
	sbc	a, d
	jr	C,00106$
;src/game_map.c:314: tile->spr      = SPR_TUNNEL;
	ld	a, #0xcf
	ld	(de), a
;src/game_map.c:315: tile->t_flags &= ~BLOCKED;
	ld	l, e
	ld	h, d
	inc	hl
	ld	a, (hl)
	and	a, #0xfe
	ld	(hl), a
;src/game_map.c:316: tile++;
	inc	de
	inc	de
	jr	00101$
00106$:
	pop	ix
	ret
;src/game_map.c:328: void  _dig_tunnel_y (u8 src_x, u8 src_y, u8 dst_y)
;	---------------------------------
; Function _dig_tunnel_y
; ---------------------------------
__dig_tunnel_y::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/game_map.c:335: start_y = min (src_y, dst_y);
	ld	b, 6 (ix)
	ld	e, 5 (ix)
;src/aux_math.h:34: return a < b ? a : b;
	ld	a, e
	sub	a, b
	jr	NC,00108$
	ld	c, e
	jr	00109$
00108$:
	ld	c, b
00109$:
;src/game_map.c:335: start_y = min (src_y, dst_y);
;src/aux_math.h:38: return a > b ? a : b;
	ld	a, b
	sub	a, e
	jr	C,00111$
	ld	e, b
00111$:
	ld	b, e
;src/game_map.c:338: tile = &(game_map.tiles[start_y][src_x]);
	ld	e,c
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	de, #(_game_map + 0x0002)
	add	hl, de
	ld	a, 4 (ix)
	add	a, a
	ld	e, a
	ld	d,#0x00
	add	hl, de
	ex	de,hl
;src/game_map.c:339: tile_end = tile + (end_y - start_y)*MAP_WIDTH;
	ld	l, b
	ld	h, #0x00
	ld	b, #0x00
	cp	a, a
	sbc	hl, bc
	ld	c, l
	ld	b, h
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl,de
	ld	c, l
	ld	b, h
;src/game_map.c:340: while (tile < tile_end) {
00101$:
	ld	a, e
	sub	a, c
	ld	a, d
	sbc	a, b
	jr	NC,00106$
;src/game_map.c:341: tile->spr      = SPR_TUNNEL;
	ld	a, #0xcf
	ld	(de), a
;src/game_map.c:342: tile->t_flags &= ~BLOCKED;
	ld	l, e
	ld	h, d
	inc	hl
	ld	a, (hl)
	and	a, #0xfe
	ld	(hl), a
;src/game_map.c:343: tile+=MAP_WIDTH;
	ld	hl, #0x0038
	add	hl,de
	ex	de,hl
	jr	00101$
00106$:
	pop	ix
	ret
;src/game_map.c:348: void _place_stairs()
;	---------------------------------
; Function _place_stairs
; ---------------------------------
__place_stairs::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;src/game_map.c:352: struct TEntity **e = last_entity_in_level;
	ld	bc, (_last_entity_in_level)
;src/game_map.c:357: if (orutrix_dlvl != dungeon_lvl) {
	ld	a,(#_orutrix_dlvl + 0)
	ld	iy, #_dungeon_lvl
	sub	a, 0 (iy)
	jr	Z,00103$
;src/game_map.c:359: proom = plast_room-1;
	ld	iy, #_plast_room
	ld	a, 0 (iy)
	add	a, #0xfa
	ld	-2 (ix), a
	ld	a, 1 (iy)
	adc	a, #0xff
	ld	-1 (ix), a
;src/game_map.c:360: rect_get_center (&(proom->rect), &x, &y);
	ld	hl, #0x0000
	add	hl, sp
	ex	de,hl
	ld	hl, #0x0001
	add	hl, sp
	push	bc
	push	de
	push	hl
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	call	_rect_get_center
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ld	a, #0x01
	push	af
	inc	sp
	ld	h, -4 (ix)
	ld	l, -3 (ix)
	push	hl
	call	_gen_stairs
	pop	af
	inc	sp
	ex	de,hl
	pop	bc
	ld	l, c
	ld	h, b
	ld	(hl), e
	inc	hl
	ld	(hl), d
	inc	bc
	inc	bc
	ld	(_last_entity_in_level), bc
;src/game_map.c:362: last_entity_in_level = e;
00103$:
	ld	sp, ix
	pop	ix
	ret
;src/game_map.c:375: void _place_entities(struct TRoom *proom)
;	---------------------------------
; Function _place_entities
; ---------------------------------
__place_entities::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;src/game_map.c:378: u8 number_of_mobs   = rand_range (0, MAX_MOBS_PER_ROOM);
	ld	hl, #0x0200
	push	hl
	call	_rand_range
	pop	af
	ld	c, l
;src/game_map.c:379: u8 number_of_items  = rand_range (0, MAX_ITEMS_PER_ROOM);
	push	bc
	ld	hl, #0x0100
	push	hl
	call	_rand_range
	pop	af
	pop	bc
	ld	-5 (ix), l
;src/game_map.c:381: for (u8 i=number_of_mobs; i!=0; i--) {
	ld	-6 (ix), c
00104$:
;src/game_map.c:382: get_random_position (&(proom->rect), &x,&y);
	ld	c,4 (ix)
	ld	b,5 (ix)
;src/game_map.c:381: for (u8 i=number_of_mobs; i!=0; i--) {
	ld	a, -6 (ix)
	or	a, a
	jr	Z,00101$
;src/game_map.c:382: get_random_position (&(proom->rect), &x,&y);
	ld	hl, #0x0003
	add	hl, sp
	ex	de,hl
	ld	hl, #0x0002
	add	hl, sp
	push	de
	push	hl
	push	bc
	call	_get_random_position
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/game_map.c:383: *last_entity_in_level++ = gen_mob (ERANDOM, x,y);
	ld	bc, (_last_entity_in_level)
	push	bc
	ld	a, -3 (ix)
	push	af
	inc	sp
	ld	d, -4 (ix)
	ld	e,#0x12
	push	de
	call	_gen_mob
	pop	af
	inc	sp
	ex	de,hl
	pop	bc
	ld	a, e
	ld	(bc), a
	inc	bc
	ld	a, d
	ld	(bc), a
	ld	hl, #_last_entity_in_level
	ld	a, (hl)
	add	a, #0x02
	ld	(hl), a
	inc	hl
	ld	a, (hl)
	adc	a, #0x00
	ld	(hl), a
;src/game_map.c:381: for (u8 i=number_of_mobs; i!=0; i--) {
	dec	-6 (ix)
	jr	00104$
00101$:
;src/game_map.c:386: for (u8 i=number_of_items; i!=0; i--) {
	ld	a, -5 (ix)
	ld	-6 (ix), a
00107$:
	ld	a, -6 (ix)
	or	a, a
	jr	Z,00109$
;src/game_map.c:387: get_random_position (&(proom->rect), &x,&y);
	ld	hl, #0x0003
	add	hl, sp
	ex	de,hl
	ld	hl, #0x0002
	add	hl, sp
	push	bc
	push	de
	push	hl
	push	bc
	call	_get_random_position
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	bc
;src/game_map.c:388: *last_entity_in_level++ = gen_item (ERANDOM, x,y);
	ld	hl, (_last_entity_in_level)
	ld	-2 (ix), l
	ld	-1 (ix), h
	push	bc
	ld	a, -3 (ix)
	push	af
	inc	sp
	ld	d, -4 (ix)
	ld	e,#0x12
	push	de
	call	_gen_item
	pop	af
	inc	sp
	ex	de,hl
	pop	bc
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	(hl), e
	inc	hl
	ld	(hl), d
	ld	hl, #_last_entity_in_level
	ld	a, (hl)
	add	a, #0x02
	ld	(hl), a
	inc	hl
	ld	a, (hl)
	adc	a, #0x00
	ld	(hl), a
;src/game_map.c:386: for (u8 i=number_of_items; i!=0; i--) {
	dec	-6 (ix)
	jr	00107$
00109$:
	ld	sp, ix
	pop	ix
	ret
;src/game_map.c:393: void _place_orutrix()
;	---------------------------------
; Function _place_orutrix
; ---------------------------------
__place_orutrix::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;src/game_map.c:395: struct TEntity **e = last_entity_in_level;
	ld	bc, (_last_entity_in_level)
;src/game_map.c:400: proom = plast_room - 1;
	ld	iy, #_plast_room
	ld	a, 0 (iy)
	add	a, #0xfa
	ld	-2 (ix), a
	ld	a, 1 (iy)
	adc	a, #0xff
	ld	-1 (ix), a
;src/game_map.c:401: get_random_position (&(proom->rect), &x,&y);
	ld	hl, #0x0000
	add	hl, sp
	ex	de,hl
	ld	hl, #0x0001
	add	hl, sp
	push	bc
	push	de
	push	hl
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	call	_get_random_position
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ld	h, -4 (ix)
	ld	l, -3 (ix)
	push	hl
	call	_gen_orutrix
	pop	af
	ex	de,hl
	pop	bc
	ld	l, c
	ld	h, b
	ld	(hl), e
	inc	hl
	ld	(hl), d
	inc	bc
	inc	bc
	ld	(_last_entity_in_level), bc
;src/game_map.c:403: last_entity_in_level = e;
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
