;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module generators
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _gen_mob
	.globl _gen_player
	.globl _gen_orutrix
	.globl _gen_stairs
	.globl _gen_item
	.globl _gen_basic_item
	.globl _rand_range
	.globl _remove_from_world
	.globl _entity_create
	.globl _stairs_create
	.globl _item_create
	.globl _kill_player
	.globl _kill_mob
	.globl _fighter_create
	.globl _basic_ai_create
	.globl _cpct_getRandom_mxor_u8
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/generators.c:43: struct TEntity *gen_basic_item (enum ItemType type, i8 x, i8 y)
;	---------------------------------
; Function gen_basic_item
; ---------------------------------
_gen_basic_item::
;src/generators.c:45: struct TItem *item = item_create (false);
	xor	a, a
	push	af
	inc	sp
	call	_item_create
	inc	sp
;src/generators.c:46: struct TEntity *entity = entity_create (type, x, y,
	ld	iy, #2
	add	iy, sp
	ld	b, 0 (iy)
	ld	de, #0x0000
	push	de
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, #0x00
	push	hl
	ld	l, #0x00
	push	hl
	ld	hl, #15+0
	add	hl, sp
	ld	a, (hl)
	push	af
	inc	sp
	ld	hl, #15+0
	add	hl, sp
	ld	a, (hl)
	push	af
	inc	sp
	push	bc
	inc	sp
	call	_entity_create
	ld	iy, #13
	add	iy, sp
	ld	sp, iy
;src/generators.c:49: return entity;
	ret
;src/generators.c:56: struct TEntity *gen_item (enum Etype item_type, i8 x, i8 y)
;	---------------------------------
; Function gen_item
; ---------------------------------
_gen_item::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;src/generators.c:61: if (item_type == ERANDOM) {
	ld	a, 4 (ix)
	sub	a, #0x12
	jr	NZ,00105$
;src/generators.c:62: if (cpct_rand () < 80) item_type = FOOD;
	call	_cpct_getRandom_mxor_u8
	ld	a, l
	sub	a, #0x50
	jr	NC,00102$
	ld	4 (ix), #0x0c
	jr	00105$
00102$:
;src/generators.c:64: item_type = rand_range (FIRST_ITEM, LAST_ITEM);
	ld	hl, #0x0d06
	push	hl
	call	_rand_range
	pop	af
	ld	4 (ix), l
00105$:
;src/generators.c:67: entity_item = gen_basic_item (item_type, x,y);
	ld	c, 4 (ix)
	ld	b, #0x00
	ld	h, 6 (ix)
	ld	l, 5 (ix)
	push	hl
	push	bc
	call	_gen_basic_item
	pop	af
	pop	af
	inc	sp
	inc	sp
	push	hl
;src/generators.c:68: item_info_id = item_type - FIRST_ITEM;
	ld	a, 4 (ix)
	add	a, #0xfa
	ld	e, a
;src/generators.c:69: entity_item->item->value  = item_info[item_info_id].value;
	ld	a, -6 (ix)
	add	a, #0x0d
	ld	-2 (ix), a
	ld	a, -5 (ix)
	adc	a, #0x00
	ld	-1 (ix), a
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	hl, #0x0007
	add	hl,bc
	ld	-4 (ix), l
	ld	-3 (ix), h
	ld	bc, #_item_info+0
	ld	l, e
	ld	h, #0x00
	add	hl, hl
	add	hl, hl
	add	hl,bc
	ld	e,l
	ld	d,h
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
;src/generators.c:70: entity_item->item->use_fn = item_info[item_info_id].use_fn;
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	bc
	inc	bc
	inc	bc
	inc	bc
	ex	de,hl
	inc	hl
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, e
	ld	(bc), a
	inc	bc
	ld	a, d
	ld	(bc), a
;src/generators.c:71: entity_item->item->is_gold = (item_type == GOLD);
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	hl, #0x0006
	add	hl, bc
	ld	a, 4 (ix)
	sub	a, #0x0d
	jr	NZ,00118$
	ld	a,#0x01
	jr	00119$
00118$:
	xor	a,a
00119$:
	ld	(hl), a
;src/generators.c:77: return entity_item;
	pop	hl
	push	hl
	ld	sp, ix
	pop	ix
	ret
;src/generators.c:86: struct TEntity *gen_stairs (i8 x, i8 y, bool downwards)
;	---------------------------------
; Function gen_stairs
; ---------------------------------
_gen_stairs::
;src/generators.c:88: struct TEntity *e =
	ld	hl, #4+0
	add	hl, sp
	ld	a, (hl)
	push	af
	inc	sp
	call	_stairs_create
	inc	sp
	push	hl
	ld	hl, #0x0000
	push	hl
	ld	l, #0x00
	push	hl
	ld	l, #0x00
	push	hl
	ld	l, #0x00
	push	hl
	ld	hl, #13+0
	add	hl, sp
	ld	a, (hl)
	push	af
	inc	sp
	ld	hl, #13+0
	add	hl, sp
	ld	d, (hl)
	ld	e,#0x0f
	push	de
	call	_entity_create
	ld	iy, #13
	add	iy, sp
	ld	sp, iy
	ld	c, l
	ld	b, h
;src/generators.c:92: e->type = (downwards) ? STAIRSDOWN : e->type;
	ld	e, c
	ld	d, b
	ld	hl, #4+0
	add	hl, sp
	bit	0, (hl)
	jr	Z,00103$
	ld	a, #0x10
	jr	00104$
00103$:
	ld	a, (bc)
00104$:
	ld	(de), a
;src/generators.c:94: return e;
	ld	l, c
	ld	h, b
	ret
;src/generators.c:103: struct TEntity *gen_orutrix (i8 x, i8 y)
;	---------------------------------
; Function gen_orutrix
; ---------------------------------
_gen_orutrix::
;src/generators.c:105: struct TEntity *e = gen_item (ORUTRIX, x,y);
	ld	hl, #3+0
	add	hl, sp
	ld	a, (hl)
	push	af
	inc	sp
	ld	hl, #3+0
	add	hl, sp
	ld	d, (hl)
	ld	e,#0x0e
	push	de
	call	_gen_item
	pop	af
	inc	sp
;src/generators.c:106: return e;
	ret
;src/generators.c:115: struct TEntity *gen_player()
;	---------------------------------
; Function gen_player
; ---------------------------------
_gen_player::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	dec	sp
;src/generators.c:122: max_hp  = 10 + rand_range (1, 10);
	ld	hl, #0x0a01
	push	hl
	call	_rand_range
	pop	af
	ld	a, l
	add	a, #0x0a
	ld	-3 (ix), a
;src/generators.c:123: strn    = 9 + rand_range (1, 4);
	ld	hl, #0x0401
	push	hl
	call	_rand_range
	pop	af
	ld	a, l
	add	a, #0x09
	ld	-1 (ix), a
;src/generators.c:124: def     = 9 + rand_range (1, 4);
	ld	hl, #0x0401
	push	hl
	call	_rand_range
	pop	af
	ld	a, l
	add	a, #0x09
	ld	-2 (ix), a
;src/generators.c:125: ref     = 9 + rand_range (1, 4);
	ld	hl, #0x0401
	push	hl
	call	_rand_range
	pop	af
	ld	a, l
	add	a, #0x09
	ld	e, a
;src/generators.c:126: dex     = 9 + rand_range (1, 4);
	push	de
	ld	hl, #0x0401
	push	hl
	call	_rand_range
	pop	af
	pop	de
	ld	a, l
	add	a, #0x09
	ld	d, a
;src/generators.c:137: item_create (false),
	push	de
	xor	a, a
	push	af
	inc	sp
	call	_item_create
	inc	sp
	ld	c, l
	ld	b, h
	pop	de
;src/generators.c:136: &inv_player,
;src/generators.c:133: max_hp, 0, strn, def, ref, dex, 1, 6,
	push	bc
	ld	hl, #_kill_player
	push	hl
	ld	hl, #0x0601
	push	hl
	push	de
	inc	sp
	ld	d, e
	ld	e, -2 (ix)
	push	de
	ld	a, -1 (ix)
	push	af
	inc	sp
	ld	hl, #0x0000
	push	hl
	ld	a, -3 (ix)
	push	af
	inc	sp
	call	_fighter_create
	ld	iy, #11
	add	iy, sp
	ld	sp, iy
	pop	bc
;src/generators.c:130: PLAYER,
	ld	de, #0x0000
	push	de
	push	bc
	ld	bc, #_inv_player
	push	bc
	ld	bc, #0x0000
	push	bc
	push	hl
	ld	hl, #0x0000
	push	hl
	xor	a, a
	push	af
	inc	sp
	call	_entity_create
	ld	iy, #13
	add	iy, sp
	ld	sp, iy
	ld	c, l
	ld	b, h
;src/generators.c:140: remove_from_world(e);
	push	bc
	push	bc
	call	_remove_from_world
	pop	af
	pop	bc
;src/generators.c:141: e->xp_level = 1;
	ld	hl, #0x0006
	add	hl, bc
	ld	(hl), #0x01
;src/generators.c:143: return e;
	ld	l, c
	ld	h, b
	ld	sp, ix
	pop	ix
	ret
;src/generators.c:149: struct TEntity *gen_mob (enum Etype entity_type, i8 x, i8 y)
;	---------------------------------
; Function gen_mob
; ---------------------------------
_gen_mob::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-8
	add	hl, sp
	ld	sp, hl
;src/generators.c:155: if (entity_type == ERANDOM) {
	ld	a, 4 (ix)
	sub	a, #0x12
	jr	NZ,00106$
;src/generators.c:157: if (!(dungeon_lvl&3)) {
	ld	a,(#_dungeon_lvl + 0)
	and	a, #0x03
	jr	NZ,00104$
;src/generators.c:158: hardest_mob_in_level += 1;
	ld	iy, #_hardest_mob_in_level
	inc	0 (iy)
;src/generators.c:159: if (hardest_mob_in_level > LAST_MOB) hardest_mob_in_level = LAST_MOB;
	ld	a, #0x05
	sub	a, 0 (iy)
	jr	NC,00104$
	ld	0 (iy), #0x05
00104$:
;src/generators.c:161: entity_type = rand_range (FIRST_MOB, hardest_mob_in_level);
	ld	a, (_hardest_mob_in_level)
	ld	d,a
	ld	e,#0x01
	push	de
	call	_rand_range
	pop	af
	ld	4 (ix), l
00106$:
;src/generators.c:164: mob_info_id = entity_type - FIRST_MOB;
	ld	e, 4 (ix)
	dec	e
;src/generators.c:180: basic_ai_create (), NULL, NULL, NULL
	push	de
	call	_basic_ai_create
	ld	-3 (ix), h
	ld	-4 (ix), l
	pop	de
;src/generators.c:177: mob_info[mob_info_id].max_dmg,
	ld	bc, #_mob_info+0
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl,bc
	ld	c, l
	ld	b, h
	push	bc
	pop	iy
	ld	a, 8 (iy)
	ld	-8 (ix), a
;src/generators.c:176: mob_info[mob_info_id].min_dmg,
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
;src/generators.c:175: mob_info[mob_info_id].dex,
	push	bc
	pop	iy
	ld	a, 6 (iy)
	ld	-6 (ix), a
;src/generators.c:174: mob_info[mob_info_id].ref,
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-7 (ix), a
;src/generators.c:173: mob_info[mob_info_id].def,
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-5 (ix), a
;src/generators.c:172: mob_info[mob_info_id].strn,
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	d, (hl)
;src/generators.c:171: mob_info[mob_info_id].xp,
	ld	l, c
	ld	h, b
	inc	hl
	ld	a, (hl)
	ld	-2 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
;src/generators.c:170: mob_info[mob_info_id].hp,
	ld	a, (bc)
	ld	b, a
	ld	hl, #_kill_mob
	push	hl
	ld	a, -8 (ix)
	push	af
	inc	sp
	ld	a, e
	push	af
	inc	sp
	ld	h, -6 (ix)
	ld	l, -7 (ix)
	push	hl
	ld	a, -5 (ix)
	push	af
	inc	sp
	push	de
	inc	sp
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	push	bc
	inc	sp
	call	_fighter_create
	ld	iy, #11
	add	iy, sp
	ld	sp, iy
;src/generators.c:167: entity_type,
	ld	bc, #0x0000
	push	bc
	ld	bc, #0x0000
	push	bc
	ld	bc, #0x0000
	push	bc
	ld	c,-4 (ix)
	ld	b,-3 (ix)
	push	bc
	push	hl
	ld	h, 6 (ix)
	ld	l, 5 (ix)
	push	hl
	ld	a, 4 (ix)
	push	af
	inc	sp
	call	_entity_create
	ld	iy, #13
	add	iy, sp
	ld	sp, iy
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
