;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module input
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _draw_inventory
	.globl _log_msg_ext
	.globl _use_stairs
	.globl _use
	.globl _drop
	.globl _pick_up
	.globl _get_stairs_at
	.globl _get_item_at
	.globl _cpct_isAnyKeyPressed_f
	.globl _cpct_isKeyPressed
	.globl _cpct_scanKeyboard
	.globl _handle_keys
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/input.c:36: enum TAction handle_keys (i8 *dx, i8 *dy)
;	---------------------------------
; Function handle_keys
; ---------------------------------
_handle_keys::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/input.c:41: cpct_scanKeyboard();
	call	_cpct_scanKeyboard
;src/input.c:44: if (cpct_isKeyPressed (Key_CursorUp) || cpct_isKeyPressed (Key_Q)) {
	ld	hl, #0x0100
	call	_cpct_isKeyPressed
	ld	c, l
;src/input.c:45: *dx = 0; *dy = -1;
	ld	l,4 (ix)
	ld	h,5 (ix)
	ld	e,6 (ix)
	ld	d,7 (ix)
;src/input.c:44: if (cpct_isKeyPressed (Key_CursorUp) || cpct_isKeyPressed (Key_Q)) {
	ld	a, c
	or	a, a
	jr	NZ,00101$
	push	hl
	push	de
	ld	hl, #0x0808
	call	_cpct_isKeyPressed
	ld	a, l
	pop	de
	pop	hl
	or	a, a
	jr	Z,00102$
00101$:
;src/input.c:45: *dx = 0; *dy = -1;
	ld	(hl), #0x00
	ld	a, #0xff
	ld	(de), a
;src/input.c:46: fov_changed = true;
	ld	hl,#_fov_changed + 0
	ld	(hl), #0x01
;src/input.c:47: return PLAYER_MOVE;
	ld	l, #0x01
	jp	00136$
00102$:
;src/input.c:51: if (cpct_isKeyPressed (Key_CursorDown) || cpct_isKeyPressed (Key_A)) {
	push	hl
	push	de
	ld	hl, #0x0400
	call	_cpct_isKeyPressed
	ld	a, l
	pop	de
	pop	hl
	or	a, a
	jr	NZ,00104$
	push	hl
	push	de
	ld	hl, #0x2008
	call	_cpct_isKeyPressed
	ld	a, l
	pop	de
	pop	hl
	or	a, a
	jr	Z,00105$
00104$:
;src/input.c:52: *dx = 0; *dy = 1;
	ld	(hl), #0x00
	ld	a, #0x01
	ld	(de), a
;src/input.c:53: fov_changed = true;
	ld	hl,#_fov_changed + 0
	ld	(hl), #0x01
;src/input.c:54: return PLAYER_MOVE;
	ld	l, #0x01
	jp	00136$
00105$:
;src/input.c:58: if (cpct_isKeyPressed (Key_CursorLeft) || cpct_isKeyPressed (Key_O)) {
	push	hl
	push	de
	ld	hl, #0x0101
	call	_cpct_isKeyPressed
	ld	a, l
	pop	de
	pop	hl
	or	a, a
	jr	NZ,00107$
	push	hl
	push	de
	ld	hl, #0x0404
	call	_cpct_isKeyPressed
	ld	a, l
	pop	de
	pop	hl
	or	a, a
	jr	Z,00108$
00107$:
;src/input.c:59: *dx = -1; *dy = 0;
	ld	(hl), #0xff
	xor	a, a
	ld	(de), a
;src/input.c:60: fov_changed = true;
	ld	hl,#_fov_changed + 0
	ld	(hl), #0x01
;src/input.c:61: return PLAYER_MOVE;
	ld	l, #0x01
	jp	00136$
00108$:
;src/input.c:65: if (cpct_isKeyPressed (Key_CursorRight) || cpct_isKeyPressed (Key_P)) {
	push	hl
	push	de
	ld	hl, #0x0200
	call	_cpct_isKeyPressed
	ld	a, l
	pop	de
	pop	hl
	or	a, a
	jr	NZ,00110$
	push	hl
	push	de
	ld	hl, #0x0803
	call	_cpct_isKeyPressed
	ld	a, l
	pop	de
	pop	hl
	or	a, a
	jr	Z,00111$
00110$:
;src/input.c:66: *dx = 1; *dy = 0;
	ld	(hl), #0x01
	xor	a, a
	ld	(de), a
;src/input.c:67: fov_changed = true;
	ld	hl,#_fov_changed + 0
	ld	(hl), #0x01
;src/input.c:68: return PLAYER_MOVE;
	ld	l, #0x01
	jp	00136$
00111$:
;src/input.c:72: if (cpct_isKeyPressed (Key_S)) {
	ld	hl, #0x1007
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00114$
;src/input.c:73: fov_changed = true;
	ld	hl,#_fov_changed + 0
	ld	(hl), #0x01
;src/input.c:74: return PLAYER_WAIT;
	ld	l, #0x02
	jp	00136$
00114$:
;src/input.c:79: if (cpct_isKeyPressed (Key_G)) {
	ld	hl, #0x1006
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00118$
;src/input.c:80: struct TEntity *entity = get_item_at (player->x, player->y);
	ld	de, (_player)
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	ld	b, (hl)
	ex	de,hl
	inc	hl
	ld	c, (hl)
	push	bc
	call	_get_item_at
	pop	af
	ld	c, l
;src/input.c:82: if (entity) {
	ld	a,h
	ld	b,a
	or	a,l
	jr	Z,00118$
;src/input.c:83: pick_up (entity->item, player);
	ld	l, c
	ld	h, b
	ld	de, #0x000d
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	hl, (_player)
	push	hl
	push	bc
	call	_pick_up
	pop	af
	pop	af
00118$:
;src/input.c:90: if (cpct_isKeyPressed (Key_D)) {
	ld	hl, #0x2007
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00122$
;src/input.c:80: struct TEntity *entity = get_item_at (player->x, player->y);
	ld	de, (_player)
;src/input.c:91: if (player->container->num_items > 0) {
	ld	hl, #0x000b
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	hl, #0x0022
	add	hl, bc
	ld	a, (hl)
	ld	-2 (ix), a
	or	a, a
	jr	Z,00122$
;src/input.c:93: player->x, player->y);
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
	ex	de,hl
	inc	hl
	ld	e, (hl)
;src/input.c:92: drop (player->container->inventory[player->container->num_items-1]->item,
	inc	bc
	inc	bc
	ld	l, -2 (ix)
	dec	l
	sla	l
	ld	h,#0x00
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, c
	ld	bc, #0x000d
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	d, -1 (ix)
	push	de
	push	bc
	call	_drop
	pop	af
	pop	af
00122$:
;src/input.c:98: if (cpct_isKeyPressed (Key_I)) {
	ld	hl, #0x0804
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00124$
;src/input.c:99: draw_inventory();
	call	_draw_inventory
00124$:
;src/input.c:103: if (cpct_isKeyPressed (Key_U)) {
	ld	hl, #0x0405
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00128$
;src/input.c:80: struct TEntity *entity = get_item_at (player->x, player->y);
	ld	hl, (_player)
;src/input.c:91: if (player->container->num_items > 0) {
	ld	de, #0x000b
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	pop	iy
	ld	e, 34 (iy)
;src/input.c:104: if (player->container->num_items > 0) {
	ld	a, e
	or	a, a
	jr	Z,00128$
;src/input.c:106: e= player->container->inventory[player->container->num_items-1];
	inc	bc
	inc	bc
	dec	e
	sla	e
	ld	l,e
	ld	h,#0x00
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	h, (hl)
;src/input.c:107: use (e->item);
	ld	l, c
	ld	de, #0x000d
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	call	_use
	pop	af
00128$:
;src/input.c:112: if (cpct_isKeyPressed (Key_Dot)) {
	ld	hl, #0x8003
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	jr	Z,00133$
;src/input.c:80: struct TEntity *entity = get_item_at (player->x, player->y);
	ld	bc, (_player)
;src/input.c:113: struct TEntity *e = get_stairs_at (player->x, player->y);
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, b
	inc	hl
	ld	e, (hl)
	push	de
	call	_get_stairs_at
	pop	af
	push	hl
	pop	iy
;src/input.c:114: if (e)
	ld	a, h
	or	a,l
	jr	Z,00130$
;src/input.c:115: use_stairs (e->stairs);
	ld	c, 15 (iy)
	ld	b, 16 (iy)
	push	bc
	call	_use_stairs
	pop	af
	jr	00133$
00130$:
;src/input.c:117: log_msg_ext ("\477\11\10No stairs to use!");
	ld	hl, #___str_0
	push	hl
	call	_log_msg_ext
	pop	af
00133$:
;src/input.c:121: if (cpct_isAnyKeyPressed_f())
	call	_cpct_isAnyKeyPressed_f
	ld	c, l
	ld	a, c
	or	a, a
	jp	Z, 00135$
;src/input.c:122: cpctm_produceHalts (50);
	.rept 50 
	halt 
	.endm 
00135$:
;src/input.c:123: return NONE;
	ld	l, #0x00
00136$:
	ld	sp, ix
	pop	ix
	ret
___str_0:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "No stairs to use!"
	.db 0x00
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
