;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module orutrix
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _display_text_lines
	.globl _wait_for_key
	.globl _log_msg_ext
	.globl _clr_log
	.globl _cpct_setPalette
	.globl _cpct_drawStringM1_f
	.globl _cpct_memset_f64
	.globl _ending
	.globl _happy_ending_palette
	.globl _use_orutrix
	.globl _happy_ending
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/orutrix.c:46: void use_orutrix (struct TEntity *target, u8 value)
;	---------------------------------
; Function use_orutrix
; ---------------------------------
_use_orutrix::
	push	ix
;src/orutrix.c:52: clr_log();
	call	_clr_log
;src/orutrix.c:53: log_msg_ext ("\477\11\12You use the ORUTRIX");
	ld	hl, #___str_0
	push	hl
	call	_log_msg_ext
	pop	af
;src/orutrix.c:57: (void*)(VMEM_LOG+num_messages*0x50),
	ld	bc, (_num_messages)
	ld	b, #0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	bc, #0xc642
	add	hl, bc
;src/orutrix.c:56: cpct_drawStringM1_f ("Press [SPACE] to continue",
	ld	bc, #___str_1+0
	ld	de, #0x0100
	push	de
	push	hl
	push	bc
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/orutrix.c:60: wait_for_key (Key_Space);
	ld	hl, #0x8005
	push	hl
	call	_wait_for_key
	pop	af
;src/orutrix.c:63: game_running  = false;
	ld	hl,#_game_running + 0
	ld	(hl), #0x00
;src/orutrix.c:64: orutrix_found = true;
	ld	hl,#_orutrix_found + 0
	ld	(hl), #0x01
	pop	ix
	ret
_happy_ending_palette:
	.db #0x14	; 20
	.db #0x03	; 3
	.db #0x0b	; 11
	.db #0x13	; 19
_ending:
	.dw __str_2
	.db #0x01	; 1
	.db #0x01	; 1
	.db #0x03	; 3
	.db #0x00	; 0
	.dw __str_3
	.db #0x01	; 1
	.db #0x02	; 2
	.db #0x03	; 3
	.db #0x00	; 0
	.dw __str_4
	.db #0x01	; 1
	.db #0x03	; 3
	.db #0x03	; 3
	.db #0x00	; 0
	.dw __str_5
	.db #0x01	; 1
	.db #0x04	; 4
	.db #0x03	; 3
	.db #0x00	; 0
	.dw __str_6
	.db #0x01	; 1
	.db #0x05	; 5
	.db #0x03	; 3
	.db #0x00	; 0
	.dw __str_7
	.db #0x01	; 1
	.db #0x06	; 6
	.db #0x03	; 3
	.db #0x00	; 0
	.dw __str_8
	.db #0x01	; 1
	.db #0x08	; 8
	.db #0x03	; 3
	.db #0x00	; 0
	.dw __str_9
	.db #0x01	; 1
	.db #0x09	; 9
	.db #0x03	; 3
	.db #0x00	; 0
	.dw __str_10
	.db #0x01	; 1
	.db #0x0a	; 10
	.db #0x03	; 3
	.db #0x00	; 0
	.dw __str_11
	.db #0x01	; 1
	.db #0x0b	; 11
	.db #0x03	; 3
	.db #0x00	; 0
	.dw __str_12
	.db #0x01	; 1
	.db #0x0c	; 12
	.db #0x03	; 3
	.db #0x00	; 0
	.dw __str_13
	.db #0x07	; 7
	.db #0x0f	; 15
	.db #0x01	; 1
	.db #0x00	; 0
___str_0:
	.ascii "?"
	.db 0x09
	.db 0x0a
	.ascii "You use the ORUTRIX"
	.db 0x00
___str_1:
	.ascii "Press [SPACE] to continue"
	.db 0x00
__str_2:
	.ascii "Without thinking about it your fingers"
	.db 0x00
__str_3:
	.ascii "start to tap the Orutrix in a special"
	.db 0x00
__str_4:
	.ascii "pattern, it's like someone (or"
	.db 0x00
__str_5:
	.ascii "something) is guiding your actions."
	.db 0x00
__str_6:
	.ascii "Suddenly, your eyes feel heavy and"
	.db 0x00
__str_7:
	.ascii "everything fades to black."
	.db 0x00
__str_8:
	.ascii "When you wake up you need to cover your"
	.db 0x00
__str_9:
	.ascii "eyes from the overwhelming burst of"
	.db 0x00
__str_10:
	.ascii "light that's coming from the Sun. But"
	.db 0x00
__str_11:
	.ascii "you welcome that intense light because"
	.db 0x00
__str_12:
	.ascii "it means you are out of the dungeon."
	.db 0x00
__str_13:
	.ascii "Congratulations!"
	.db 0x00
;src/orutrix.c:68: void happy_ending()
;	---------------------------------
; Function happy_ending
; ---------------------------------
_happy_ending::
;src/orutrix.c:70: cpct_setPalette (happy_ending_palette, 4);
	ld	hl, #0x0004
	push	hl
	ld	hl, #_happy_ending_palette
	push	hl
	call	_cpct_setPalette
;src/conio.h:28: cpct_clearScreen_f64 (0x0000);
	ld	hl, #0x4000
	push	hl
	ld	h, #0x00
	push	hl
	ld	h, #0xc0
	push	hl
	call	_cpct_memset_f64
;src/orutrix.c:72: display_text_lines (ending, NUM_ENDING_LINES);
	ld	a, #0x0c
	push	af
	inc	sp
	ld	hl, #_ending
	push	hl
	call	_display_text_lines
	pop	af
	inc	sp
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
