//-----------------------------LICENSE NOTICE--------------------------------
//  This file is part of CPCRogue: An Amstrad CPC rogue like game
//  Copyright (C) 2019 Andrés Mata Bretón (@FlautinesMata)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------------------------
#include <cpctelera.h>
#include "conio.h"
#include "credits.h"
#include "consts.h"

const u8 credits_palette[] = {
// \x1C: INK
// \xAA: PEN
// \xBB: COLOR 1
// \xCC: COLOR 2
0,0,0,    // BLACK
1,15,15,  // ORANGE
2,26,26,  // BRIGHT WHITE
3,25,25,  // BRIGHT YELLOW
};


const TTextLine credits[] = {
  // Text, x,y, fg_color, bg_color
  {" CPCRogue ", 14,6, 0,3},
  {"Created by", 14,8, 1,0},
  {"Andres Mata", 13,10, 2,0},
  {"for CPCRetrodev 2019", 9,12, 1,0},
};
//---------------------------------------------------------------------------
void display_credits()
{
  fw_set_palette (credits_palette);
  fw_set_border (0);
  display_text_lines (credits, NUM_CREDITS_LINES);
}