//-----------------------------LICENSE NOTICE--------------------------------
//  This file is part of CPCRogue: An Amstrad CPC rogue like game
//  Copyright (C) 2019 Andrés Mata Bretón (@FlautinesMata)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------------------------
typedef struct TEntity;

void draw_game        (bool needs_redraw);
void draw_map         ();
void draw_tile        (i8 x, i8 y);
void entity_draw      (struct TEntity *e);
void draw_player_hp   ();
void draw_player_strn ();
void draw_player_def  ();
void draw_player_ref  ();
void draw_player_dex  ();
void draw_player_hungry(bool clear);
void draw_stats       ();
void draw_text_ext    (char *msg, void *vmem, u8 fg_color, u8 bg_color);
void draw_inventory   ();