;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module container
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _cpct_memcpy
	.globl _cpct_memset
	.globl _init_container
	.globl _append_to_container
	.globl _remove_from_container
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/components/container.c:11: void init_container (struct TContainer *container) {
;	---------------------------------
; Function init_container
; ---------------------------------
_init_container::
;src/components/container.c:12: cpct_memset (container, 0, sizeof(struct TContainer));
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x0026
	push	hl
	xor	a, a
	push	af
	inc	sp
	push	bc
	call	_cpct_memset
	ret
;src/components/container.c:15: void append_to_container (
;	---------------------------------
; Function append_to_container
; ---------------------------------
_append_to_container::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/components/container.c:22: container->inventory[container->num_items++] = entity;
	ld	e,4 (ix)
	ld	d,5 (ix)
	ld	c, e
	ld	b, d
	inc	bc
	inc	bc
	ld	hl, #0x0022
	add	hl, de
	ld	e, (hl)
	ld	d, e
	inc	d
	ld	(hl), d
	sla	e
	ld	l,e
	ld	h,#0x00
	add	hl, bc
	ld	a, 6 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 7 (ix)
	ld	(hl), a
	pop	ix
	ret
;src/components/container.c:25: void remove_from_container (struct TContainer *container,
;	---------------------------------
; Function remove_from_container
; ---------------------------------
_remove_from_container::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-8
	add	hl, sp
	ld	sp, hl
;src/components/container.c:29: bool found = false;
	ld	-7 (ix), #0x00
;src/components/container.c:31: for (i=0; i<container->num_items; ++i) {
	ld	-1 (ix), #0x00
	ld	c,4 (ix)
	ld	b,5 (ix)
	ld	hl, #0x0022
	add	hl,bc
	ex	de,hl
	ld	-8 (ix), #0x00
00107$:
	ld	a, (de)
	ld	-4 (ix), a
;src/components/container.c:32: if (container->inventory[i] == entity) {
	ld	hl, #0x0002
	add	hl,bc
	ld	-3 (ix), l
	ld	-2 (ix), h
;src/components/container.c:31: for (i=0; i<container->num_items; ++i) {
	ld	a, -8 (ix)
	sub	a, -4 (ix)
	jr	NC,00103$
;src/components/container.c:32: if (container->inventory[i] == entity) {
	ld	a, -8 (ix)
	add	a, a
	ld	l, a
	ld	a, -3 (ix)
	add	a, l
	ld	l, a
	ld	a, -2 (ix)
	adc	a, #0x00
	ld	h, a
	ld	a, (hl)
	ld	-6 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-5 (ix), a
	ld	a, 6 (ix)
	sub	a, -6 (ix)
	jr	NZ,00108$
	ld	a, 7 (ix)
	sub	a, -5 (ix)
	jr	NZ,00108$
;src/components/container.c:33: found = true;
	ld	-7 (ix), #0x01
;src/components/container.c:34: break;
	jr	00103$
00108$:
;src/components/container.c:31: for (i=0; i<container->num_items; ++i) {
	inc	-8 (ix)
	ld	a, -8 (ix)
	ld	-1 (ix), a
	jr	00107$
00103$:
;src/components/container.c:37: if (found) {
	bit	0, -7 (ix)
	jr	Z,00109$
;src/components/container.c:39: &container->inventory[--container->num_items], 2);
	ld	c, -4 (ix)
	dec	c
	ld	a, c
	ld	(de), a
	sla	c
	ld	a, -3 (ix)
	add	a, c
	ld	c, a
	ld	a, -2 (ix)
	adc	a, #0x00
	ld	b, a
;src/components/container.c:38: cpct_memcpy (&container->inventory[i],
	ld	a, -1 (ix)
	add	a, a
	ld	e, a
	ld	l,-3 (ix)
	ld	h,-2 (ix)
	ld	d, #0x00
	add	hl, de
	ld	de, #0x0002
	push	de
	push	bc
	push	hl
	call	_cpct_memcpy
00109$:
	ld	sp, ix
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
