;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module stairs
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _transition_next
	.globl _transition_previous
	.globl _cpct_memset
	.globl _plast_stairs
	.globl _num_stairs
	.globl _stairs_list
	.globl _init_stairs
	.globl _stairs_create
	.globl _use_stairs
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_stairs_list::
	.ds 6
_num_stairs::
	.ds 1
_plast_stairs::
	.ds 2
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/components/stairs.c:30: void init_stairs() {
;	---------------------------------
; Function init_stairs
; ---------------------------------
_init_stairs::
;src/components/stairs.c:31: cpct_memset (stairs_list, 0x0, sizeof (stairs_list));
	ld	hl, #0x0006
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	hl, #_stairs_list
	push	hl
	call	_cpct_memset
;src/components/stairs.c:32: num_stairs = 0;
	ld	hl,#_num_stairs + 0
	ld	(hl), #0x00
;src/components/stairs.c:33: plast_stairs = stairs_list;
	ld	hl, #_stairs_list
	ld	(_plast_stairs), hl
	ret
;src/components/stairs.c:37: struct TStairs *stairs_create (bool downwards)
;	---------------------------------
; Function stairs_create
; ---------------------------------
_stairs_create::
;src/components/stairs.c:39: struct TStairs *stairs = NULL;
	ld	bc, #0x0000
;src/components/stairs.c:41: if (num_stairs < MAX_STAIRS)
	ld	iy, #_num_stairs
	ld	a, 0 (iy)
	sub	a, #0x02
	jr	NC,00102$
;src/components/stairs.c:45: stairs = plast_stairs++;
	ld	bc, (_plast_stairs)
	ld	hl, #_plast_stairs
	ld	a, (hl)
	add	a, #0x03
	ld	(hl), a
	inc	hl
	ld	a, (hl)
	adc	a, #0x00
	ld	(hl), a
;src/components/stairs.c:46: num_stairs++;
	inc	0 (iy)
;src/components/stairs.c:47: stairs->downwards = downwards;
	ld	e, c
	ld	d, b
	inc	de
	inc	de
	ld	hl, #2+0
	add	hl, sp
	ld	a, (hl)
	ld	(de), a
00102$:
;src/components/stairs.c:50: return stairs;
	ld	l, c
	ld	h, b
	ret
;src/components/stairs.c:53: void use_stairs (struct TStairs *stairs)
;	---------------------------------
; Function use_stairs
; ---------------------------------
_use_stairs::
;src/components/stairs.c:55: if (stairs->downwards)
	pop	bc
	pop	hl
	push	hl
	push	bc
	inc	hl
	inc	hl
	ld	a, (hl)
	or	a, a
;src/components/stairs.c:56: transition_next();
	jp	NZ,_transition_next
;src/components/stairs.c:58: transition_previous();
	jp  _transition_previous
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
