;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module conio
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _strlen
	.globl _strtok
	.globl _putchar
	.globl _getchar
	.globl _cpct_getScreenPtr
	.globl _cpct_drawStringM1_f
	.globl _cpct_drawCharM1_f
	.globl _cpct_isKeyPressed
	.globl _cpct_scanKeyboard
	.globl _cpct_memset
	.globl _num_messages
	.globl _clr_log
	.globl _clr_stats
	.globl _clr_map
	.globl _clrwin
	.globl _putchar_f
	.globl _log_msg_ext
	.globl _press_any_key_cont
	.globl _wait_for_key
	.globl _get_string
	.globl _display_text_lines
	.globl _get_center
	.globl _fw_set_palette
	.globl _fw_set_border
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_num_messages::
	.ds 1
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/conio.c:30: void clr_log() {
;	---------------------------------
; Function clr_log
; ---------------------------------
_clr_log::
;src/conio.c:31: clrwin ((void*)VMEM_LOG, LOG_W, 5, DEFAULT_BG);
	ld	hl, #0x0005
	push	hl
	ld	a, #0x4c
	push	af
	inc	sp
	ld	hl, #0xc642
	push	hl
	call	_clrwin
	pop	af
	pop	af
	inc	sp
	ret
;src/conio.c:34: void clr_stats() {
;	---------------------------------
; Function clr_stats
; ---------------------------------
_clr_stats::
;src/conio.c:35: clrwin ((void*)VMEM_STATS_XP, STATS_W, 12, DEFAULT_BG);
	ld	hl, #0x000c
	push	hl
	ld	a, #0x14
	push	af
	inc	sp
	ld	hl, #0xc0da
	push	hl
	call	_clrwin
	pop	af
	pop	af
	inc	sp
	ret
;src/conio.c:38: void clr_map() {
;	---------------------------------
; Function clr_map
; ---------------------------------
_clr_map::
;src/conio.c:39: clrwin ((void*)VMEM_MAP, VMAP_WIDTH, VMAP_HEIGHT, DEFAULT_BG);
	ld	hl, #0x0012
	push	hl
	ld	a, #0x38
	push	af
	inc	sp
	ld	hl, #0xc052
	push	hl
	call	_clrwin
	pop	af
	pop	af
	inc	sp
	ret
;src/conio.c:52: void clrwin (u8 *pvmem_start, u8 cols, u8 rows, u8 color)
;	---------------------------------
; Function clrwin
; ---------------------------------
_clrwin::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/conio.c:54: for (u8 i=0; i != rows; ++i) {
	ld	c, #0x00
00107$:
	ld	a, 7 (ix)
	sub	a, c
	jr	Z,00102$
;src/conio.c:55: for (u8 line=0; line != 8; ++line) {
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	b, l
	ld	e, h
	ld	a, 4 (ix)
	add	a, b
	ld	-2 (ix), a
	ld	a, 5 (ix)
	adc	a, e
	ld	-1 (ix), a
	ld	b, #0x00
00104$:
	ld	a, b
	sub	a, #0x08
	jr	Z,00108$
;src/conio.c:56: cpct_memset (pvmem_start+i*0x50+line*0x800, color, cols);
	ld	l, 6 (ix)
	ld	h, #0x00
	ld	a, b
	rlca
	rlca
	rlca
	and	a, #0xf8
	ld	d, a
	ld	e, #0x00
	ld	a, -2 (ix)
	add	a, e
	ld	e, a
	ld	a, -1 (ix)
	adc	a, d
	ld	d, a
	push	bc
	push	hl
	ld	a, 8 (ix)
	push	af
	inc	sp
	push	de
	call	_cpct_memset
	pop	bc
;src/conio.c:55: for (u8 line=0; line != 8; ++line) {
	inc	b
	jr	00104$
00108$:
;src/conio.c:54: for (u8 i=0; i != rows; ++i) {
	inc	c
	jr	00107$
00102$:
;src/conio.c:59: num_messages = 0;
	ld	hl,#_num_messages + 0
	ld	(hl), #0x00
	ld	sp, ix
	pop	ix
	ret
;src/conio.c:72: void putchar_f (void *pvmem_start, u8 x, u8 y, u8 ch, u8 fg_pen, u8 bg_pen)
;	---------------------------------
; Function putchar_f
; ---------------------------------
_putchar_f::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/conio.c:74: void *pvdest = cpct_getScreenPtr (pvmem_start, x*2, y*8);
	ld	a, 7 (ix)
	rlca
	rlca
	rlca
	and	a, #0xf8
	ld	d, a
	ld	a, 6 (ix)
	add	a, a
	ld	e,a
	push	de
	ld	l,4 (ix)
	ld	h,5 (ix)
	push	hl
	call	_cpct_getScreenPtr
	ld	c, l
	ld	b, h
;src/conio.c:76: cpct_drawCharM1_f (pvdest, fg_pen, bg_pen, ch);
	ld	h, 8 (ix)
	ld	l, 10 (ix)
	push	hl
	ld	a, 9 (ix)
	push	af
	inc	sp
	push	bc
	call	_cpct_drawCharM1_f
	pop	af
	pop	af
	inc	sp
	pop	ix
	ret
;src/conio.c:79: void log_msg_ext (char *text) {
;	---------------------------------
; Function log_msg_ext
; ---------------------------------
_log_msg_ext::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	dec	sp
;src/conio.c:81: u8 fg, bg, col=0;
	ld	-3 (ix), #0x00
;src/conio.c:83: pch=strtok (text,"\477");
	ld	hl, #___str_0
	push	hl
	ld	l,4 (ix)
	ld	h,5 (ix)
	push	hl
	call	_strtok
	pop	af
	pop	af
	ld	c, l
	ld	b, h
;src/conio.c:85: while (pch != NULL) {
00101$:
	ld	a, b
	or	a,c
	jr	Z,00103$
;src/conio.c:86: fg = *pch++;
	ld	a, (bc)
	ld	e, a
	inc	bc
;src/conio.c:87: bg = *pch++;
	ld	a, (bc)
	ld	l, a
	inc	bc
;src/conio.c:88: fg -= 8;
	ld	a, e
	add	a, #0xf8
	ld	-1 (ix), a
;src/conio.c:89: bg -= 8;
	ld	a, l
	add	a, #0xf8
	ld	-2 (ix), a
;src/conio.c:90: cpct_drawStringM1_f (pch, (void*)(VMEM_LOG+num_messages*0x50+col),
	ld	de, (_num_messages)
	ld	d, #0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	de, #0xc642
	add	hl, de
	ld	e, -3 (ix)
	ld	d, #0x00
	add	hl,de
	ex	de,hl
	push	bc
	ld	h, -2 (ix)
	ld	l, -1 (ix)
	push	hl
	push	de
	push	bc
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	call	_strlen
	pop	af
	sla	l
	ld	a, -3 (ix)
	add	a, l
	ld	-3 (ix), a
;src/conio.c:93: pch = strtok (NULL, "\477");
	ld	hl, #___str_0
	push	hl
	ld	hl, #0x0000
	push	hl
	call	_strtok
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	jr	00101$
00103$:
;src/conio.c:95: num_messages++;
	ld	iy, #_num_messages
	inc	0 (iy)
;src/conio.c:96: if (num_messages > 3) {
	ld	a, #0x03
	sub	a, 0 (iy)
	jr	NC,00106$
;src/conio.c:98: (void*)(VMEM_LOG+num_messages*0x50),
	ld	bc, (_num_messages)
	ld	b, #0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	bc, #0xc642
	add	hl, bc
;src/conio.c:97: cpct_drawStringM1_f ("Press [SPACE] to continue",
	ld	bc, #___str_1+0
	ld	de, #0x0100
	push	de
	push	hl
	push	bc
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/conio.c:102: wait_for_key (Key_Space);
	ld	hl, #0x8005
	push	hl
	call	_wait_for_key
	pop	af
;src/conio.c:105: clr_log();
	call	_clr_log
00106$:
	ld	sp, ix
	pop	ix
	ret
___str_0:
	.ascii "?"
	.db 0x00
___str_1:
	.ascii "Press [SPACE] to continue"
	.db 0x00
;src/conio.c:109: void press_any_key_cont() {
;	---------------------------------
; Function press_any_key_cont
; ---------------------------------
_press_any_key_cont::
;src/conio.c:110: void *pvmem = cpct_getScreenPtr (CPCT_VMEM_START, 5*2, 23*8);
	ld	hl, #0xb80a
	push	hl
	ld	hl, #0xc000
	push	hl
	call	_cpct_getScreenPtr
;src/conio.c:111: cpct_drawStringM1_f ("Press [SPACE] to continue", pvmem, 2,0);
	ld	bc, #___str_2+0
	ld	de, #0x0002
	push	de
	push	hl
	push	bc
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/conio.c:113: cpct_memset (cpct_keyboardStatusBuffer, 0, sizeof (cpct_keyboardStatusBuffer));
	ld	hl, #0x000a
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	hl, #_cpct_keyboardStatusBuffer
	push	hl
	call	_cpct_memset
;src/conio.c:116: wait_for_key (Key_Space);
	ld	hl, #0x8005
	push	hl
	call	_wait_for_key
	pop	af
	ret
___str_2:
	.ascii "Press [SPACE] to continue"
	.db 0x00
;src/conio.c:119: void wait_for_key(cpct_keyID key) {
;	---------------------------------
; Function wait_for_key
; ---------------------------------
_wait_for_key::
;src/conio.c:121: cpct_scanKeyboard();
	call	_cpct_scanKeyboard
;src/conio.c:122: while (!cpct_isKeyPressed(key)) {
00101$:
	pop	bc
	pop	hl
	push	hl
	push	bc
	call	_cpct_isKeyPressed
	ld	a, l
	or	a, a
	ret	NZ
;src/conio.c:123: cpct_scanKeyboard();
	call	_cpct_scanKeyboard
	jr	00101$
;src/conio.c:127: char *get_string (char *str, u8 x, u8 y, u8 fg_color, u8 bg_color)
;	---------------------------------
; Function get_string
; ---------------------------------
_get_string::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	dec	sp
;src/conio.c:130: retstr = str;
	ld	a, 4 (ix)
	ld	-3 (ix), a
	ld	a, 5 (ix)
	ld	-2 (ix), a
;src/conio.c:132: while ( (ch = getchar()) != '\r') {
	pop	bc
	push	bc
	ld	e, 6 (ix)
00101$:
	push	bc
	push	de
	call	_getchar
	pop	de
	pop	bc
	ld	a,l
	ld	d,a
	sub	a, #0x0d
	jr	Z,00103$
;src/conio.c:133: *str++ = ch;
	ld	a, d
	ld	(bc), a
	inc	bc
;src/conio.c:134: putchar_f ((void*)0xC000, x++, y, ch, fg_color, bg_color);
	ld	-1 (ix), e
	inc	e
	ld	6 (ix), e
	push	bc
	push	de
	ld	h, 9 (ix)
	ld	l, 8 (ix)
	push	hl
	push	de
	inc	sp
	ld	h, 7 (ix)
	ld	l, -1 (ix)
	push	hl
	ld	hl, #0xc000
	push	hl
	call	_putchar_f
	ld	hl, #7
	add	hl, sp
	ld	sp, hl
	pop	de
	pop	bc
	jr	00101$
00103$:
;src/conio.c:136: *str = '\0';
	xor	a, a
	ld	(bc), a
;src/conio.c:138: return retstr;
	pop	hl
	push	hl
	ld	sp, ix
	pop	ix
	ret
;src/conio.c:141: void display_text_lines (TTextLine text_lines[], u8 nlines)
;	---------------------------------
; Function display_text_lines
; ---------------------------------
_display_text_lines::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;src/conio.c:143: TTextLine *plast_line  = &(text_lines[nlines]);
	ld	c,6 (ix)
	ld	b,#0x00
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	ld	c, l
	ld	b, h
	ld	l,4 (ix)
	ld	h,5 (ix)
	add	hl, bc
	inc	sp
	inc	sp
	push	hl
;src/conio.c:144: TTextLine  *pline = text_lines;
	ld	c,4 (ix)
	ld	b,5 (ix)
;src/conio.c:145: while (pline < plast_line) {
00101$:
	ld	a, c
	sub	a, -4 (ix)
	ld	a, b
	sbc	a, -3 (ix)
	jr	NC,00104$
;src/conio.c:149: pline->bg_color);
	push	bc
	pop	iy
	ld	a, 5 (iy)
	ld	-2 (ix), a
;src/conio.c:148: pline->fg_color,
	push	bc
	pop	iy
	ld	a, 4 (iy)
	ld	-1 (ix), a
;src/conio.c:147: cpct_getScreenPtr ((void*)0xC000, pline->x*2, pline->y*8),
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	rlca
	rlca
	rlca
	and	a, #0xf8
	ld	d, a
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a, (hl)
	add	a, a
	push	bc
	ld	e, a
	push	de
	ld	hl, #0xc000
	push	hl
	call	_cpct_getScreenPtr
	pop	bc
	push	hl
	pop	iy
;src/conio.c:146: cpct_drawStringM1_f (pline->text,
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	ld	h, -2 (ix)
	ld	l, -1 (ix)
	push	hl
	push	iy
	push	de
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	bc
;src/conio.c:150: pline++;
	ld	hl, #0x0006
	add	hl,bc
	ld	c, l
	ld	b, h
	jr	00101$
00104$:
	ld	sp, ix
	pop	ix
	ret
;src/conio.c:154: u8 get_center (u8 startx, u8 width, char *str)
;	---------------------------------
; Function get_center
; ---------------------------------
_get_center::
;src/conio.c:156: return startx + width - strlen (str);
	ld	hl, #3
	add	hl, sp
	ld	iy, #2
	add	iy, sp
	ld	a, 0 (iy)
	add	a, (hl)
	ld	e, a
	ld	hl, #4
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	call	_strlen
	pop	af
	ld	c, l
	ld	a, e
	sub	a, c
	ld	l, a
	ret
;src/conio.c:159: void fw_set_palette (u8 acolors[])
;	---------------------------------
; Function fw_set_palette
; ---------------------------------
_fw_set_palette::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;src/conio.c:162: u8 *data = acolors;
	ld	c,4 (ix)
	ld	b,5 (ix)
;src/conio.c:163: for (u8 i=0; i<4; i++) {
	ld	-1 (ix), #0x00
00103$:
	ld	a, -1 (ix)
	sub	a, #0x04
	jr	NC,00105$
;src/conio.c:164: putchar (0x1C);        // INK CMD
	push	bc
	ld	hl, #0x001c
	push	hl
	call	_putchar
	pop	af
	pop	bc
;src/conio.c:165: putchar (*data++);  // PEN
	ld	a, (bc)
	ld	e, a
	inc	bc
	ld	d, #0x00
	push	bc
	push	de
	call	_putchar
	pop	af
	pop	bc
;src/conio.c:166: putchar (*data++);    // COLOR1
	ld	a, (bc)
	ld	e, a
	inc	bc
	ld	d, #0x00
	push	bc
	push	de
	call	_putchar
	pop	af
	pop	bc
;src/conio.c:167: putchar (*data++);  // COLOR2
	ld	a, (bc)
	ld	e, a
	inc	bc
	ld	d, #0x00
	push	bc
	push	de
	call	_putchar
	pop	af
	pop	bc
;src/conio.c:163: for (u8 i=0; i<4; i++) {
	inc	-1 (ix)
	jr	00103$
00105$:
	inc	sp
	pop	ix
	ret
;src/conio.c:171: void fw_set_border  (u8 bgcolor)
;	---------------------------------
; Function fw_set_border
; ---------------------------------
_fw_set_border::
;src/conio.c:173: putchar (0x1D);
	ld	hl, #0x001d
	push	hl
	call	_putchar
	pop	af
;src/conio.c:174: putchar (bgcolor);
	ld	hl, #2+0
	add	hl, sp
	ld	c, (hl)
	ld	b, #0x00
	push	bc
	push	bc
	call	_putchar
	pop	af
	call	_putchar
	pop	af
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
