;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module draw
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _log_msg_ext
	.globl _putchar_f
	.globl _clr_stats
	.globl _clr_log
	.globl _name
	.globl _sprintf
	.globl _cpct_drawStringM1_f
	.globl _draw_game
	.globl _draw_map
	.globl _draw_tile
	.globl _entity_draw
	.globl _draw_player_hp
	.globl _draw_player_strn
	.globl _draw_player_def
	.globl _draw_player_ref
	.globl _draw_player_dex
	.globl _draw_player_hungry
	.globl _draw_stats
	.globl _draw_inventory
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/draw.c:41: void draw_game(bool needs_redraw) {
;	---------------------------------
; Function draw_game
; ---------------------------------
_draw_game::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-6
	add	hl, sp
	ld	sp, hl
;src/draw.c:49: if (needs_redraw) {
	bit	0, 4 (ix)
	jp	Z, 00109$
;src/draw.c:51: draw_map();
	call	_draw_map
;src/draw.c:54: pentity = last_entity_in_level;
	ld	hl, (_last_entity_in_level)
	ld	-2 (ix), l
	ld	-1 (ix), h
;src/draw.c:56: while (pentity-- != entities_in_level) {
00105$:
	ld	c,-2 (ix)
	ld	b,-1 (ix)
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	dec	hl
	dec	hl
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	a, c
	sub	a, #<(_entities_in_level)
	jr	NZ,00141$
	ld	a, b
	sub	a, #>(_entities_in_level)
	jp	Z,00107$
00141$:
;src/draw.c:57: e = *pentity;
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	a, (hl)
	ld	-4 (ix), a
	inc	hl
	ld	a, (hl)
	ld	-3 (ix), a
;src/entity.h:120: return (e->flags & E_IN_WORLD) != 0;
	pop	bc
	pop	hl
	push	hl
	push	bc
	ld	de, #0x0005
	add	hl, de
	ld	a, (hl)
	and	a,#0x01
	xor	a,#0x01
;src/draw.c:58: if (in_world(e))
	bit	0,a
	jr	NZ,00105$
;src/draw.c:59: if (distance_sqr (player->x,player->y, e->x, e->y) < FOV_R2)
	pop	bc
	pop	hl
	push	hl
	push	bc
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-6 (ix), a
	pop	bc
	pop	hl
	push	hl
	push	bc
	inc	hl
	ld	c, (hl)
	ld	de, (_player)
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-5 (ix), a
	ex	de,hl
	inc	hl
	ld	e, (hl)
;src/aux_math.h:30: return ((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
	ld	a,c
	ld	l,a
	rla
	sbc	a, a
	ld	h, a
	ld	a, e
	rla
	sbc	a, a
	ld	d, a
	cp	a, a
	sbc	hl, de
	push	hl
	push	hl
	call	__mulint
	pop	af
	pop	af
	ld	c, l
	ld	b, h
	ld	l, -6 (ix)
	ld	a, -6 (ix)
	rla
	sbc	a, a
	ld	h, a
	ld	e, -5 (ix)
	ld	a, -5 (ix)
	rla
	sbc	a, a
	ld	d, a
	cp	a, a
	sbc	hl, de
	push	bc
	push	hl
	push	hl
	call	__mulint
	pop	af
	pop	af
	pop	bc
	add	hl, bc
;src/draw.c:59: if (distance_sqr (player->x,player->y, e->x, e->y) < FOV_R2)
	ld	a, l
	sub	a, #0x19
	ld	a, h
	sbc	a, #0x00
	jp	NC, 00105$
;src/draw.c:60: entity_draw (e);
	pop	bc
	pop	hl
	push	hl
	push	bc
	push	hl
	call	_entity_draw
	pop	af
	jp	00105$
00107$:
;src/draw.c:65: entity_draw (player);
	ld	hl, (_player)
	push	hl
	call	_entity_draw
	pop	af
00109$:
;src/draw.c:70: if (stats_changed) {
	ld	hl,#_stats_changed+0
	bit	0, (hl)
	jr	Z,00114$
;src/draw.c:71: clr_stats();
	call	_clr_stats
;src/draw.c:72: draw_stats();
	call	_draw_stats
;src/draw.c:73: stats_changed = false;
	ld	hl,#_stats_changed + 0
	ld	(hl), #0x00
00114$:
	ld	sp, ix
	pop	ix
	ret
;src/draw.c:79: void draw_map() {
;	---------------------------------
; Function draw_map
; ---------------------------------
_draw_map::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
	dec	sp
;src/draw.c:85: start_x = player->x < FOV_RADIUS ? 0 : player->x - FOV_RADIUS;
	ld	de, (_player)
	ld	l, e
	ld	h, d
	inc	hl
	ld	b, (hl)
	ld	a, b
	xor	a, #0x80
	sub	a, #0x85
	jr	NC,00114$
	ld	c, #0x00
	jr	00115$
00114$:
	ld	a, b
	add	a, #0xfb
	ld	c, a
00115$:
;src/draw.c:86: start_y = player->y < FOV_RADIUS ? 0 : player->y - FOV_RADIUS;
	ex	de,hl
	inc	hl
	inc	hl
	ld	e, (hl)
	ld	a, e
	xor	a, #0x80
	sub	a, #0x85
	jr	NC,00116$
	ld	l, #0x00
	jr	00117$
00116$:
	ld	a, e
	add	a, #0xfb
	ld	l, a
00117$:
;src/draw.c:87: end_x   = player->x >= MAP_WIDTH-FOV_RADIUS-1 ?
	ld	a, b
	xor	a, #0x80
	sub	a, #0x96
	jr	C,00118$
;src/draw.c:88: MAP_WIDTH-1 : player->x+FOV_RADIUS;
	ld	a, #0x1b
	jr	00119$
00118$:
	ld	a, b
	add	a, #0x05
00119$:
	ld	-4 (ix), a
;src/draw.c:89: end_y   = player->y >= MAP_HEIGHT-FOV_RADIUS-1 ?
	ld	a, e
	xor	a, #0x80
	sub	a, #0x8c
	jr	C,00120$
;src/draw.c:90: MAP_HEIGHT-1 : player->y+FOV_RADIUS;
	ld	a, #0x11
	jr	00121$
00120$:
	ld	a, e
	add	a, #0x05
00121$:
	ld	-5 (ix), a
;src/draw.c:92: for (y=start_y; y <= end_y; ++y)
	ld	e, l
00110$:
	ld	a, -5 (ix)
	sub	a, e
	jp	PO, 00160$
	xor	a, #0x80
00160$:
	jp	M, 00112$
;src/draw.c:93: for (x=start_x; x <=end_x; ++x) {
	ld	b, c
00107$:
	ld	a, -4 (ix)
	sub	a, b
	jp	PO, 00161$
	xor	a, #0x80
00161$:
	jp	M, 00111$
;src/draw.c:85: start_x = player->x < FOV_RADIUS ? 0 : player->x - FOV_RADIUS;
	ld	hl, (_player)
;src/draw.c:94: if ( !(player->x == x && player->y == y) )
	ld	-3 (ix), l
	ld	-2 (ix), h
	inc	hl
	ld	d, (hl)
	ld	a, b
	sub	a, d
	jr	NZ,00101$
	ld	l,-3 (ix)
	ld	h,-2 (ix)
	inc	hl
	inc	hl
	ld	a, (hl)
	sub	a, e
	jr	Z,00108$
00101$:
;src/draw.c:95: draw_tile (x, y);
	push	bc
	push	de
	ld	a, e
	push	af
	inc	sp
	push	bc
	inc	sp
	call	_draw_tile
	pop	af
	pop	de
	pop	bc
00108$:
;src/draw.c:93: for (x=start_x; x <=end_x; ++x) {
	inc	b
	jr	00107$
00111$:
;src/draw.c:92: for (y=start_y; y <= end_y; ++y)
	inc	e
	jr	00110$
00112$:
	ld	sp, ix
	pop	ix
	ret
;src/draw.c:103: void draw_tile (i8 x, i8 y) {
;	---------------------------------
; Function draw_tile
; ---------------------------------
_draw_tile::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/draw.c:106: struct TTile *current_tile = &game_map.tiles[y][x];
	ld	c, 5 (ix)
	ld	a, c
	rlc	a
	sbc	a, a
	ld	b, a
	ld	l, c
	ld	h, b
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, bc
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	de, #(_game_map + 0x0002)
	add	hl, de
	ld	a, 4 (ix)
	add	a, a
	ld	c, a
	ld	e,c
	ld	d,#0x00
	add	hl, de
;src/draw.c:113: if (current_tile->spr)
	ld	b, (hl)
	ld	a, b
	or	a, a
	jr	Z,00103$
;src/draw.c:114: putchar_f ((void*)VMEM_MAP, x,y, current_tile->spr, fg_color, bg_color);
	ld	hl, #0x0002
	push	hl
	push	bc
	inc	sp
	ld	h, 5 (ix)
	ld	l, 4 (ix)
	push	hl
	ld	hl, #0xc052
	push	hl
	call	_putchar_f
	ld	hl, #7
	add	hl, sp
	ld	sp, hl
00103$:
	pop	ix
	ret
;src/draw.c:118: void entity_draw(struct TEntity *e) {
;	---------------------------------
; Function entity_draw
; ---------------------------------
_entity_draw::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/draw.c:119: putchar_f ((void*)VMEM_MAP, e->x,e->y, ech(e), 1, DEFAULT_BG);
	ld	c,4 (ix)
	ld	b,5 (ix)
;src/entity.h:116: return (e->flags & E_DEAD) != 0;
	push	bc
	pop	iy
	ld	a, 5 (iy)
	and	a, #0x02
	sub	a,#0x01
	ld	a, #0x00
	rla
;src/entity.h:128: return (is_dead(e)) ? '%' : entity_info[e->type].ch;
	bit	0,a
	jr	NZ,00105$
	ld	de, #0x0025
	jr	00106$
00105$:
	ld	a, (bc)
	ld	l, a
	ld	h, #0x00
	add	hl, hl
	add	hl, hl
	ld	de, #_entity_info
	add	hl, de
	inc	hl
	inc	hl
	inc	hl
	ld	e, (hl)
00106$:
;src/draw.c:119: putchar_f ((void*)VMEM_MAP, e->x,e->y, ech(e), 1, DEFAULT_BG);
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, b
	inc	hl
	ld	b, (hl)
	ld	hl, #0x0001
	push	hl
	ld	a, e
	push	af
	inc	sp
	ld	e, b
	push	de
	ld	hl, #0xc052
	push	hl
	call	_putchar_f
	ld	hl, #7
	add	hl, sp
	ld	sp, hl
	pop	ix
	ret
;src/draw.c:123: void draw_player_hp() {
;	---------------------------------
; Function draw_player_hp
; ---------------------------------
_draw_player_hp::
;src/draw.c:127: sprintf (msg, "HP: %d/%d ", player->fighter->hp, player->fighter->max_hp);
	ld	hl, (_player)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	e, (hl)
	ld	a, e
	rla
	sbc	a, a
	ld	d, a
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	c, (hl)
	ld	a, c
	rla
	sbc	a, a
	ld	b, a
	push	de
	push	bc
	ld	hl, #___str_0
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;src/draw.c:128: cpct_drawStringM1_f (msg, (void*)(VMEM_STATS_HP),
	ld	hl, #0x0001
	push	hl
	ld	hl, #0xc12a
	push	hl
	ld	hl, #_msg
	push	hl
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ret
___str_0:
	.ascii "HP: %d/%d "
	.db 0x00
;src/draw.c:133: void draw_player_strn()
;	---------------------------------
; Function draw_player_strn
; ---------------------------------
_draw_player_strn::
;src/draw.c:137: sprintf (msg, "STR: %d", player->fighter->strn);
	ld	hl, (_player)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, c
	ld	de, #0x0004
	add	hl, de
	ld	c, (hl)
	ld	b, #0x00
	push	bc
	ld	hl, #___str_1
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/draw.c:138: cpct_drawStringM1_f (msg, (void*)(VMEM_STATS_STR),
	ld	hl, #0x0001
	push	hl
	ld	hl, #0xc1ca
	push	hl
	ld	hl, #_msg
	push	hl
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ret
___str_1:
	.ascii "STR: %d"
	.db 0x00
;src/draw.c:142: void draw_player_def()
;	---------------------------------
; Function draw_player_def
; ---------------------------------
_draw_player_def::
;src/draw.c:146: sprintf (msg, "DEF: %d", player->fighter->def);
	ld	hl, (_player)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, c
	ld	de, #0x0005
	add	hl, de
	ld	c, (hl)
	ld	b, #0x00
	push	bc
	ld	hl, #___str_2
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/draw.c:147: cpct_drawStringM1_f (msg, (void*)(VMEM_STATS_DEF),
	ld	hl, #0x0001
	push	hl
	ld	hl, #0xc21a
	push	hl
	ld	hl, #_msg
	push	hl
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ret
___str_2:
	.ascii "DEF: %d"
	.db 0x00
;src/draw.c:151: void draw_player_ref()
;	---------------------------------
; Function draw_player_ref
; ---------------------------------
_draw_player_ref::
;src/draw.c:155: sprintf (msg, "REF: %d", player->fighter->ref);
	ld	hl, (_player)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, c
	ld	de, #0x0006
	add	hl, de
	ld	c, (hl)
	ld	b, #0x00
	push	bc
	ld	hl, #___str_3
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/draw.c:156: cpct_drawStringM1_f (msg, (void*)(VMEM_STATS_REF),
	ld	hl, #0x0001
	push	hl
	ld	hl, #0xc26a
	push	hl
	ld	hl, #_msg
	push	hl
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ret
___str_3:
	.ascii "REF: %d"
	.db 0x00
;src/draw.c:160: void draw_player_dex()
;	---------------------------------
; Function draw_player_dex
; ---------------------------------
_draw_player_dex::
;src/draw.c:164: sprintf (msg, "DEX: %d", player->fighter->dex);
	ld	hl, (_player)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, c
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	ld	b, #0x00
	push	bc
	ld	hl, #___str_4
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/draw.c:165: cpct_drawStringM1_f (msg, (void*)(VMEM_STATS_DEX),
	ld	hl, #0x0001
	push	hl
	ld	hl, #0xc2ba
	push	hl
	ld	hl, #_msg
	push	hl
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ret
___str_4:
	.ascii "DEX: %d"
	.db 0x00
;src/draw.c:170: void draw_player_hungry(bool clear)
;	---------------------------------
; Function draw_player_hungry
; ---------------------------------
_draw_player_hungry::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/draw.c:174: clear ? DEFAULT_BG : WARNING_FG, clear ? DEFAULT_BG : WARNING_BG);
	bit	0, 4 (ix)
	jr	Z,00103$
	ld	d, #0x00
	jr	00104$
00103$:
	ld	d, #0x02
00104$:
	bit	0, 4 (ix)
	jr	Z,00105$
	ld	b, #0x00
	jr	00106$
00105$:
	ld	b, #0x01
00106$:
;src/draw.c:173: cpct_drawStringM1_f (" HUNGRY ", (void*)(VMEM_HUNGRY),
	ld	e, b
	push	de
	ld	hl, #0xc49a
	push	hl
	ld	hl, #___str_5
	push	hl
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	ix
	ret
___str_5:
	.ascii " HUNGRY "
	.db 0x00
;src/draw.c:178: void draw_stats() {
;	---------------------------------
; Function draw_stats
; ---------------------------------
_draw_stats::
;src/draw.c:184: player->xp_level, player->fighter->xp);
	ld	bc, (_player)
	push	bc
	pop	iy
	ld	l, 7 (iy)
	ld	h, 8 (iy)
	ld	de, #0x0008
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	pop	iy
	ld	c, 6 (iy)
	ld	b, #0x00
;src/draw.c:183: sprintf (msg, "Lvl %d/%d",
	push	de
	push	bc
	ld	hl, #___str_6
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;src/draw.c:185: cpct_drawStringM1_f (msg, (void*)(VMEM_STATS_XP),
	ld	hl, #0x0001
	push	hl
	ld	hl, #0xc0da
	push	hl
	ld	hl, #_msg
	push	hl
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/draw.c:188: draw_player_hp();
	call	_draw_player_hp
;src/draw.c:189: draw_player_strn();
	call	_draw_player_strn
;src/draw.c:190: draw_player_def();
	call	_draw_player_def
;src/draw.c:191: draw_player_ref();
	call	_draw_player_ref
;src/draw.c:192: draw_player_dex();
	call	_draw_player_dex
;src/draw.c:194: sprintf (msg, "Gold: %d", player->item->value);
	ld	iy, (_player)
	ld	l, 13 (iy)
	ld	h, 14 (iy)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	ld	hl, #___str_7
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/draw.c:195: cpct_drawStringM1_f (msg, (void*)(VMEM_STATS_GOLD),
	ld	hl, #0x0001
	push	hl
	ld	hl, #0xc35a
	push	hl
	ld	hl, #_msg
	push	hl
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/draw.c:198: sprintf (msg, "DLvl: %d", dungeon_lvl);
	ld	hl,#_dungeon_lvl + 0
	ld	c, (hl)
	ld	b, #0x00
	push	bc
	ld	hl, #___str_8
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/draw.c:199: cpct_drawStringM1_f (msg, (void*)(VMEM_DUNGEON_LVL),
	ld	hl, #0x0001
	push	hl
	ld	hl, #0xc3fa
	push	hl
	ld	hl, #_msg
	push	hl
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ret
___str_6:
	.ascii "Lvl %d/%d"
	.db 0x00
___str_7:
	.ascii "Gold: %d"
	.db 0x00
___str_8:
	.ascii "DLvl: %d"
	.db 0x00
;src/draw.c:204: void draw_inventory()
;	---------------------------------
; Function draw_inventory
; ---------------------------------
_draw_inventory::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
;src/draw.c:208: clr_log();
	call	_clr_log
;src/draw.c:210: if (!player->container->num_items) {
	ld	hl, (_player)
	ld	de, #0x000b
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, c
	ld	de, #0x0022
	add	hl, de
	ld	a, (hl)
	ld	-1 (ix), a
	or	a, a
	jr	NZ,00112$
;src/draw.c:211: sprintf (msg, "\477\11\12Inventory empty");
	ld	hl, #___str_9
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	pop	af
;src/draw.c:212: log_msg_ext (msg);
	ld	hl, #_msg
	ex	(sp),hl
	call	_log_msg_ext
	pop	af
	jr	00108$
;src/draw.c:214: else for (u8 i=0; i<player->container->num_items; ++i) {
00112$:
	ld	-4 (ix), #0x00
00106$:
;src/draw.c:210: if (!player->container->num_items) {
	ld	iy, (_player)
;src/draw.c:214: else for (u8 i=0; i<player->container->num_items; ++i) {
	ld	a, 11 (iy)
	ld	-3 (ix), a
	ld	a, 12 (iy)
	ld	-2 (ix), a
	ld	l,-3 (ix)
	ld	h,-2 (ix)
	ld	de, #0x0022
	add	hl, de
	ld	a,-4 (ix)
	sub	a,(hl)
	jr	NC,00108$
;src/draw.c:217: name(player->container->inventory[i]));
	ld	a, -3 (ix)
	add	a, #0x02
	ld	-3 (ix), a
	ld	a, -2 (ix)
	adc	a, #0x00
	ld	-2 (ix), a
	ld	a, -4 (ix)
	add	a, a
	ld	c, a
	ld	l,-3 (ix)
	ld	h,-2 (ix)
	ld	b, #0x00
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	call	_name
	pop	af
	ld	c, l
	ld	b, h
;src/draw.c:216: 'a'+i,
	ld	e, -4 (ix)
	ld	d, #0x00
	ld	hl, #0x0061
	add	hl, de
;src/draw.c:215: sprintf (msg, "\477\13\10%c\477\11\10 - %s",
	push	bc
	push	hl
	ld	hl, #___str_10
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;src/draw.c:219: log_msg_ext (msg);
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
;src/draw.c:214: else for (u8 i=0; i<player->container->num_items; ++i) {
	inc	-4 (ix)
	jr	00106$
00108$:
	ld	sp, ix
	pop	ix
	ret
___str_9:
	.ascii "?"
	.db 0x09
	.db 0x0a
	.ascii "Inventory empty"
	.db 0x00
___str_10:
	.ascii "?"
	.db 0x0b
	.db 0x08
	.ascii "%c?"
	.db 0x09
	.db 0x08
	.ascii " - %s"
	.db 0x00
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
