;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module entity
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _rand_range
	.globl _draw_player_dex
	.globl _draw_player_ref
	.globl _draw_player_def
	.globl _draw_player_strn
	.globl _init_container
	.globl _fighter_attack
	.globl _sprintf
	.globl _cpct_memset
	.globl _dead_name
	.globl _num_entities
	.globl _entities
	.globl _entity_info
	.globl _init_entities
	.globl _entity_create
	.globl _entity_move
	.globl _is_there_an_entity
	.globl _get_fighter_at
	.globl _get_item_at
	.globl _get_stairs_at
	.globl _add_to_world
	.globl _remove_from_world
	.globl _entity_find
	.globl _remove_from_list
	.globl _add_to_list
	.globl _check_level
	.globl _name
	.globl _is_potion
	.globl _is_known
	.globl _remove_bonus
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_entities::
	.ds 2176
_num_entities::
	.ds 1
_dead_name::
	.ds 25
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/entity.c:70: void init_entities() {
;	---------------------------------
; Function init_entities
; ---------------------------------
_init_entities::
;src/entity.c:71: cpct_memset (entities, 0x00, sizeof (entities));
	ld	hl, #0x0880
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	hl, #_entities
	push	hl
	call	_cpct_memset
;src/entity.c:72: num_entities = 0;
	ld	hl,#_num_entities + 0
	ld	(hl), #0x00
	ret
_entity_info:
	.db #0x00	; 0
	.dw __str_0
	.db #0x40	; 64
	.db #0x01	; 1
	.dw __str_1
	.db #0x67	; 103	'g'
	.db #0x02	; 2
	.dw __str_2
	.db #0x42	; 66	'B'
	.db #0x03	; 3
	.dw __str_3
	.db #0x53	; 83	'S'
	.db #0x04	; 4
	.dw __str_4
	.db #0x4b	; 75	'K'
	.db #0x05	; 5
	.dw __str_5
	.db #0x6f	; 111	'o'
	.db #0x06	; 6
	.dw __str_6
	.db #0xaf	; 175
	.db #0x07	; 7
	.dw __str_7
	.db #0xaf	; 175
	.db #0x08	; 8
	.dw __str_8
	.db #0xaf	; 175
	.db #0x09	; 9
	.dw __str_9
	.db #0xaf	; 175
	.db #0x0a	; 10
	.dw __str_10
	.db #0xaf	; 175
	.db #0x0b	; 11
	.dw __str_11
	.db #0xaf	; 175
	.db #0x0c	; 12
	.dw __str_12
	.db #0xe2	; 226
	.db #0x0d	; 13
	.dw __str_13
	.db #0x24	; 36
	.db #0x0e	; 14
	.dw __str_14
	.db #0xb5	; 181
	.db #0x0f	; 15
	.dw __str_15
	.db #0x3c	; 60
	.db #0x10	; 16
	.dw __str_16
	.db #0x3e	; 62
__str_0:
	.db 0x00
__str_1:
	.ascii "Goblin"
	.db 0x00
__str_2:
	.ascii "Bat"
	.db 0x00
__str_3:
	.ascii "Snake"
	.db 0x00
__str_4:
	.ascii "Kobold"
	.db 0x00
__str_5:
	.ascii "Orc"
	.db 0x00
__str_6:
	.ascii "Healing Potion"
	.db 0x00
__str_7:
	.ascii "Poison Potion"
	.db 0x00
__str_8:
	.ascii "Strength Potion"
	.db 0x00
__str_9:
	.ascii "Defense Potion"
	.db 0x00
__str_10:
	.ascii "Dexterity Potion"
	.db 0x00
__str_11:
	.ascii "Reflexes Potion"
	.db 0x00
__str_12:
	.ascii "Food"
	.db 0x00
__str_13:
	.ascii "Gold"
	.db 0x00
__str_14:
	.ascii "The Orutrix"
	.db 0x00
__str_15:
	.ascii "Stairs Up"
	.db 0x00
__str_16:
	.ascii "Stairs Down"
	.db 0x00
;src/entity.c:81: struct TEntity *entity_create (enum Etype type, i8 x, i8 y,
;	---------------------------------
; Function entity_create
; ---------------------------------
_entity_create::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/entity.c:96: e = &entities[num_entities++];
	ld	bc, #_entities+0
	ld	iy, #_num_entities
	ld	e, 0 (iy)
	inc	0 (iy)
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl,bc
	ld	c, l
	ld	b, h
;src/entity.c:98: e->type = type;
	ld	a, 4 (ix)
	ld	(bc), a
;src/entity.c:100: add_to_world (e, x,y);
	push	bc
	ld	h, 6 (ix)
	ld	l, 5 (ix)
	push	hl
	push	bc
	call	_add_to_world
	pop	af
	pop	af
	pop	bc
;src/entity.c:102: if (fighter)                      // Set the owner of the component
	ld	a, 8 (ix)
	or	a,7 (ix)
	jr	Z,00102$
;src/entity.c:103: fighter->owner = e;             // Fighter component if it's a combat
	ld	l,7 (ix)
	ld	h,8 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
00102$:
;src/entity.c:104: e->fighter = fighter;             // entity or NULL
	ld	hl, #0x0007
	add	hl, bc
	ld	a, 7 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 8 (ix)
	ld	(hl), a
;src/entity.c:106: if (ai)                           // AI component
	ld	a, 10 (ix)
	or	a,9 (ix)
	jr	Z,00104$
;src/entity.c:107: ai->owner = e;
	ld	l,9 (ix)
	ld	h,10 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
00104$:
;src/entity.c:108: e->ai = ai;
	ld	hl, #0x0009
	add	hl, bc
	ld	a, 9 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 10 (ix)
	ld	(hl), a
;src/entity.c:110: if (container) {                  // Set owner of the container and
	ld	a, 12 (ix)
	or	a,11 (ix)
	jr	Z,00106$
;src/entity.c:111: init_container (container);     // ...initialize it
	push	bc
	ld	l,11 (ix)
	ld	h,12 (ix)
	push	hl
	call	_init_container
	pop	af
	pop	bc
;src/entity.c:112: container->owner = e;           //
	ld	l,11 (ix)
	ld	h,12 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
00106$:
;src/entity.c:114: e->container = container;         // Container if can collect items or NULL
	ld	hl, #0x000b
	add	hl, bc
	ld	a, 11 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 12 (ix)
	ld	(hl), a
;src/entity.c:116: if (item)                         // Item component
	ld	a, 14 (ix)
	or	a,13 (ix)
	jr	Z,00108$
;src/entity.c:117: item->owner = e;
	ld	l,13 (ix)
	ld	h,14 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
00108$:
;src/entity.c:118: e->item = item;
	ld	hl, #0x000d
	add	hl, bc
	ld	a, 13 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 14 (ix)
	ld	(hl), a
;src/entity.c:120: if (stairs)                       // Stairs component
	ld	a, 16 (ix)
	or	a,15 (ix)
	jr	Z,00110$
;src/entity.c:121: stairs->owner = e;
	ld	l,15 (ix)
	ld	h,16 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
00110$:
;src/entity.c:122: e->stairs = stairs;
	ld	hl, #0x000f
	add	hl, bc
	ld	a, 15 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 16 (ix)
	ld	(hl), a
;src/entity.c:124: return e;
	ld	l, c
	ld	h, b
	pop	ix
	ret
;src/entity.c:128: bool entity_move (struct TEntity *e, i8 dx, i8 dy)  {
;	---------------------------------
; Function entity_move
; ---------------------------------
_entity_move::
	push	ix
	ld	ix,#0
	add	ix,sp
	ld	hl, #-9
	add	hl, sp
	ld	sp, hl
;src/entity.c:133: if (!tile_blocks_movement (e->x+dx, e->y+dy)) {
	ld	a, 4 (ix)
	ld	-6 (ix), a
	ld	a, 5 (ix)
	ld	-5 (ix), a
	ld	a, -6 (ix)
	add	a, #0x02
	ld	-4 (ix), a
	ld	a, -5 (ix)
	adc	a, #0x00
	ld	-3 (ix), a
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	a, (hl)
	add	a, 7 (ix)
	ld	-9 (ix), a
	ld	e, a
	ld	c,-6 (ix)
	ld	b,-5 (ix)
	inc	bc
	ld	a, (bc)
	add	a, 6 (ix)
	ld	-8 (ix), a
	ld	-7 (ix), a
;src/game_map.h:112: return game_map.tiles[y][x].t_flags & BLOCKED;
	ld	a, e
	rlc	a
	sbc	a, a
	ld	d, a
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	ld	de, #(_game_map + 0x0002)
	add	hl, de
	ld	a, -7 (ix)
	add	a, a
	ld	e, a
	ld	d,#0x00
	add	hl, de
	inc	hl
	ld	a, (hl)
	rrca
	jp	C,00107$
;src/entity.c:133: if (!tile_blocks_movement (e->x+dx, e->y+dy)) {
;src/entity.c:136: if ((target = get_fighter_at(e->x+dx, e->y+dy) )) {
	push	bc
	ld	h, -9 (ix)
	ld	l, -8 (ix)
	push	hl
	call	_get_fighter_at
	pop	af
	ex	de,hl
	pop	bc
	ld	-2 (ix), e
	ld	-1 (ix), d
	ld	a, d
	or	a,e
	jr	Z,00104$
;src/entity.c:140: if (target != e)  // Ensure we are not attacking ourselves!
	ld	a, -6 (ix)
	sub	a, -2 (ix)
	jr	NZ,00125$
	ld	a, -5 (ix)
	sub	a, -1 (ix)
	jr	Z,00105$
00125$:
;src/entity.c:142: fighter_attack (e->fighter, target);
	ld	l,-6 (ix)
	ld	h,-5 (ix)
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	push	bc
	call	_fighter_attack
	pop	af
	pop	af
	jr	00105$
00104$:
;src/entity.c:146: e->px = e->x;     // Save old positions
	ld	e,-6 (ix)
	ld	d,-5 (ix)
	inc	de
	inc	de
	inc	de
	ld	a, (bc)
	ld	(de), a
;src/entity.c:147: e->py = e->y;
	ld	a, -6 (ix)
	add	a, #0x04
	ld	e, a
	ld	a, -5 (ix)
	adc	a, #0x00
	ld	d, a
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	a, (hl)
	ld	(de), a
;src/entity.c:148: e->x  = e->x+dx;  // Update to new position
	ld	a, (bc)
	add	a, 6 (ix)
	ld	(bc), a
;src/entity.c:149: e->y  = e->y+dy;
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	a, (hl)
	add	a, 7 (ix)
	ld	l,-4 (ix)
	ld	h,-3 (ix)
	ld	(hl), a
00105$:
;src/entity.c:153: return true;
	ld	l, #0x01
	jr	00109$
00107$:
;src/entity.c:157: return false;
	ld	l, #0x00
00109$:
	ld	sp, ix
	pop	ix
	ret
;src/entity.c:160: bool is_there_an_entity (i8 x, i8 y)
;	---------------------------------
; Function is_there_an_entity
; ---------------------------------
_is_there_an_entity::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;src/entity.c:163: pentity = last_entity_in_level;
	ld	de, (_last_entity_in_level)
;src/entity.c:164: while(pentity-- != entities_in_level) {
00105$:
	ld	c, e
	ld	b, d
	dec	de
	dec	de
	ld	a, c
	sub	a, #<(_entities_in_level)
	jr	NZ,00130$
	ld	a, b
	sub	a, #>(_entities_in_level)
	jr	Z,00107$
00130$:
;src/entity.c:165: if ((*pentity) && (*pentity)->x == x && (*pentity)->y ==y)
	ld	l, e
	ld	h, d
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	a, b
	or	a,c
	jr	Z,00105$
	ld	l, c
	ld	h, b
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
	ld	a, 4 (ix)
	sub	a, -1 (ix)
	jr	NZ,00105$
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a,5 (ix)
	sub	a,(hl)
	jr	NZ,00105$
;src/entity.c:166: return true;
	ld	l, #0x01
	jr	00108$
00107$:
;src/entity.c:168: return false;
	ld	l, #0x00
00108$:
	inc	sp
	pop	ix
	ret
;src/entity.c:176: struct TEntity *get_fighter_at (i8 x, i8 y)
;	---------------------------------
; Function get_fighter_at
; ---------------------------------
_get_fighter_at::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/entity.c:179: pentity = last_entity_in_level;
	ld	hl, (_last_entity_in_level)
	ex	(sp), hl
;src/entity.c:180: while(pentity-- >= entities_in_level) {
00105$:
	pop	bc
	push	bc
	pop	hl
	push	hl
	dec	hl
	dec	hl
	ex	(sp), hl
	ld	a, c
	sub	a, #<(_entities_in_level)
	ld	a, b
	sbc	a, #>(_entities_in_level)
	jr	C,00107$
;src/entity.c:181: if ((*pentity)->fighter &&
	pop	hl
	push	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	a, (hl)
	or	a,e
	jr	Z,00105$
;src/entity.c:182: (*pentity)->x == x && (*pentity)->y == y)
	ld	l, c
	ld	h, b
	inc	hl
	ld	a,4 (ix)
	sub	a,(hl)
	jr	NZ,00105$
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a,5 (ix)
	sub	a,(hl)
	jr	NZ,00105$
;src/entity.c:183: return (*pentity);
	ld	l, c
	ld	h, b
	jr	00108$
00107$:
;src/entity.c:185: return NULL;
	ld	hl, #0x0000
00108$:
	ld	sp, ix
	pop	ix
	ret
;src/entity.c:194: struct TEntity *get_item_at (i8 x, i8 y)
;	---------------------------------
; Function get_item_at
; ---------------------------------
_get_item_at::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;src/entity.c:197: pentity = last_entity_in_level;
	ld	de, (_last_entity_in_level)
;src/entity.c:198: while(pentity-- != entities_in_level) {
00106$:
	ld	c, e
	ld	b, d
	dec	de
	dec	de
	ld	a, c
	sub	a, #<(_entities_in_level)
	jr	NZ,00136$
	ld	a, b
	sub	a, #>(_entities_in_level)
	jr	Z,00108$
00136$:
;src/entity.c:199: if (in_world((*pentity)) &&(*pentity)->item &&
	ld	l, e
	ld	h, d
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	pop	iy
;src/entity.h:120: return (e->flags & E_IN_WORLD) != 0;
	ld	a, 5 (iy)
	and	a, #0x01
	ld	-1 (ix), a
	sub	a,#0x01
	ld	a, #0x00
	rla
	ld	-1 (ix), a
;src/entity.c:199: if (in_world((*pentity)) &&(*pentity)->item &&
	bit	0, -1 (ix)
	jr	NZ,00106$
	push	bc
	pop	iy
	ld	l, 13 (iy)
	ld	a, 14 (iy)
	or	a,l
	jr	Z,00106$
;src/entity.c:200: (*pentity)->x == x &&(*pentity)->y == y)
	ld	l, c
	ld	h, b
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
	ld	a, 4 (ix)
	sub	a, -1 (ix)
	jr	NZ,00106$
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
	ld	a, 5 (ix)
	sub	a, -1 (ix)
	jr	NZ,00106$
;src/entity.c:201: return (*pentity);
	ld	l, c
	ld	h, b
	jr	00110$
00108$:
;src/entity.c:204: return NULL;
	ld	hl, #0x0000
00110$:
	inc	sp
	pop	ix
	ret
;src/entity.c:207: struct TEntity *get_stairs_at (i8 x, i8 y)
;	---------------------------------
; Function get_stairs_at
; ---------------------------------
_get_stairs_at::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/entity.c:210: pentity = last_entity_in_level;
	ld	hl, (_last_entity_in_level)
	ex	(sp), hl
;src/entity.c:211: while(pentity-- != entities_in_level) {
00105$:
	pop	bc
	push	bc
	pop	hl
	push	hl
	dec	hl
	dec	hl
	ex	(sp), hl
	ld	a, c
	sub	a, #<(_entities_in_level)
	jr	NZ,00130$
	ld	a, b
	sub	a, #>(_entities_in_level)
	jr	Z,00107$
00130$:
;src/entity.c:212: if ((*pentity)->stairs &&
	pop	hl
	push	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l, c
	ld	h, b
	ld	de, #0x000f
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	a, (hl)
	or	a,e
	jr	Z,00105$
;src/entity.c:213: (*pentity)->x == x && (*pentity)->y == y)
	ld	l, c
	ld	h, b
	inc	hl
	ld	a,4 (ix)
	sub	a,(hl)
	jr	NZ,00105$
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a,5 (ix)
	sub	a,(hl)
	jr	NZ,00105$
;src/entity.c:214: return *pentity;
	ld	l, c
	ld	h, b
	jr	00108$
00107$:
;src/entity.c:216: return NULL;
	ld	hl, #0x0000
00108$:
	ld	sp, ix
	pop	ix
	ret
;src/entity.c:220: void add_to_world (struct TEntity *e, i8 x, i8 y) {
;	---------------------------------
; Function add_to_world
; ---------------------------------
_add_to_world::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/entity.c:226: e->x = e->px = x;
	ld	c,4 (ix)
	ld	b,5 (ix)
	ld	e, c
	ld	d, b
	inc	de
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	a, 6 (ix)
	ld	(hl), a
	ld	a, 6 (ix)
	ld	(de), a
;src/entity.c:227: e->y = e->py = y;
	ld	e, c
	ld	d, b
	inc	de
	inc	de
	ld	hl, #0x0004
	add	hl, bc
	ld	a, 7 (ix)
	ld	(hl), a
	ld	a, 7 (ix)
	ld	(de), a
;src/entity.c:228: e->flags |= E_IN_WORLD;
	ld	hl, #0x0005
	add	hl, bc
	set	0, (hl)
	ld	a, (hl)
	pop	ix
	ret
;src/entity.c:233: void remove_from_world (struct TEntity *e) {
;	---------------------------------
; Function remove_from_world
; ---------------------------------
_remove_from_world::
;src/entity.c:235: e->flags &= (~E_IN_WORLD);
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x0005
	add	hl, bc
	ld	c, (hl)
	res	0, c
	ld	(hl), c
	ret
;src/entity.c:240: void entity_find (struct TEntity *array[], struct TEntity *e, u8 *index)
;	---------------------------------
; Function entity_find
; ---------------------------------
_entity_find::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/entity.c:242: struct TEntity **parray = array;
	ld	c,4 (ix)
	ld	b,5 (ix)
;src/entity.c:244: for (*index = 0;  *parray != e; parray++, (*index)++)
	ld	e,8 (ix)
	ld	d,9 (ix)
	xor	a, a
	ld	(de), a
00103$:
	ld	a, (bc)
	ld	-2 (ix), a
	inc	bc
	ld	a, (bc)
	ld	-1 (ix), a
	dec	bc
	ld	a, 6 (ix)
	sub	a, -2 (ix)
	jr	NZ,00116$
	ld	a, 7 (ix)
	sub	a, -1 (ix)
	jr	Z,00105$
00116$:
	inc	bc
	inc	bc
	ld	a, (de)
	inc	a
	ld	(de), a
	jr	00103$
00105$:
	ld	sp, ix
	pop	ix
	ret
;src/entity.c:249: void remove_from_list (struct TEntity *array[], struct TEntity *e)
;	---------------------------------
; Function remove_from_list
; ---------------------------------
_remove_from_list::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;src/entity.c:253: entity_find (entities_in_level, e, &entity_idx);
	ld	hl, #0x0000
	add	hl, sp
	push	hl
	ld	l,6 (ix)
	ld	h,7 (ix)
	push	hl
	ld	hl, #_entities_in_level
	push	hl
	call	_entity_find
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/entity.c:254: --last_entity_in_level;
	ld	hl, (_last_entity_in_level)
	dec	hl
	dec	hl
	ld	(_last_entity_in_level), hl
;src/entity.c:255: array[entity_idx] = *last_entity_in_level;
	ld	l, -1 (ix)
	ld	h, #0x00
	add	hl, hl
	ld	c, l
	ld	b, h
	ld	a, 4 (ix)
	add	a, c
	ld	c, a
	ld	a, 5 (ix)
	adc	a, b
	ld	b, a
	ld	hl, (_last_entity_in_level)
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, e
	ld	(bc), a
	inc	bc
	ld	a, d
	ld	(bc), a
	inc	sp
	pop	ix
	ret
;src/entity.c:258: void add_to_list (struct TEntity *array[], struct TEntity *e)
;	---------------------------------
; Function add_to_list
; ---------------------------------
_add_to_list::
;src/entity.c:260: *last_entity_in_level = e;
	ld	hl, (_last_entity_in_level)
	ld	iy, #4
	add	iy, sp
	ld	a, 0 (iy)
	ld	(hl), a
	inc	hl
	ld	a, 1 (iy)
	ld	(hl), a
;src/entity.c:261: last_entity_in_level++;
	ld	hl, #_last_entity_in_level
	ld	a, (hl)
	add	a, #0x02
	ld	(hl), a
	inc	hl
	ld	a, (hl)
	adc	a, #0x00
	ld	(hl), a
	ret
;src/entity.c:265: void check_level()
;	---------------------------------
; Function check_level
; ---------------------------------
_check_level::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	push	af
	dec	sp
;src/entity.c:268: u16 level_up_xp = LEVEL_UP_BASE + player->xp_level * LEVEL_UP_FACTOR;
	ld	bc, (_player)
	ld	hl, #0x0006
	add	hl,bc
	ld	-2 (ix), l
	ld	-1 (ix), h
	ld	a, (hl)
	ld	-3 (ix), a
	ld	e, a
	ld	d,#0x00
	ld	l, e
	ld	h, d
	add	hl, hl
	add	hl, de
	add	hl, hl
	add	hl, hl
	add	hl, hl
	add	hl, de
	add	hl, hl
	ld	de, #0x004b
	add	hl, de
	ex	(sp), hl
;src/entity.c:271: if (player->fighter->xp >= level_up_xp) {
	push	bc
	pop	iy
	ld	l, 7 (iy)
	ld	h, 8 (iy)
	ld	de, #0x0008
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	a, c
	sub	a, -5 (ix)
	ld	a, b
	sbc	a, -4 (ix)
	jp	C, 00111$
;src/entity.c:272: player->xp_level += 1;
	ld	c, -3 (ix)
	inc	c
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	(hl), c
;src/entity.c:268: u16 level_up_xp = LEVEL_UP_BASE + player->xp_level * LEVEL_UP_FACTOR;
	ld	hl, (_player)
;src/entity.c:271: if (player->fighter->xp >= level_up_xp) {
	ld	bc, #0x0007
	add	hl, bc
;src/entity.c:273: player->fighter->xp -= level_up_xp;
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	hl, #0x0008
	add	hl, bc
	push	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	pop	hl
	ld	a, c
	sub	a, -5 (ix)
	ld	c, a
	ld	a, b
	sbc	a, -4 (ix)
	ld	b, a
	ld	(hl), c
	inc	hl
	ld	(hl), b
;src/entity.c:268: u16 level_up_xp = LEVEL_UP_BASE + player->xp_level * LEVEL_UP_FACTOR;
	ld	de, (_player)
;src/entity.c:271: if (player->fighter->xp >= level_up_xp) {
	ld	hl, #0x0007
	add	hl, de
;src/entity.c:273: player->fighter->xp -= level_up_xp;
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;src/entity.c:274: player->fighter->max_hp += rand_range (player->xp_level+2, player->xp_level+8);
	inc	bc
	inc	bc
	ld	a, (bc)
	ld	-3 (ix), a
;src/entity.c:268: u16 level_up_xp = LEVEL_UP_BASE + player->xp_level * LEVEL_UP_FACTOR;
	push	de
	pop	iy
	ld	d, 6 (iy)
;src/entity.c:274: player->fighter->max_hp += rand_range (player->xp_level+2, player->xp_level+8);
	ld	a, d
	add	a, #0x08
	ld	h, a
	inc	d
	inc	d
	push	bc
	ld	l, d
	push	hl
	call	_rand_range
	pop	af
	pop	bc
	ld	a, -3 (ix)
	add	a, l
	ld	(bc), a
;src/entity.c:268: u16 level_up_xp = LEVEL_UP_BASE + player->xp_level * LEVEL_UP_FACTOR;
	ld	hl, (_player)
;src/entity.c:271: if (player->fighter->xp >= level_up_xp) {
	ld	bc, #0x0007
	add	hl, bc
;src/entity.c:273: player->fighter->xp -= level_up_xp;
	ld	e, (hl)
	inc	hl
	ld	h, (hl)
;src/entity.c:275: player->fighter->hp = player->fighter->max_hp;
	ld	c, e
	ld	b, h
	inc	bc
	inc	bc
	inc	bc
	ld	l, e
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	(bc), a
;src/entity.c:268: u16 level_up_xp = LEVEL_UP_BASE + player->xp_level * LEVEL_UP_FACTOR;
	ld	bc, (_player)
;src/entity.c:279: if (!(player->xp_level & 2))  player->fighter->strn += 1;
	push	bc
	pop	iy
	ld	e, 6 (iy)
	bit	1, e
	jr	NZ,00102$
;src/entity.c:271: if (player->fighter->xp >= level_up_xp) {
;src/entity.c:273: player->fighter->xp -= level_up_xp;
	ld	l, c
	ld	h, b
	ld	de, #0x0007
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;src/entity.c:279: if (!(player->xp_level & 2))  player->fighter->strn += 1;
	inc	bc
	inc	bc
	inc	bc
	inc	bc
	ld	a, (bc)
	inc	a
	ld	(bc), a
00102$:
;src/entity.c:268: u16 level_up_xp = LEVEL_UP_BASE + player->xp_level * LEVEL_UP_FACTOR;
	ld	bc, (_player)
;src/entity.c:281: if (!(player->xp_level & 3))   player->fighter->ref += 1;
	push	bc
	pop	iy
	ld	a, 6 (iy)
	and	a, #0x03
	jr	NZ,00104$
;src/entity.c:271: if (player->fighter->xp >= level_up_xp) {
	ld	hl, #0x0007
	add	hl, bc
;src/entity.c:273: player->fighter->xp -= level_up_xp;
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;src/entity.c:281: if (!(player->xp_level & 3))   player->fighter->ref += 1;
	ld	hl, #0x0006
	add	hl, bc
	ld	c, (hl)
	inc	c
	ld	(hl), c
00104$:
;src/entity.c:268: u16 level_up_xp = LEVEL_UP_BASE + player->xp_level * LEVEL_UP_FACTOR;
	ld	bc, (_player)
;src/entity.c:283: if (!(player->xp_level & 5))   player->fighter->dex += 1;
	push	bc
	pop	iy
	ld	a, 6 (iy)
	and	a, #0x05
	jr	NZ,00106$
;src/entity.c:271: if (player->fighter->xp >= level_up_xp) {
	ld	hl, #0x0007
	add	hl, bc
;src/entity.c:273: player->fighter->xp -= level_up_xp;
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;src/entity.c:283: if (!(player->xp_level & 5))   player->fighter->dex += 1;
	ld	hl, #0x0007
	add	hl, bc
	ld	c, (hl)
	inc	c
	ld	(hl), c
00106$:
;src/entity.c:268: u16 level_up_xp = LEVEL_UP_BASE + player->xp_level * LEVEL_UP_FACTOR;
	ld	bc, (_player)
;src/entity.c:285: if (!(player->xp_level & 9))   player->fighter->def += 1;
	push	bc
	pop	iy
	ld	a, 6 (iy)
	and	a, #0x09
	jr	NZ,00111$
;src/entity.c:271: if (player->fighter->xp >= level_up_xp) {
	ld	hl, #0x0007
	add	hl, bc
;src/entity.c:273: player->fighter->xp -= level_up_xp;
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
;src/entity.c:285: if (!(player->xp_level & 9))   player->fighter->def += 1;
	ld	hl, #0x0005
	add	hl, bc
	ld	c, (hl)
	inc	c
	ld	(hl), c
00111$:
	ld	sp, ix
	pop	ix
	ret
;src/entity.c:291: char *name(struct TEntity *e)
;	---------------------------------
; Function name
; ---------------------------------
_name::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/entity.c:293: if (!is_dead(e)) {
	ld	c,4 (ix)
	ld	b,5 (ix)
;src/entity.h:116: return (e->flags & E_DEAD) != 0;
	push	bc
	pop	iy
	ld	a, 5 (iy)
	and	a, #0x02
	sub	a,#0x01
	ld	a, #0x00
	rla
;src/entity.c:293: if (!is_dead(e)) {
	bit	0,a
	jr	Z,00106$
;src/entity.c:294: if (is_potion(e) && !is_known(e))
	push	bc
	push	bc
	call	_is_potion
	pop	af
	pop	bc
	bit	0, l
	jr	Z,00102$
	push	bc
	push	bc
	call	_is_known
	pop	af
	pop	bc
	bit	0, l
	jr	NZ,00102$
;src/entity.c:295: return "UNKNOWN POTION";
	ld	hl, #___str_17
	jr	00109$
00102$:
;src/entity.c:297: return entity_info[e->type].name;
	ld	de, #_entity_info+0
	ld	a, (bc)
	ld	l, a
	ld	h, #0x00
	add	hl, hl
	add	hl, hl
	add	hl, de
	inc	hl
	ld	c, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, c
	jr	00109$
00106$:
;src/entity.c:300: sprintf(dead_name, "%s %s", "Dead", entity_info[e->type].name);
	ld	a, (bc)
	ld	l, a
	ld	h, #0x00
	add	hl, hl
	add	hl, hl
	ld	de, #_entity_info
	add	hl, de
	inc	hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	ld	hl, #___str_19
	push	hl
	ld	hl, #___str_18
	push	hl
	ld	hl, #_dead_name
	push	hl
	call	_sprintf
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;src/entity.c:301: return dead_name;
	ld	hl, #_dead_name
00109$:
	pop	ix
	ret
___str_17:
	.ascii "UNKNOWN POTION"
	.db 0x00
___str_18:
	.ascii "%s %s"
	.db 0x00
___str_19:
	.ascii "Dead"
	.db 0x00
;src/entity.c:307: bool is_potion(struct TEntity *e)
;	---------------------------------
; Function is_potion
; ---------------------------------
_is_potion::
	dec	sp
;src/entity.c:309: return ( (e->type >= HEAL_POTION) && (e->type < GOLD) );
	ld	hl, #3
	add	hl, sp
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	a, (bc)
	cp	a, #0x06
	jr	C,00103$
	sub	a, #0x0d
	jr	C,00104$
00103$:
	ld	l, #0x00
	jr	00105$
00104$:
	ld	l, #0x01
00105$:
	inc	sp
	ret
;src/entity.c:313: bool is_known(struct TEntity *e)
;	---------------------------------
; Function is_known
; ---------------------------------
_is_known::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/entity.c:316: return known_potions[e->type-HEAL_POTION];
	ld	l,4 (ix)
	ld	h,5 (ix)
	ld	c, (hl)
	ld	b, #0x00
	ld	a, c
	add	a, #0xfa
	ld	c, a
	ld	a, b
	adc	a, #0xff
	ld	b, a
	ld	hl, #_known_potions
	add	hl, bc
	ld	c, (hl)
	xor	a, a
	cp	a, c
	rla
	ld	l, a
	pop	ix
	ret
;src/entity.c:320: void remove_bonus(struct TEntity *target)
;	---------------------------------
; Function remove_bonus
; ---------------------------------
_remove_bonus::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/entity.c:322: if (target->flags & E_STR_BONUS) {
	ld	e,4 (ix)
	ld	d,5 (ix)
	ld	hl, #0x0005
	add	hl,de
	ld	c, l
	ld	b, h
	ld	a, (bc)
	ld	l, a
;src/entity.c:324: target->fighter->strn -= 2;
	ld	a, e
	add	a, #0x07
	ld	e, a
	ld	a, d
	adc	a, #0x00
	ld	d, a
;src/entity.c:322: if (target->flags & E_STR_BONUS) {
	bit	3, l
	jr	Z,00102$
;src/entity.c:323: target->flags &= ~E_STR_BONUS;
	ld	a, l
	and	a, #0xf7
	ld	(bc), a
;src/entity.c:324: target->fighter->strn -= 2;
	ld	l, e
	ld	h, d
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	add	a, #0xfe
	ld	(hl), a
;src/entity.c:325: draw_player_strn();
	push	bc
	push	de
	call	_draw_player_strn
	pop	de
	pop	bc
00102$:
;src/entity.c:322: if (target->flags & E_STR_BONUS) {
	ld	a, (bc)
;src/entity.c:327: if (target->flags & E_REF_BONUS) {
	bit	6, a
	jr	Z,00104$
;src/entity.c:328: target->flags &= ~E_REF_BONUS;
	and	a, #0xbf
	ld	(bc), a
;src/entity.c:329: target->fighter->ref -= 2;
	ld	l, e
	ld	h, d
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	de
	ld	de, #0x0006
	add	hl, de
	pop	de
	ld	a, (hl)
	add	a, #0xfe
	ld	(hl), a
;src/entity.c:330: draw_player_ref();
	push	bc
	push	de
	call	_draw_player_ref
	pop	de
	pop	bc
00104$:
;src/entity.c:322: if (target->flags & E_STR_BONUS) {
	ld	a, (bc)
;src/entity.c:332: if (target->flags & E_DEX_BONUS) {
	bit	5, a
	jr	Z,00106$
;src/entity.c:333: target->flags &= ~E_DEX_BONUS;
	and	a, #0xdf
	ld	(bc), a
;src/entity.c:334: target->fighter->dex -= 2;
	ld	l, e
	ld	h, d
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	de
	ld	de, #0x0007
	add	hl, de
	pop	de
	ld	a, (hl)
	add	a, #0xfe
	ld	(hl), a
;src/entity.c:335: draw_player_dex();
	push	bc
	push	de
	call	_draw_player_dex
	pop	de
	pop	bc
00106$:
;src/entity.c:322: if (target->flags & E_STR_BONUS) {
	ld	a, (bc)
;src/entity.c:337: if (target->flags & E_DEF_BONUS) {
	bit	4, a
	jr	Z,00109$
;src/entity.c:338: target->flags &= ~E_DEF_BONUS;
	and	a, #0xef
	ld	(bc), a
;src/entity.c:339: target->fighter->def -= 2;
	ex	de,hl
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	hl, #0x0005
	add	hl, bc
	ld	c, (hl)
	dec	c
	dec	c
	ld	(hl), c
;src/entity.c:340: draw_player_def();
	call	_draw_player_def
00109$:
	pop	ix
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
