;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module game
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _rand_range
	.globl _draw_player_hungry
	.globl _draw_player_hp
	.globl _draw_game
	.globl _remove_bonus
	.globl _init_entities
	.globl _map_create
	.globl _init_stairs
	.globl _init_items
	.globl _init_fighters
	.globl _init_ai
	.globl _display_credits
	.globl _get_string
	.globl _log_msg_ext
	.globl _clr_map
	.globl _cpct_getScreenPtr
	.globl _cpct_drawStringM1_f
	.globl _cpct_memset_f64
	.globl _cpct_memset
	.globl _orutrix_placed
	.globl _orutrix_dlvl
	.globl _turns_to_hungry
	.globl _turns_bonus
	.globl _turns_poisoned
	.globl _transition_previous
	.globl _transition_next
	.globl _init_all
	.globl _start_game
	.globl _do_background_actions
	.globl __ask_player_name
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_turns_poisoned::
	.ds 1
_turns_bonus::
	.ds 1
_turns_to_hungry::
	.ds 1
_orutrix_dlvl::
	.ds 1
_orutrix_placed::
	.ds 1
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/game.c:48: void transition_previous()
;	---------------------------------
; Function transition_previous
; ---------------------------------
_transition_previous::
;src/game.c:51: }
	ret
;src/game.c:53: void transition_next()
;	---------------------------------
; Function transition_next
; ---------------------------------
_transition_next::
;src/game.c:58: log_msg_ext("\477\11\10Going down");
	ld	hl, #___str_0
	push	hl
	call	_log_msg_ext
	pop	af
;src/game.c:59: init_stairs();
	call	_init_stairs
;src/game.c:60: map_create (MAP_WIDTH, MAP_HEIGHT);
	ld	hl, #0x121c
	push	hl
	call	_map_create
	pop	af
;src/game.c:61: fov_changed = false;
	ld	hl,#_fov_changed + 0
	ld	(hl), #0x00
;src/game.c:62: stats_changed = true;
	ld	hl,#_stats_changed + 0
	ld	(hl), #0x01
;src/game.c:63: dungeon_lvl++;
	ld	hl, #_dungeon_lvl+0
	inc	(hl)
;src/game.c:66: clr_map();
	call	_clr_map
;src/game.c:67: draw_game(true);
	ld	a, #0x01
	push	af
	inc	sp
	call	_draw_game
	inc	sp
	ret
___str_0:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "Going down"
	.db 0x00
;src/game.c:70: void init_all()
;	---------------------------------
; Function init_all
; ---------------------------------
_init_all::
;src/game.c:72: extern u16 steps = 0;
	ld	hl, #0x0000
	ld	(_steps), hl
;src/game.c:73: extern u8 dungeon_lvl = 1;
	ld	hl,#_dungeon_lvl + 0
	ld	(hl), #0x01
;src/game.c:74: extern u8 hardest_mob_in_level = SNAKE;
	ld	hl,#_hardest_mob_in_level + 0
	ld	(hl), #0x03
;src/game.c:76: turns_poisoned  = 0;
	ld	hl,#_turns_poisoned + 0
	ld	(hl), #0x00
;src/game.c:77: turns_bonus     = 0;
	ld	hl,#_turns_bonus + 0
	ld	(hl), #0x00
;src/game.c:78: turns_to_hungry = HUNGRY_COUNTER;
	ld	hl,#_turns_to_hungry + 0
	ld	(hl), #0xff
;src/game.c:79: orutrix_found   = false;
	ld	hl,#_orutrix_found + 0
	ld	(hl), #0x00
;src/game.c:82: orutrix_dlvl = rand_range(ORUTRIX_MIN_DLVL, ORUTRIX_MAX_DLVL);
	ld	hl, #0x0e0a
	push	hl
	call	_rand_range
	pop	af
	ld	iy, #_orutrix_dlvl
	ld	0 (iy), l
;src/game.c:83: orutrix_placed = false;
	ld	hl,#_orutrix_placed + 0
	ld	(hl), #0x00
;src/game.c:86: cpct_memset (known_potions, 0, MAX_POTIONS);
	ld	hl, #0x0006
	push	hl
	xor	a, a
	push	af
	inc	sp
	ld	hl, #_known_potions
	push	hl
	call	_cpct_memset
;src/game.c:88: init_entities();
	call	_init_entities
;src/game.c:89: init_ai();
	call	_init_ai
;src/game.c:90: init_fighters();
	call	_init_fighters
;src/game.c:91: init_items();
	call	_init_items
;src/game.c:92: init_stairs();
	call	_init_stairs
	ret
;src/game.c:95: void start_game()
;	---------------------------------
; Function start_game
; ---------------------------------
_start_game::
;src/conio.h:28: cpct_clearScreen_f64 (0x0000);
	ld	hl, #0x4000
	push	hl
	ld	h, #0x00
	push	hl
	ld	h, #0xc0
	push	hl
	call	_cpct_memset_f64
;src/game.c:98: display_credits();
	call	_display_credits
;src/game.c:99: _ask_player_name(4, 20);
	ld	hl, #0x1404
	push	hl
	call	__ask_player_name
	pop	af
	ret
;src/game.c:102: void do_background_actions()
;	---------------------------------
; Function do_background_actions
; ---------------------------------
_do_background_actions::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/game.c:107: steps += 1;
	ld	iy, #_steps
	inc	0 (iy)
	jr	NZ,00178$
	inc	1 (iy)
00178$:
;src/game.c:110: turns_to_hungry--;
	ld	iy, #_turns_to_hungry
	dec	0 (iy)
;src/game.c:111: if (!turns_to_hungry) {
	ld	a, 0 (iy)
	or	a, a
	jr	NZ,00102$
;src/game.c:112: player->flags |= E_HUNGRY;
	ld	bc, (_player)
	inc	bc
	inc	bc
	inc	bc
	inc	bc
	inc	bc
	ld	a, (bc)
	set	7, a
	ld	(bc), a
;src/game.c:113: draw_player_hungry(false);
	xor	a, a
	push	af
	inc	sp
	call	_draw_player_hungry
	inc	sp
00102$:
;src/game.c:112: player->flags |= E_HUNGRY;
	ld	hl, (_player)
	ex	(sp), hl
;src/game.c:116: if (player->flags & E_HUNGRY) {
	pop	hl
	push	hl
	ld	de, #0x0005
	add	hl, de
	ld	h, (hl)
	add	hl, hl
	jr	NC,00104$
;src/game.c:117: player->fighter->hp = max (player->fighter->hp - 1, 0);
	ld	a, -2 (ix)
	add	a, #0x07
	ld	l, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	h, a
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	bc
	inc	bc
	inc	bc
	ld	a, (bc)
	ld	e, a
	dec	e
;src/aux_math.h:38: return a > b ? a : b;
	xor	a, a
	sub	a, e
	jr	C,00125$
	ld	e, #0x00
00125$:
;src/game.c:117: player->fighter->hp = max (player->fighter->hp - 1, 0);
	ld	a, e
	ld	(bc), a
;src/game.c:118: draw_player_hp();
	call	_draw_player_hp
00104$:
;src/game.c:122: if (!(steps&3) && !(player->flags & E_POISONED)
	ld	a,(#_steps + 0)
	and	a, #0x03
	jr	NZ,00106$
;src/game.c:112: player->flags |= E_HUNGRY;
	ld	iy, (_player)
	push	iy
	pop	hl
	ld	de, #0x0005
	add	hl, de
	ld	h, (hl)
;src/game.c:122: if (!(steps&3) && !(player->flags & E_POISONED)
	bit	2, h
	jr	NZ,00106$
;src/game.c:123: && !(player->flags & E_HUNGRY)) {
	add	hl, hl
	jr	C,00106$
;src/game.c:117: player->fighter->hp = max (player->fighter->hp - 1, 0);
	ld	l, 7 (iy)
	ld	h, 8 (iy)
	ld	c, l
	ld	b, h
	inc	bc
	inc	bc
	inc	bc
;src/game.c:125: player->fighter->max_hp);
	inc	hl
	inc	hl
	ld	e, (hl)
;src/game.c:124: player->fighter->hp = min (player->fighter->hp + 1,
	ld	a, (bc)
	inc	a
;src/aux_math.h:34: return a < b ? a : b;
	cp	a, e
	jr	C,00127$
	ld	a, e
00127$:
;src/game.c:125: player->fighter->max_hp);
	ld	(bc), a
;src/game.c:126: draw_player_hp();
	call	_draw_player_hp
00106$:
;src/game.c:112: player->flags |= E_HUNGRY;
	ld	hl, (_player)
	ex	(sp), hl
	ld	a, -2 (ix)
	add	a, #0x05
	ld	c, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	b, a
	ld	a, (bc)
	ld	e, a
;src/game.c:130: if (player->flags & E_POISONED) {
	bit	2, e
	jr	Z,00113$
;src/game.c:131: if (turns_poisoned != POISON_DURATION) {
	ld	a,(#_turns_poisoned + 0)
	sub	a, #0x0c
	jr	Z,00110$
;src/game.c:117: player->fighter->hp = max (player->fighter->hp - 1, 0);
	ld	a, -2 (ix)
	add	a, #0x07
	ld	l, a
	ld	a, -1 (ix)
	adc	a, #0x00
	ld	h, a
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	inc	bc
	inc	bc
	inc	bc
;src/game.c:132: player->fighter->hp = max (player->fighter->hp - 1, 0);
	ld	a, (bc)
	ld	e, a
	dec	e
;src/aux_math.h:38: return a > b ? a : b;
	xor	a, a
	sub	a, e
	jr	C,00129$
	ld	e, #0x00
00129$:
;src/game.c:132: player->fighter->hp = max (player->fighter->hp - 1, 0);
	ld	a, e
	ld	(bc), a
;src/game.c:133: turns_poisoned++;
	ld	hl, #_turns_poisoned+0
	inc	(hl)
;src/game.c:134: draw_player_hp();
	call	_draw_player_hp
	jr	00113$
00110$:
;src/game.c:137: player->flags &= ~E_POISONED;
	res	2, e
	ld	a, e
	ld	(bc), a
;src/game.c:138: turns_poisoned = 0;
	ld	hl,#_turns_poisoned + 0
	ld	(hl), #0x00
;src/game.c:139: log_msg_ext ("\477\11\10You no longer feel poisoned");
	ld	hl, #___str_1
	push	hl
	call	_log_msg_ext
	pop	af
00113$:
;src/game.c:144: if (player->flags & E_STATS_IMPR) {
	ld	iy, (_player)
	ld	a, 5 (iy)
	and	a, #0x78
	jr	Z,00122$
;src/game.c:145: if (turns_bonus != BONUS_DURATION) {
	ld	iy, #_turns_bonus
	ld	a, 0 (iy)
	sub	a, #0x0c
	jr	Z,00115$
;src/game.c:146: turns_bonus++;
	inc	0 (iy)
	jr	00122$
00115$:
;src/game.c:149: remove_bonus (player);
	ld	hl, (_player)
	push	hl
	call	_remove_bonus
	pop	af
;src/game.c:150: turns_bonus = 0;
	ld	hl,#_turns_bonus + 0
	ld	(hl), #0x00
00122$:
	ld	sp, ix
	pop	ix
	ret
___str_1:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "You no longer feel poisoned"
	.db 0x00
;src/game.c:159: void _ask_player_name(u8 x, u8 y)
;	---------------------------------
; Function _ask_player_name
; ---------------------------------
__ask_player_name::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/game.c:162: char **pname = &(entity_info[PLAYER].name);
;src/game.c:163: *pname = player_name;
	ld	hl, #_player_name
	ld	((_entity_info + 0x0001)), hl
;src/game.c:166: cpct_getScreenPtr (CPCT_VMEM_START, x*2, y*8),
	ld	a, 5 (ix)
	rlca
	rlca
	rlca
	and	a, #0xf8
	ld	d, a
	ld	a, 4 (ix)
	add	a, a
	ld	e,a
	push	de
	ld	hl, #0xc000
	push	hl
	call	_cpct_getScreenPtr
;src/game.c:165: cpct_drawStringM1_f ("Hero's name: ",
	ld	bc, #___str_2+0
	ld	de, #0x0003
	push	de
	push	hl
	push	bc
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/game.c:169: get_string(player_name, x+14,y, 2,0);
	ld	a, 4 (ix)
	add	a, #0x0e
	ld	b, a
	ld	hl, #0x0002
	push	hl
	ld	a, 5 (ix)
	push	af
	inc	sp
	push	bc
	inc	sp
	ld	hl, #_player_name
	push	hl
	call	_get_string
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	pop	ix
	ret
___str_2:
	.ascii "Hero's name: "
	.db 0x00
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
