;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module main
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _main
	.globl _game_init
	.globl _game_loop
	.globl _happy_ending
	.globl _display_permadeath
	.globl _gen_player
	.globl _map_create
	.globl _name
	.globl _entity_move
	.globl _draw_game
	.globl _handle_keys
	.globl _do_background_actions
	.globl _start_game
	.globl _init_all
	.globl _press_any_key_cont
	.globl _log_msg_ext
	.globl _clr_map
	.globl _clr_log
	.globl _sprintf
	.globl _cpct_setPalette
	.globl _cpct_disableFirmware
	.globl _msg
	.globl _known_potions
	.globl _hardest_mob_in_level
	.globl _dungeon_lvl
	.globl _steps
	.globl _global_seed
	.globl _orutrix_found
	.globl _game_running
	.globl _inv_player
	.globl _player
	.globl _stats_changed
	.globl _fov_changed
	.globl _game_palette
	.globl _player_name
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_fov_changed::
	.ds 1
_stats_changed::
	.ds 1
_player::
	.ds 2
_inv_player::
	.ds 38
_game_running::
	.ds 1
_orutrix_found::
	.ds 1
_global_seed::
	.ds 4
_steps::
	.ds 2
_dungeon_lvl::
	.ds 1
_hardest_mob_in_level::
	.ds 1
_known_potions::
	.ds 6
_msg::
	.ds 38
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/main.c:59: void game_loop() {
;	---------------------------------
; Function game_loop
; ---------------------------------
_game_loop::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/main.c:66: game_running = true;
	ld	hl,#_game_running + 0
	ld	(hl), #0x01
;src/main.c:67: while (game_running) {
00116$:
	ld	hl,#_game_running+0
	bit	0, (hl)
	jp	Z, 00118$
;src/main.c:70: dx = dy = 0;
	ld	-2 (ix), #0x00
	ld	-1 (ix), #0x00
;src/main.c:71: fov_changed = false;
	ld	hl,#_fov_changed + 0
	ld	(hl), #0x00
;src/main.c:72: player_action = handle_keys(&dx, &dy);
	ld	hl, #0x0000
	add	hl, sp
	ld	c, l
	ld	b, h
	ld	hl, #0x0001
	add	hl, sp
	push	bc
	push	hl
	call	_handle_keys
	pop	af
	pop	af
	ld	c, l
;src/main.c:74: if (player_action != NONE) clr_log();
	ld	a, c
	or	a, a
	jr	Z,00102$
	push	bc
	call	_clr_log
	pop	bc
00102$:
;src/main.c:75: if (player_action == PLAYER_MOVE) {
	ld	a, c
	dec	a
	jr	NZ,00106$
;src/main.c:78: if (!entity_move (player, dx, dy)) {
	push	bc
	ld	h, -2 (ix)
	ld	l, -1 (ix)
	push	hl
	ld	hl, (_player)
	push	hl
	call	_entity_move
	pop	af
	pop	af
	pop	bc
	bit	0, l
	jr	NZ,00106$
;src/main.c:79: player_action = NONE;
	ld	c, #0x00
;src/main.c:80: fov_changed = false;
	ld	hl,#_fov_changed + 0
	ld	(hl), #0x00
00106$:
;src/main.c:87: if (player_action != NONE) {
	ld	a, c
	or	a, a
	jr	Z,00115$
;src/main.c:88: pentity = last_entity_in_level;//entities + num_entities;
	ld	bc, (_last_entity_in_level)
;src/main.c:89: while(pentity-- != entities_in_level) {
00109$:
	ld	e, c
	ld	d, b
	dec	bc
	dec	bc
	ld	a, e
	sub	a, #<(_entities_in_level)
	jr	NZ,00171$
	ld	a, d
	sub	a, #>(_entities_in_level)
	jr	Z,00111$
00171$:
;src/main.c:90: if ((*pentity)->ai) {
	ld	l, c
	ld	h, b
	ld	e, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, e
	ld	de, #0x0009
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, d
	or	a,e
	jr	Z,00109$
;src/main.c:91: ai = (*pentity)->ai;
;src/main.c:92: ai->take_turn(ai);
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	push	bc
	push	de
	call	___sdcc_call_hl
	pop	af
	pop	bc
	jr	00109$
00111$:
;src/main.c:98: do_background_actions();
	call	_do_background_actions
;src/main.c:101: if (player->fighter->hp <= 0) {
	ld	iy, (_player)
	ld	l, 7 (iy)
	ld	h, 8 (iy)
	inc	hl
	inc	hl
	inc	hl
	ld	c, (hl)
	xor	a, a
	sub	a, c
	jp	PO, 00172$
	xor	a, #0x80
00172$:
	jp	M, 00115$
;src/main.c:102: game_running = false;
	ld	hl,#_game_running + 0
	ld	(hl), #0x00
00115$:
;src/main.c:107: draw_game(fov_changed);
	ld	a, (_fov_changed)
	push	af
	inc	sp
	call	_draw_game
	inc	sp
	jp	00116$
00118$:
;src/main.c:110: if (orutrix_found)
	ld	hl,#_orutrix_found+0
	bit	0, (hl)
	jr	Z,00120$
;src/main.c:111: happy_ending();
	call	_happy_ending
	jr	00121$
00120$:
;src/main.c:113: display_permadeath();
	call	_display_permadeath
00121$:
;src/main.c:115: press_any_key_cont();
	call	_press_any_key_cont
	ld	sp, ix
	pop	ix
	ret
_player_name:
	.ascii "Thorbag"
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
	.db 0x00
_game_palette:
	.db #0x14	; 20
	.db #0x03	; 3
	.db #0x1c	; 28
	.db #0x06	; 6
;src/main.c:120: void game_init() {
;	---------------------------------
; Function game_init
; ---------------------------------
_game_init::
;src/main.c:125: cpct_disableFirmware();
	call	_cpct_disableFirmware
;src/main.c:127: init_all();
	call	_init_all
;src/main.c:129: player = gen_player();
	call	_gen_player
	ld	(_player), hl
;src/main.c:130: map_create (MAP_WIDTH, MAP_HEIGHT);
	ld	hl, #0x121c
	push	hl
	call	_map_create
	pop	af
;src/main.c:132: fov_changed = false;
	ld	hl,#_fov_changed + 0
	ld	(hl), #0x00
;src/main.c:133: stats_changed = true;
	ld	hl,#_stats_changed + 0
	ld	(hl), #0x01
;src/main.c:136: cpct_setPalette (game_palette, 4);
	ld	hl, #0x0004
	push	hl
	ld	hl, #_game_palette
	push	hl
	call	_cpct_setPalette
;src/main.c:137: clr_map();
	call	_clr_map
;src/main.c:138: draw_game(true);
	ld	a, #0x01
	push	af
	inc	sp
	call	_draw_game
	inc	sp
;src/main.c:139: sprintf(msg,"\477\11\12Welcome to your doom %s!", name(player));
	ld	hl, (_player)
	push	hl
	call	_name
	ex	(sp),hl
	ld	hl, #___str_1
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/main.c:140: log_msg_ext (msg);
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
	ret
___str_1:
	.ascii "?"
	.db 0x09
	.db 0x0a
	.ascii "Welcome to your doom %s!"
	.db 0x00
;src/main.c:150: void main(void) {
;	---------------------------------
; Function main
; ---------------------------------
_main::
;src/main.c:152: while (1) {
00102$:
;src/main.c:153: start_game();
	call	_start_game
;src/main.c:154: game_init();
	call	_game_init
;src/main.c:155: game_loop();
	call	_game_loop
	jr	00102$
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
