;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module permadeath
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _name
	.globl _get_center
	.globl _display_text_lines
	.globl _cpct_getScreenPtr
	.globl _cpct_setPalette
	.globl _cpct_drawStringM1_f
	.globl _cpct_memset_f64
	.globl _permadeath
	.globl _perma_palette
	.globl _display_permadeath
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/permadeath.c:66: void display_permadeath()
;	---------------------------------
; Function display_permadeath
; ---------------------------------
_display_permadeath::
;src/permadeath.c:69: u8 x = get_center (GRAVE_TEXT_STARTX, GRAVE_WIDTH, name(player));
	ld	hl, (_player)
	push	hl
	call	_name
	ex	(sp),hl
	ld	hl, #0x1016
	push	hl
	call	_get_center
	pop	af
	pop	af
	ld	b, l
;src/permadeath.c:71: cpct_setPalette (perma_palette, 4);
	push	bc
	ld	hl, #0x0004
	push	hl
	ld	hl, #_perma_palette
	push	hl
	call	_cpct_setPalette
	ld	hl, #0x4000
	push	hl
	ld	h, #0x00
	push	hl
	ld	h, #0xc0
	push	hl
	call	_cpct_memset_f64
	ld	a, #0x2b
	push	af
	inc	sp
	ld	hl, #_permadeath
	push	hl
	call	_display_text_lines
	pop	af
	inc	sp
	pop	bc
;src/permadeath.c:77: cpct_getScreenPtr (CPCT_VMEM_START, x,HERO_TEXT_Y), 0,2);
	ld	a, #0x68
	push	af
	inc	sp
	push	bc
	inc	sp
	ld	hl, #0xc000
	push	hl
	call	_cpct_getScreenPtr
;src/permadeath.c:76: cpct_drawStringM1_f (name(player),
	push	hl
	ld	hl, (_player)
	push	hl
	call	_name
	pop	af
	pop	bc
	ld	de, #0x0200
	push	de
	push	bc
	push	hl
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
;src/permadeath.c:79: x = get_center (GRAVE_TEXT_STARTX, GRAVE_WIDTH, "snake");
	ld	hl, #___str_0
	push	hl
	ld	hl, #0x1016
	push	hl
	call	_get_center
	pop	af
	pop	af
	ld	b, l
;src/permadeath.c:81: cpct_getScreenPtr (CPCT_VMEM_START, x,KILLEDBY_TEXT_Y), 0,2);
	ld	a, #0x78
	push	af
	inc	sp
	push	bc
	inc	sp
	ld	hl, #0xc000
	push	hl
	call	_cpct_getScreenPtr
;src/permadeath.c:80: cpct_drawStringM1_f ("snake",
	ld	bc, #0x0200
	push	bc
	push	hl
	ld	hl, #___str_0
	push	hl
	call	_cpct_drawStringM1_f
	ld	hl, #6
	add	hl, sp
	ld	sp, hl
	ret
_perma_palette:
	.db #0x54	; 84	'T'
	.db #0x56	; 86	'V'
	.db #0x40	; 64
	.db #0x5c	; 92
_permadeath:
	.dw __str_1
	.db #0x0f	; 15
	.db #0x02	; 2
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_2
	.db #0x0f	; 15
	.db #0x03	; 3
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_3
	.db #0x0f	; 15
	.db #0x04	; 4
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_4
	.db #0x0f	; 15
	.db #0x05	; 5
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_5
	.db #0x0e	; 14
	.db #0x06	; 6
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_6
	.db #0x0a	; 10
	.db #0x07	; 7
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x08	; 8
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_8
	.db #0x0b	; 11
	.db #0x08	; 8
	.db #0x00	; 0
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x08	; 8
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x09	; 9
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_9
	.db #0x0b	; 11
	.db #0x09	; 9
	.db #0x00	; 0
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x09	; 9
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x0a	; 10
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_10
	.db #0x0b	; 11
	.db #0x0a	; 10
	.db #0x00	; 0
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x0a	; 10
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x0b	; 11
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_11
	.db #0x0b	; 11
	.db #0x0b	; 11
	.db #0x00	; 0
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x0b	; 11
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x0c	; 12
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_8
	.db #0x0b	; 11
	.db #0x0c	; 12
	.db #0x00	; 0
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x0c	; 12
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x0d	; 13
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_8
	.db #0x0b	; 11
	.db #0x0d	; 13
	.db #0x00	; 0
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x0d	; 13
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x0e	; 14
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_12
	.db #0x0b	; 11
	.db #0x0e	; 14
	.db #0x00	; 0
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x0e	; 14
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x0f	; 15
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_8
	.db #0x0b	; 11
	.db #0x0f	; 15
	.db #0x00	; 0
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x0f	; 15
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x10	; 16
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_8
	.db #0x0b	; 11
	.db #0x10	; 16
	.db #0x00	; 0
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x10	; 16
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x11	; 17
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_13
	.db #0x0b	; 11
	.db #0x11	; 17
	.db #0x03	; 3
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x11	; 17
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x12	; 18
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_8
	.db #0x0b	; 11
	.db #0x12	; 18
	.db #0x00	; 0
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x12	; 18
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_7
	.db #0x0a	; 10
	.db #0x13	; 19
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_8
	.db #0x0b	; 11
	.db #0x13	; 19
	.db #0x00	; 0
	.db #0x02	; 2
	.dw __str_7
	.db #0x1b	; 27
	.db #0x13	; 19
	.db #0x02	; 2
	.db #0x00	; 0
	.dw __str_14
	.db #0x06	; 6
	.db #0x14	; 20
	.db #0x01	; 1
	.db #0x00	; 0
___str_0:
	.ascii "snake"
	.db 0x00
__str_1:
	.db 0xd6
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0xd7
	.db 0x00
__str_2:
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x81
	.db 0x82
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x00
__str_3:
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x84
	.db 0x88
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x00
__str_4:
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x85
	.db 0x8a
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x00
__str_5:
	.db 0xd6
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0x8f
	.db 0xd7
	.db 0x00
__str_6:
	.db 0xc2
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0x9a
	.db 0xc3
	.db 0x00
__str_7:
	.db 0x95
	.db 0x00
__str_8:
	.ascii "                "
	.db 0x00
__str_9:
	.ascii "      REST      "
	.db 0x00
__str_10:
	.ascii "       IN       "
	.db 0x00
__str_11:
	.ascii "     PEACE      "
	.db 0x00
__str_12:
	.ascii "   killed by a  "
	.db 0x00
__str_13:
	.ascii "   "
	.db 0xe2
	.ascii "   "
	.db 0xe2
	.ascii "    "
	.db 0xe2
	.ascii "   "
	.db 0x00
__str_14:
	.db 0xd2
	.db 0xd2
	.db 0xc6
	.db 0x5c
	.db 0x5c
	.ascii "/)"
	.db 0xc6
	.db 0x5c
	.db 0x5c
	.ascii "/"
	.db 0xc6
	.ascii "("
	.db 0x5c
	.ascii "/)"
	.db 0xc6
	.ascii "(/"
	.db 0xc6
	.db 0x5c
	.db 0xc6
	.ascii ")/"
	.db 0xc6
	.db 0xd2
	.db 0xd2
	.db 0x00
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
