;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (Linux)
;--------------------------------------------------------
	.module potions
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _draw_player_hungry
	.globl _draw_player_dex
	.globl _draw_player_ref
	.globl _draw_player_def
	.globl _draw_player_strn
	.globl _draw_player_hp
	.globl _remove_bonus
	.globl _name
	.globl _log_msg_ext
	.globl _rand_range
	.globl _sprintf
	.globl _set_known
	.globl _cast_heal
	.globl _cast_poison
	.globl _cast_bonus
	.globl _remove_hungry
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/potions.c:30: void set_known (u8 potion_id, bool status)
;	---------------------------------
; Function set_known
; ---------------------------------
_set_known::
	push	ix
	ld	ix,#0
	add	ix,sp
;src/potions.c:32: known_potions[potion_id-HEAL_POTION] = status;
	ld	bc, #_known_potions+0
	ld	a, 4 (ix)
	ld	d, #0x00
	add	a, #0xfa
	ld	l, a
	ld	a, d
	adc	a, #0xff
	ld	h, a
	add	hl, bc
	ld	c, 5 (ix)
	ld	(hl), c
	pop	ix
	ret
;src/potions.c:36: void cast_heal(struct TEntity *target, u8 value)
;	---------------------------------
; Function cast_heal
; ---------------------------------
_cast_heal::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
	dec	sp
;src/potions.c:40: u8 heal_value = rand_range (2, value);
	ld	d, 6 (ix)
	ld	e,#0x02
	push	de
	call	_rand_range
	pop	af
	ld	e, l
;src/potions.c:42: target->fighter->hp = min (target->fighter->hp + heal_value,
	ld	a, 4 (ix)
	ld	-2 (ix), a
	ld	a, 5 (ix)
	ld	-1 (ix), a
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	bc, #0x0007
	add	hl, bc
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	ld	c, l
	ld	b, h
	inc	bc
	inc	bc
	inc	bc
;src/potions.c:43: target->fighter->max_hp);
	inc	hl
	inc	hl
	ld	d, (hl)
;src/potions.c:42: target->fighter->hp = min (target->fighter->hp + heal_value,
	ld	a, (bc)
	ld	l, a
	ld	-3 (ix), e
	ld	a, l
	add	a, -3 (ix)
;src/aux_math.h:34: return a < b ? a : b;
	cp	a, d
	jr	C,00107$
	ld	a, d
00107$:
;src/potions.c:43: target->fighter->max_hp);
	ld	(bc), a
;src/potions.c:46: name (target), heal_value);
	ld	d, #0x00
	push	de
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	push	hl
	call	_name
	ex	(sp),hl
	ld	hl, #___str_0
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;src/potions.c:47: log_msg_ext (msg);
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
;src/potions.c:49: if (target == player)
	ld	a, 4 (ix)
	ld	iy, #_player
	sub	a, 0 (iy)
	jr	NZ,00102$
	ld	a, 5 (ix)
	sub	a, 1 (iy)
	jr	NZ,00102$
;src/potions.c:50: draw_player_hp();
	call	_draw_player_hp
00102$:
;src/potions.c:52: set_known (HEAL_POTION, true);
	ld	hl, #0x0106
	push	hl
	call	_set_known
	ld	sp,ix
	pop	ix
	ret
___str_0:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "%s healed for ?"
	.db 0x0a
	.db 0x08
	.ascii "%d ?"
	.db 0x09
	.db 0x08
	.ascii "hp"
	.db 0x00
;src/potions.c:56: void cast_poison (struct TEntity *target, u8 value)
;	---------------------------------
; Function cast_poison
; ---------------------------------
_cast_poison::
	push	ix
	ld	ix,#0
	add	ix,sp
	dec	sp
;src/potions.c:60: u8 poison_value = rand_range (2, value);
	ld	d, 6 (ix)
	ld	e,#0x02
	push	de
	call	_rand_range
	pop	af
	ld	c, l
;src/potions.c:62: target->fighter->hp = max (target->fighter->hp - poison_value, 0);
	ld	e,4 (ix)
	ld	d,5 (ix)
	push	de
	pop	iy
	ld	l, 7 (iy)
	ld	h, 8 (iy)
	inc	hl
	inc	hl
	inc	hl
	ld	b, (hl)
	ld	-1 (ix), c
	ld	a, b
	sub	a, -1 (ix)
	ld	b, a
;src/aux_math.h:38: return a > b ? a : b;
	xor	a, a
	sub	a, b
	jr	C,00107$
	ld	b, #0x00
00107$:
;src/potions.c:62: target->fighter->hp = max (target->fighter->hp - poison_value, 0);
	ld	(hl), b
;src/potions.c:63: target->flags |= E_POISONED;
	ld	hl, #0x0005
	add	hl, de
	set	2, (hl)
	ld	a, (hl)
;src/potions.c:65: sprintf (msg, "\477\11\10%s is poisoned and lost \477\12\10%d \477\11\10hp", name (target), poison_value);
	ld	b, #0x00
	push	bc
	push	de
	call	_name
	ex	(sp),hl
	ld	hl, #___str_1
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	ld	hl, #8
	add	hl, sp
	ld	sp, hl
;src/potions.c:66: log_msg_ext (msg);
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
;src/potions.c:68: if (target == player)
	ld	a, 4 (ix)
	ld	iy, #_player
	sub	a, 0 (iy)
	jr	NZ,00102$
	ld	a, 5 (ix)
	sub	a, 1 (iy)
	jr	NZ,00102$
;src/potions.c:69: draw_player_hp();
	call	_draw_player_hp
00102$:
;src/potions.c:71: set_known (POISON_POTION, true);
	ld	hl, #0x0107
	push	hl
	call	_set_known
	pop	af
	inc	sp
	pop	ix
	ret
___str_1:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "%s is poisoned and lost ?"
	.db 0x0a
	.db 0x08
	.ascii "%d ?"
	.db 0x09
	.db 0x08
	.ascii "hp"
	.db 0x00
;src/potions.c:75: void cast_bonus (struct TEntity *target, u8 value)
;	---------------------------------
; Function cast_bonus
; ---------------------------------
_cast_bonus::
	push	ix
	ld	ix,#0
	add	ix,sp
	push	af
;src/potions.c:83: if (target->flags & E_STATS_IMPR)
	ld	e,4 (ix)
	ld	d,5 (ix)
	ld	hl, #0x0005
	add	hl,de
	ld	c, l
	ld	b, h
	ld	a, (bc)
	and	a, #0x78
	jr	Z,00102$
;src/potions.c:84: remove_bonus(target);
	push	bc
	push	de
	push	de
	call	_remove_bonus
	pop	af
	pop	de
	pop	bc
00102$:
;src/potions.c:88: target->fighter->strn+=2;
	ld	hl, #0x0007
	add	hl,de
	ex	de,hl
;src/potions.c:86: switch (value) {
	ld	a, 6 (ix)
	or	a, a
	jr	Z,00103$
	ld	a, 6 (ix)
	dec	a
	jr	Z,00104$
	ld	a, 6 (ix)
	sub	a, #0x02
	jr	Z,00105$
	ld	a, 6 (ix)
	sub	a, #0x03
	jp	Z,00106$
	jp	00107$
;src/potions.c:87: case 0:   // STR_POTION
00103$:
;src/potions.c:88: target->fighter->strn+=2;
	ex	de,hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	inc	de
	inc	de
	inc	de
	inc	de
	ld	a, (de)
	add	a, #0x02
	ld	(de), a
;src/potions.c:89: target->flags |= E_STR_BONUS;
	ld	a, (bc)
	set	3, a
	ld	(bc), a
;src/potions.c:90: sprintf (msg, "\477\11\10You feel stronger");
	ld	hl, #___str_2
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	pop	af
;src/potions.c:91: set_known (STR_POTION, true);
	ld	hl, #0x0108
	ex	(sp),hl
	call	_set_known
	pop	af
;src/potions.c:92: draw_stat = draw_player_strn;
	ld	-2 (ix), #<(_draw_player_strn)
	ld	-1 (ix), #>(_draw_player_strn)
;src/potions.c:93: break;
	jp	00107$
;src/potions.c:95: case 1:  // DEF_POTION
00104$:
;src/potions.c:96: target->fighter->def+=2;
	ex	de,hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	hl, #0x0005
	add	hl, de
	ld	e, (hl)
	inc	e
	inc	e
	ld	(hl), e
;src/potions.c:97: target->flags |= E_DEF_BONUS;
	ld	a, (bc)
	set	4, a
	ld	(bc), a
;src/potions.c:98: sprintf (msg, "\477\11\10Your defense is improved");
	ld	hl, #___str_3
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	pop	af
;src/potions.c:99: set_known (DEF_POTION, true);
	ld	hl, #0x0109
	ex	(sp),hl
	call	_set_known
	pop	af
;src/potions.c:100: draw_stat = draw_player_def;
	ld	-2 (ix), #<(_draw_player_def)
	ld	-1 (ix), #>(_draw_player_def)
;src/potions.c:101: break;
	jr	00107$
;src/potions.c:103: case 2: // DEX_POTION
00105$:
;src/potions.c:104: target->fighter->dex+=2;
	ex	de,hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	hl, #0x0007
	add	hl, de
	ld	e, (hl)
	inc	e
	inc	e
	ld	(hl), e
;src/potions.c:105: target->flags |= E_DEX_BONUS;
	ld	a, (bc)
	set	5, a
	ld	(bc), a
;src/potions.c:106: sprintf (msg, "\477\11\10You feel nimble as a cat");
	ld	hl, #___str_4
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	pop	af
;src/potions.c:107: set_known (DEX_POTION, true);
	ld	hl, #0x010a
	ex	(sp),hl
	call	_set_known
	pop	af
;src/potions.c:108: draw_stat = draw_player_dex;
	ld	-2 (ix), #<(_draw_player_dex)
	ld	-1 (ix), #>(_draw_player_dex)
;src/potions.c:109: break;
	jr	00107$
;src/potions.c:111: case 3: // REF_POTION
00106$:
;src/potions.c:112: target->fighter->ref+=2;
	ex	de,hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	hl, #0x0006
	add	hl, de
	ld	e, (hl)
	inc	e
	inc	e
	ld	(hl), e
;src/potions.c:113: target->flags |= E_REF_BONUS;
	ld	a, (bc)
	set	6, a
	ld	(bc), a
;src/potions.c:114: sprintf (msg, "\477\11\10Your reflexes are improved\477\12\10");
	ld	hl, #___str_5
	push	hl
	ld	hl, #_msg
	push	hl
	call	_sprintf
	pop	af
;src/potions.c:115: set_known (REF_POTION, true);
	ld	hl, #0x010b
	ex	(sp),hl
	call	_set_known
	pop	af
;src/potions.c:116: draw_stat = draw_player_ref;
	ld	-2 (ix), #<(_draw_player_ref)
	ld	-1 (ix), #>(_draw_player_ref)
;src/potions.c:118: }
00107$:
;src/potions.c:120: log_msg_ext (msg);
	ld	hl, #_msg
	push	hl
	call	_log_msg_ext
	pop	af
;src/potions.c:122: if (target == player)
	ld	a, 4 (ix)
	ld	iy, #_player
	sub	a, 0 (iy)
	jr	NZ,00110$
	ld	a, 5 (ix)
	sub	a, 1 (iy)
	jr	NZ,00110$
;src/potions.c:123: draw_stat();
	pop	hl
	push	hl
	call	___sdcc_call_hl
00110$:
	ld	sp, ix
	pop	ix
	ret
___str_2:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "You feel stronger"
	.db 0x00
___str_3:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "Your defense is improved"
	.db 0x00
___str_4:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "You feel nimble as a cat"
	.db 0x00
___str_5:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "Your reflexes are improved?"
	.db 0x0a
	.db 0x08
	.db 0x00
;src/potions.c:127: void remove_hungry (struct TEntity *target, u8 value)
;	---------------------------------
; Function remove_hungry
; ---------------------------------
_remove_hungry::
;src/potions.c:132: target->flags &= ~E_HUNGRY;
	pop	de
	pop	bc
	push	bc
	push	de
	ld	hl, #0x0005
	add	hl, bc
	ld	c, (hl)
	res	7, c
	ld	(hl), c
;src/potions.c:133: turns_to_hungry = HUNGRY_COUNTER;
	ld	hl,#_turns_to_hungry + 0
	ld	(hl), #0xff
;src/potions.c:134: log_msg_ext ("\477\11\10You no longer feel hungry");
	ld	hl, #___str_6
	push	hl
	call	_log_msg_ext
;src/potions.c:135: draw_player_hungry (true);
	ld	h,#0x01
	ex	(sp),hl
	inc	sp
	call	_draw_player_hungry
	inc	sp
	ret
___str_6:
	.ascii "?"
	.db 0x09
	.db 0x08
	.ascii "You no longer feel hungry"
	.db 0x00
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
