#!/usr/bin/python
import math

HIT_MAGICK_NUMBER = math.exp(1)/2
BASE = 50
BON_ATKDEF_MAGICK = 0.75


def gen_hit_prob():
  hit_prob_values = [int (256*(HIT_MAGICK_NUMBER*idx+50)//100)
    for idx in range (0, 31)]
  out_code = ""
  out_code += "///< % Hit\n"
  out_code += "const u8 hit_probability[] = {\n"
  out_code += str (hit_prob_values).strip('[]')
  out_code += "\n};"

  print(out_code);

def gen_hit_bon_atkdef():
  bon_atkdef_values = [int ((idx-10)*BON_ATKDEF_MAGICK)
    for idx in range (0, 31)]
  out_code = ""
  out_code += "///< Atack/Defense Bonus\n"
  out_code += "const i8 bon_atkdef[] = {\n"
  out_code += str (bon_atkdef_values).strip('[]')
  out_code += "\n};"

  print (out_code);

def main():
  gen_hit_prob()
  print ("");
  gen_hit_bon_atkdef()

if __name__ == "__main__":
  main()